GNU bug report logs - #54399
27.2; Problems with (let ((custom-variable ...)) (autoload-function ...))

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Ignacio Casso <ignaciocasso@HIDDEN>; Keywords: moreinfo; dated Tue, 15 Mar 2022 15:53:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 11:49:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 07:49:47 2022
Received: from localhost ([127.0.0.1]:39851 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np7KE-000721-Ny
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 07:49:46 -0400
Received: from quimby.gnus.org ([95.216.78.240]:52320)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1np7KD-00071g-Ad
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 07:49:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=WwKkbYxubiqtuo+nnbAbF/T8WzAS5PXhOtko4t/f4KI=; b=d/RzF7Tu1c3iFUpV8IrpQGeCZS
 lmQ4GxRtjTgi+TSi4UdyNQpzV/1McfP1qrUpNddoKeQ/AWch+jQF/5c68cXYAVdg17ksdwxz1C7JS
 sER8cPlz4c28XCMAgylSqI2sRJsWLazk8WxQodyVRV+0mAswTzLS+jjUYETBdubHeC+Y=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1np7K3-0004CV-A2; Thu, 12 May 2022 13:49:37 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 <83r14zp5jz.fsf@HIDDEN>
 <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
 <83o803p2p3.fsf@HIDDEN>
 <DB6PR0601MB2087CD5C08847EA630D2D71BC6CB9@HIDDEN>
 <83lev7ozqq.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAALVBMVEUSLHNbaZIsQ4Gt
 rK38/PwKH1sSGjPi4N7S0NF6haSPkZsFBQhaXGN/fn7////lmZ5TAAAAAWJLR0QOb70wTwAAAAd0
 SU1FB+YFDAskF/CR6XcAAAGXSURBVDjLldI/S8NAFADwqCTYdlIc/RYNtHTtwQtOmbq4ZBKxHR9c
 9h7kcCv4DSy4OGRpB89dEJxc+2F875K0uUtFzHAJ98v7c3+CgJ9LO57Y8UzYh75CF672EDlwiqBy
 raqIsIIeD+diuh4OXxhu0zbEYjp+rmDehr4QSaGrVCYjiDKapLRPQoBEQIKQ4CIYbCz0qJ+boV7G
 BJEpCWZ3FtYWJpN1A6kxadBP7eKSsV4qCxuKYHgoldg/FayCrcmitw/hQhmuQkNwLzrwSjXuFqoD
 0XVpzDYWHRjsSn+eYGaM2Zl3Ow+SBiktZHOGT7S/Ic3SNEuwoexfdVnAOg+9g+3i+9BNI0CATkk4
 FHd7seltLh8E/gZwDDQ2IS4ko6LpzAUYjTkGuqBjULBE9NsFpQCKRwUIHvAqcv5wAGQutS5y2kap
 2sBrxkRLruADYL5EfjuQoD0kjkicrgAktrK2AJtNBxdEgc3WogvSLowT+cAr5MsA3pbA4ZQ6R2u3
 HI4AX7b6pvhHC3l9HTpnXtc5AurfEeIP+AEmWEK/GuRi0wAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAy
 Mi0wNS0xMlQxMTozNjoyMyswMDowMLvo/70AAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjItMDUtMTJU
 MTE6MzY6MjMrMDA6MDDKtUcBAAAAAElFTkSuQmCC
X-Now-Playing: Joe Jackson's _Night & Day_: "Real Men"
Date: Thu, 12 May 2022 13:49:34 +0200
In-Reply-To: <83lev7ozqq.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 12 May
 2022 12:40:29 +0300")
Message-ID: <87zgjnynqp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > If those changes are
 fine with Stefan and Lars, I don't mind. They make sense to me, but perhaps
 Stefan has some comments... 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Ignacio Casso <ignaciocasso@HIDDEN>,
 54399 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> If those changes are fine with Stefan and Lars, I don't mind.

They make sense to me, but perhaps Stefan has some comments...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 09:40:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 05:40:39 2022
Received: from localhost ([127.0.0.1]:39703 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np5JH-00009Z-5J
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 05:40:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47602)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1np5JF-00009K-Kv
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 05:40:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60300)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np5J8-0000Hk-7Y; Thu, 12 May 2022 05:40:31 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=kmrUO3AJB3mXHEnKsv1b6mZmT7Auvx1GSvmF/fIVybQ=; b=EH9G0wiO6SO8
 KdtrMbLVV7EumEZlNjIlLa92Uq7JpqQzskB/OW9ac4tJb/FuLoy++TM84wz52Y59gHwHVVOmeMGv/
 3C4NrJFGRIc2qO6zz+PD6bHaYlvB7ZewhgTSmleCFduWjSntpxaPCTujWJaictKx1hQ1NPYsUbnoN
 nd7gHKNq7ZoT0tNnrc4/8eRtSGc6QjDbufMCZl+tcko17Xg5CJxxIK10/RwySjxwDyQD6bQjvKhMB
 eVD6pCKQWYAaRClyI3blceF8U/UYitAug2DL5zhNhHQgjJ5PLXdKqb3+dXP171j9olVq7+AJMYSUQ
 m1iYzNFIlhbZWr5oPUnoMg==;
Received: from [87.69.77.57] (port=4342 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np5J3-0007To-IC; Thu, 12 May 2022 05:40:28 -0400
Date: Thu, 12 May 2022 12:40:29 +0300
Message-Id: <83lev7ozqq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <DB6PR0601MB2087CD5C08847EA630D2D71BC6CB9@HIDDEN>
 (message from Ignacio Casso on Thu, 12 May 2022 10:41:56 +0200)
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 <83r14zp5jz.fsf@HIDDEN>
 <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
 <83o803p2p3.fsf@HIDDEN> 
 <DB6PR0601MB2087CD5C08847EA630D2D71BC6CB9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ignacio Casso <ignaciocasso@HIDDEN>
> Cc: larsi@HIDDEN, michael_heerdegen@HIDDEN, 54399 <at> debbugs.gnu.org,
>  monnier@HIDDEN
> Date: Thu, 12 May 2022 10:41:56 +0200
> 
> The few non-documentation changes are just using the toplevel versions
> of those functions in some places that were still missing, in functions
> and places completely equivalent to those that are already using
> them. This makes the use of those functions more consistent across
> custom.el, and fixes in those new places the potential bug that those
> functions were introduced to solve in the first place: calling
> `defcustom' or customize functions inside a let-binding of the variable
> in question (e.g., because a function inside the let body autoloads,
> calling `defcustom')

If those changes are fine with Stefan and Lars, I don't mind.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 09:29:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 05:29:18 2022
Received: from localhost ([127.0.0.1]:39691 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np58H-0008GH-Pd
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 05:29:18 -0400
Received: from mail-oln040092074079.outbound.protection.outlook.com
 ([40.92.74.79]:15491 helo=EUR04-DB3-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1np58G-0008Fz-71
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 05:29:16 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=XyCSCR0Iv868V8iKBAkZsuP0J3T07Z0iXdUokdT4HICqRGfl3Aexwa6JgGJbcRGtCVr7f3M1QmVI1W69Va0aIDghaHn+BG9TFlgQ1LQN0Hn1IUGP1yaY7SUMgBjtSBuQRrwTIM7JPPwh57Ajp0vxLwS3FIYkF0eQa3QOQtg8bMPBVgrw0LGIbg9JnPxDJFGLSjvD+R3ZsRd46MgSsUmwUf6FaOGUNVyEs83WobiVO+DpNEtj6h6LRFfKfPdjx+r7mxKlgpZfQrUzuS50FZ4Vwukw2ST+48ZJjyFVWg3zEbpF5bqHzOOycNfvDN/AqM8jSJI1Kd+w0doy/fq3YeozHQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=uXr+E4NYhjcF78xLgz1pvHwuW3S+vb6ZJY4D4v4mGeM=;
 b=JH15TemrFkuXpgzBMaNGSjTL8ih22QkQ7r1niofm1VfldxONaT1TGkzGiK5ExKCtmhfpaV8c7ZBErsP366DctvTtVQKGvY4jiZo2cpbifNSHIDjp8yCKr5S7nd/awTx6/Jq06BC3/0Bz9Ok7dXrb8qMyMyyBlrBrr3sADioxGQEx2rJ/vryGW/K6Y/g4W7I8s0O7vz+Md8stY2pxdLv/oKWhWchnqmkOQs+zk0T0uVX3zEfW5oGPuUckc+b3a9+mRRQnF0yEWUYKDYD1HflIfBIoR2ECR+sQAbDjVinuWrqBP+z2uAfBTUriTX6yrGhyrHL0outmAHkZmaxbo2CYLQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=uXr+E4NYhjcF78xLgz1pvHwuW3S+vb6ZJY4D4v4mGeM=;
 b=ZK72O3M1w1oh+/XWJ0PABV391QjN+Q2/AyYSk5NcgoFqoE9+OsqqASa54/Jx4cG2shcBWKc7kOKT5CFl7fexjnFLFHo8NowFEpw0SAZWMmPJzcyJAnE0Oz37SlsTe/zTBSrvQN36aQxBdtxrFl9uFq85XWnKNrx3gZ4hwurbky7uMtGzjoySEGQJHW9Qkwskdz3HUk2G3bHTvqrVJlcJTuZR8aHFGKCfd50Yu9wJ6Euyv+gerrtlJ+4D9/qfaWEvWOgqS/ndqEL8PHdjrCUKMn8a19uNyfuwKBLJx0PDEIxy863Ilmn5W1WKLy2AU31YZN9yJgiMPEwWhuTUNKnHRQ==
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com (2603:10a6:4:4f::26)
 by DB6PR06MB3125.eurprd06.prod.outlook.com (2603:10a6:6:3::26) with
 Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.5227.23; Thu, 12 May 2022 09:29:08 +0000
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2]) by DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2%2]) with mapi id 15.20.5250.013; Thu, 12 May 2022
 09:29:08 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 <83r14zp5jz.fsf@HIDDEN>
 <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
 <83o803p2p3.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Thu, 12 May 2022 10:41:56 +0200
In-reply-to: <83o803p2p3.fsf@HIDDEN>
Message-ID: <DB6PR0601MB2087CD5C08847EA630D2D71BC6CB9@HIDDEN>
Content-Type: text/plain
X-TMN: [RduXFdx3kD3z1osBpNBdS7Om8nq0GhJa]
X-ClientProxiedBy: PR3P251CA0029.EURP251.PROD.OUTLOOK.COM
 (2603:10a6:102:b5::34) To DB6PR0601MB2087.eurprd06.prod.outlook.com
 (2603:10a6:4:4f::26)
X-Microsoft-Original-Message-ID: <87lev7umjp.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 47d7dabd-eae5-4baf-266e-08da33f9dd0f
X-MS-TrafficTypeDiagnostic: DB6PR06MB3125:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: vRQMZozC6SHd4aL3gDMdqjXC6qQu6N+puXR6lV1NkMzPdlVJpSKa5wAjuU96gnGsY36z8y3im8MBG0nJpejnZEezs8c72OquTYD2cU1Rr44TbH6BVjwVXqa2M36rGalY0YbGbbiDDKTdjLKiE/PP0v3hWSOYTfmY0oicCC81Lu8obXD6qGDnvukQ1VVZRvIRV4t/mWzzPNkSqYF0kRoKSgdtaXxP9kmTbBeYdJ8QLfRzANNgYGBDqJVQPMGpajfXv8UADVG6Chmrg6vO6NoFgKYxpdpydRW6SRD+6yUsBnmrIK4VNWdOayVFAlbDrj80mMq+Fcz00v1J/2LFAA7dwLM6LzEmagFXQFIbSGr6I2cz6lvtErgE1wzMGj5KiFx5wmk8t+aEossSuqGd879cQBL2bNiw4Is2g7jkNvpI6iwYpSTx9C9mjGdjXy6+y6G1uzpwrbDzVa4C7k0YZ5Z03tj9UUBSXTgYcp1VepC6AnmEyw/ncC5p0Le5aCPiqYxuKqSStp0KB2KTP5/IleQd4ocpjv/HncGny6WeKBH1YPlkubeOV45xNgHgw0dW7E7b1h2HLVLdvLiDJlEeyaq8YQ==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?GxGWdJxv/0nG74J4PuRXY8KSypkrEerOqI3an4hYgi7nYc5rTUsA+rIcoALt?=
 =?us-ascii?Q?IhJrjnYwkPiGa2m/wV9qLym0wJg9ypaLNy5oiCfCsSw7DaUyIikNfN6jjlEm?=
 =?us-ascii?Q?p6tB8eNOgW627tdX/1yUxr0OUU6Yc28VJP1RUaeuEOxkHZYHBEbNUap+qXyN?=
 =?us-ascii?Q?AaOkGgcOuONn5oR3uioPiZquonpjQxUKGA/Dvp/FDH+gmD/mV3KPKc+Ib1fw?=
 =?us-ascii?Q?aXRzadtGiDz/Sva3suUWVoXx2UfNnRh07RmrQ8RiEPbj49AQKOKbw268agz4?=
 =?us-ascii?Q?jGC698F4toWlvbCOv7PiqHMJuv62xeZOUeihw9hs63l/cJtYlt1TCMLPXe3o?=
 =?us-ascii?Q?830vrTcHlec4ZZWMmt9ZOFnt3Dao75lUUWx8ZCV/kDqBjoJ16PENUHo8pT8K?=
 =?us-ascii?Q?M6gld+wrn8dAsYJgICVEAHl9s0FWD4J3Tp6WvVxLP0lvbN8Tk189G7NX/5Jo?=
 =?us-ascii?Q?KVZ2NoJ1xIMfQVaYN8aFtYgL6hLolUvKO/co19C+a/mEnrZrtXOAQljfec4t?=
 =?us-ascii?Q?lQopfDm0x3j05etFiD4KhFz5HFP+cy+/1zgALPViLPBG7qjq9ONt+R0hUS97?=
 =?us-ascii?Q?rLwTjOUr2984opVFe8GAUc1UjptdBm0aUMMBYZ1FaUXP4nusvZS5e0+ooydm?=
 =?us-ascii?Q?rN0KlrWpxo6gbFb9NCogOpyRq8repB3gYExNRAJK4mLtMDb3vo1cPWFmHfjX?=
 =?us-ascii?Q?68hV1OPWfDXgJLAE0f+pwgLFbeDycmRQuIFBsLutDm1XVyVQauhjdrCJKoNM?=
 =?us-ascii?Q?96MqhMFn4F8U2LYGaanNcd1InMZ+UTQ7go7dFvQoUyYDXyGX04tojzBfjjFl?=
 =?us-ascii?Q?YcQGbZFJfMMkU3ZPeXZcAl2oISltvXuN96P6rM7C7UVPRH2Pz3s6HJ9ZhwtU?=
 =?us-ascii?Q?3Rvyd/7d+qnVn9ZOmK3YnwGrmOZClpYhTN2r1L8LyUbx2rY6AggDY5Gc8eAA?=
 =?us-ascii?Q?Oi1EgQlTj7IfcDbE9ZwiOqFfAPuN0Myp/RTUrlGSPqbFVkcJWzkGA9QW1MbD?=
 =?us-ascii?Q?Ich4FDkqyfz+SePlLPDzdu+RmOrvw7UvmHPaizJQa+/Y5GaigoTxvlDKYi4f?=
 =?us-ascii?Q?Lma53K5bQYleFMYHm5edKlKWllSE7YyiSvevWzzyFOPChj3U5nIPEt3pgjJ1?=
 =?us-ascii?Q?Y16YiN/ABGTCbzeK2sQh+U+LjiQcJOg9578yuammJnA8zQ/oGAstkwzsJOd1?=
 =?us-ascii?Q?FkHf3Z1ko3Lw/4gf5xT02kFCfHS7DG7rurMjKSES4nr7dUDW0nzew4Jje07a?=
 =?us-ascii?Q?v0bazE5H/xEmtrD1pbcpjJKiMLD4mQliyq/zjT7mbftjbdctK4yH2/Ie1lEc?=
 =?us-ascii?Q?W2Vi0jcNLax7MeLZKtJDiFN8PZ7qr/e7icyi3dekQUv9BioQLCv3waM6dSps?=
 =?us-ascii?Q?dLUdRUYl8VgNEgzNKh2rjcmbTsQ8wqNJ0IUJQm/GzOinT9hs6YIQHr6bIlSL?=
 =?us-ascii?Q?5AVCzBTcHH0=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 47d7dabd-eae5-4baf-266e-08da33f9dd0f
X-MS-Exchange-CrossTenant-AuthSource: DB6PR0601MB2087.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 May 2022 09:29:07.9508 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB6PR06MB3125
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> My point is that you seemed to be sating that you suggest a
> documentation change, but the changeset actually changes some code.
> So I'm not sure anymore what is this changeset about.  Perhaps I
> forgot what we were discussing at the beginning, since that was quite
> some time ago.  Can you remind?

Sure. It began as a bug report, but after you explained things to me,
all that was left were some mismatches between the docstrings of some
functions and their actual behavior: they use `default-toplevel-value'
and `set-default-toplevel-value' and their docstring said they use
`default-value' and `set-default'. And that is mainly what this patch
fixes, aside from another error in the docstring of
`default-boundp'.

The few non-documentation changes are just using the toplevel versions
of those functions in some places that were still missing, in functions
and places completely equivalent to those that are already using
them. This makes the use of those functions more consistent across
custom.el, and fixes in those new places the potential bug that those
functions were introduced to solve in the first place: calling
`defcustom' or customize functions inside a let-binding of the variable
in question (e.g., because a function inside the let body autoloads,
calling `defcustom')

A few further comments on each change:

> @@ -114,7 +114,7 @@ custom-initialize-changed
>                  symbol
>                  (eval (car (get symbol 'saved-value)))))
>        (t
> -       (set-default symbol (eval exp)))))))
> +       (set-default-toplevel-value symbol (eval exp)))))))
>  
>  (defvar custom-delayed-init-variables nil
>    "List of variables whose initialization is pending until startup.

The docstring of this function actually says that it behaves like
`custom-initialize-reset', which is already using
`set-default-toplevel-value'.


> @@ -717,7 +717,7 @@ custom-set-default
>    (if custom-local-buffer
>        (with-current-buffer custom-local-buffer
>  	(set variable value))
> -    (set-default variable value)))
> +    (set-default-toplevel-value variable value)))
>  
>  (defun custom-set-minor-mode (variable value)
>    ":set function for minor mode variables.

This would be the only setter function that does not use
`set-default-toplevel-value'.

> @@ -752,7 +752,7 @@ customize-mark-to-save
> @@ -779,7 +779,7 @@ customize-mark-as-set

These two I thought that I had remove them. Ignore them, they will not
be there in the next version of the patch

--Ignacio




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 08:37:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 04:37:05 2022
Received: from localhost ([127.0.0.1]:39592 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np4Ja-0006Qv-0y
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 04:37:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:34960)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1np4JY-0006Qa-I0
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 04:36:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59656)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np4JL-00072i-Cm; Thu, 12 May 2022 04:36:41 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=OiXQYK2xMsL/S83IbUWg8YIF6c8l785iH7LnI+ap0kI=; b=OaVkiGXvl5bY
 na4cxcU4hpR0M5rBRACOWP5F8eT4EkV1S0eCeIzaoVpYQTvOaTaL0FCYu4NxO1QJB9m7JFwa2e0Aw
 CtcBCBmjCZYzx8qYNY1erJfcaRsT16VtFr4wsXp+H0nRYMut0pXEvjN4iRWsER+codKmSq4jqqJas
 akpbHmtsv4XKtYFIP0Ek63CgkOPCyICv7rstgPQjLZIIV/8QfQFNjPfLjbGiPx5+VBNhVVoRzO+FV
 eyKK+N8RBafDPS/hs0nlT2U+AAqrFdKAMEtyx0vTkfPAtcpbfu/LqN4ON+jOcO0Xh9Mm0C7WIg1QI
 DffYdFm0FZrIP1L/8wcY9g==;
Received: from [87.69.77.57] (port=4430 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np4JK-0004kn-6R; Thu, 12 May 2022 04:36:38 -0400
Date: Thu, 12 May 2022 11:36:40 +0300
Message-Id: <83o803p2p3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
 (message from Ignacio Casso on Thu, 12 May 2022 10:14:13 +0200)
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 <83r14zp5jz.fsf@HIDDEN> 
 <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ignacio Casso <ignaciocasso@HIDDEN>
> Cc: larsi@HIDDEN, michael_heerdegen@HIDDEN, 54399 <at> debbugs.gnu.org,
>  monnier@HIDDEN
> Date: Thu, 12 May 2022 10:14:13 +0200
> 
> > This doesn't just change documentation, it also changes some code.
> 
> Do you say it because of the commit message?

No, because of this:

> -  (let* ((get (or (get symbol 'custom-get) #'default-value))
> +  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))

and this:

> @@ -114,7 +114,7 @@ custom-initialize-changed
>                  symbol
>                  (eval (car (get symbol 'saved-value)))))
>        (t
> -       (set-default symbol (eval exp)))))))
> +       (set-default-toplevel-value symbol (eval exp)))))))
 

and several similar changes.

> I was waiting until you agreed on the patch to write a proper one
> following the guidelines.
> 
> Or if you want a patch with only documentation changes, I can
> update it, but the changes are just using the toplevel versions in a
> few places that were missing.

My point is that you seemed to be sating that you suggest a
documentation change, but the changeset actually changes some code.
So I'm not sure anymore what is this changeset about.  Perhaps I
forgot what we were discussing at the beginning, since that was quite
some time ago.  Can you remind?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 08:28:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 04:28:35 2022
Received: from localhost ([127.0.0.1]:39527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np4BW-00065E-Q3
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 04:28:34 -0400
Received: from mail-oln040092069054.outbound.protection.outlook.com
 ([40.92.69.54]:23685 helo=EUR02-VE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1np4BU-00064x-R1
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 04:28:33 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Xb10rqGhkPK8Ck5laYN79ubDsXijFmZ61U9LvZwjtN3OaPxg/eeirDIwdnQOQB1VaWFYwRSgMAzjL725nFnml3eMPGi19SAiXKclOOjVUmbvKu925SkzvxRzhnqIC0rNeoJoBC3xi0R2HErOHOJJwqlNvcS+Ix4lq/pWTvWwYlUluf+TkfNnC4UgLhRTSfPnXKo3J+C9N8pa5nI9Mh0QdAeFqDiLqJIWhLehekJWqiuu4Em8hd7E4g2sQpZ+mSai6XUnS+6ezPjhNm2NJ80d376LXnMpqx+/DXGOiSiMfMV08HUJmy4U0KNuMjkmgLCLeilCjjjBAIsg5PZz/xnA7A==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=obTPZR1FrGzKD3unVj++qWqqn8RmyByMdMg+GlJ08Zg=;
 b=a6qjJJBqTUbJR17Uc+yNcQLgxDDRXkgnq0YLZ/4dCoTCaxajmJixpEw+OuSa1O+iPbhevBfUwkpehfq0zJRqh3Kpy8cG1u/CMH75YBed2o6aVfpNqI5cmP+7QXud0cH7dv/ZzbFouQLzUIMJRACSckLY/wxXG077h0yDKoG67mXG80Vw+JLAPRn5Gh/hJT86Tbh7aSL0QgNjPqQ0PZSE/BTQfSC+jk8POZA/fm3VturvY2knhUUX+D4cByoRxgak5rWpR8Nnx/neqGc+FpgJJ6Z1KLpd9pExKepDErsUdrH5lTWIzRzZtnRXv5ZNG2rQb9E1YEx5CrzCTmaCZSi7xg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=obTPZR1FrGzKD3unVj++qWqqn8RmyByMdMg+GlJ08Zg=;
 b=mku1Hh0amxFaxA5OSO41lpbTh/WwPnhCiZd2To78NYlL50vhuCDD3G1F8uogFqFXTKvP8lcgVJFYrD95y0uKcu7YQZJJwov6yZZvUN6ecMLL3H8lm+kQ/Oukelwt1FrJnuFEwxN+JYg7y4U74bbwH8O0EtXY8CeLyWEP4//L9qdeXE+R1r0GKkw6IVYqXSP/v7OlUNuDfSS7xKMQcAnECL/FhJUPqh+mG3b287Dw/xh3bFqkEMuDgj77TgWvJ6oaZVrG0DHaIVzfMyiqnH0YWnxE28g3CD5SEUQzu4cqssKsCHlah4pL/TwUzfve4fbTN6dIi0MPO8qP+11Bh81HmQ==
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com (2603:10a6:4:4f::26)
 by HE1PR0601MB2092.eurprd06.prod.outlook.com (2603:10a6:3:26::12)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5227.22; Thu, 12 May
 2022 08:28:26 +0000
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2]) by DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2%2]) with mapi id 15.20.5250.013; Thu, 12 May 2022
 08:28:25 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 <83r14zp5jz.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 27.2
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Thu, 12 May 2022 10:14:13 +0200
In-reply-to: <83r14zp5jz.fsf@HIDDEN>
Message-ID: <DB6PR0601MB20872007356D637848EA40C2C6CB9@HIDDEN>
Content-Type: text/plain
X-TMN: [hET6y31H1suMIyCMn/OLgQMDbIgWH/rf]
X-ClientProxiedBy: PR0P264CA0177.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:100:1c::21) To DB6PR0601MB2087.eurprd06.prod.outlook.com
 (2603:10a6:4:4f::26)
X-Microsoft-Original-Message-ID: <87pmkj5f4t.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: a88ccee4-9dfa-4fb6-8a33-08da33f16246
X-MS-TrafficTypeDiagnostic: HE1PR0601MB2092:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: oXnLYN+rj7Robqe2evhIsQ0/gQlngPAKjXRPKcldwtLQ85O20OumFa7A46D8ZkpzS32cbqCByIdHUTj5TS9jlhU8dCTWqZWysRE3972dbYvfss3Cl6olta5Rj3HI1Q5LhFcsSDL7MN/rHqAGA+Lv2oxWozPCEt8Dw6sf4I5ZpAfFGVwJ7YM3VpFDG57W7b5iRlLNffl+NpbLi9Qz5URjwdgjLiW+IKxZ0PaRU2fHhzRWsZ0EWFCVCdhwVUm7Skcm7FmhQVPR6LvAQnqZ/y/LeNRZIlU0mVfBqjytBCgk+u9glSyCGsAw2shCE92fluvGCuaRJU2R8sldTvoaGhgKe3WUMdwUG9IomsQAk9w1mbZLkFANWiMdzOKU0cgkxPQZMaYqIKpCKXFLgF4iQ1jE4AdiEiJZlTMTnhgjAOtmwP8KJ7xQzUoJJlGWuwsq2odyPOdew8dwIjntPuN4CD2sQ0fowMv7VTEasL3UGw03uqGoTcysMcPWnNl/lKeNLTQrHnlDinfnBKfXuWkniDvdHKo3YrLEF11MHMiQC/MVe1w7g3gYaa6BHaqtDDEyf1iHMLyO3Fm/LOhh8v/4Vvz+zg==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?+DbDdssgyWVy5LWJxStal8T36oaMqUTOssxjcs5N4fA6/ZeGKMGJixcIQGOT?=
 =?us-ascii?Q?UHhuQ8J2F/7ajRPySYpvpKmdsmMSkgcpXLMcxQjKAoB9KrRUNVlcVcxz6azH?=
 =?us-ascii?Q?E//ROXjSRd4hvKqpJ2gwPBqvB4NJkV4o96w7m/RzQHgNz3AL2YQ2/knv3JwG?=
 =?us-ascii?Q?W5DcvqJRF83gxx4HaHCHY29e1wInyqVcqXP4TFPXJFkQYEtyd721Puv3SDjX?=
 =?us-ascii?Q?NaZeWCwze234qLN+h1UPcaqsTkHBZVF4bp5sFEfcaeLJvqT+APnaZAsFlV4X?=
 =?us-ascii?Q?q3UdaVVQw5uj2q+e8hJWsLKkr5LwJvfdPIhWdd41HgzSIxBGn9qmv+gOxx6n?=
 =?us-ascii?Q?r7wxrZl7jXOEZyjFzI+430CoFk7angusqa23vRfk7SQvSqv5yNdb+m2t/iTm?=
 =?us-ascii?Q?LED/fNjhmwCnti7oz/4c/7WthtR2YYErjAt34Jg4wfuDIPeJKHYaL2DaM9nR?=
 =?us-ascii?Q?eaqRy8Ofd8yZvyJNWxW7jNDRv2zXps18ODjffx749M9Pc5iQuAYeoNaI+Lvh?=
 =?us-ascii?Q?DFgWhQlGqjM1ib5e6dqplxkstxdI4mpFTcg4e5LA4yI4YpaPaY+dTwBiE6AY?=
 =?us-ascii?Q?8Gok+eKawwv/I8YnHiiP7PShwDUMuVUURymDPCevfIZEMC8H0Zin7YaUnuB/?=
 =?us-ascii?Q?1g6yEThHxtvUsVOVRPseTGlnw8Y5nbM3pKdZvpE/W7eyH+faM1pRAyuTS1JF?=
 =?us-ascii?Q?yQxoOmblxS3eRPepahJKD91u907u0PvtcB6bP40adng3W/WQw+ruweITXO9D?=
 =?us-ascii?Q?nQY8lcqYniZi0Zf7uraUe4xFhEwnQnw1MuLtzgNcNlGh7Zj6arXqWr0hbr1v?=
 =?us-ascii?Q?/0YFSErQxeXhSGt0EiJa35PsW8t7AKt4du6BvOh9QEvRhlFLOukVPvYGLWGh?=
 =?us-ascii?Q?mVG78Xsph8rPeewfwDckfOQtzdEvIBWMdze0zcxi+sHzD3gvNnaHiG4leAQ1?=
 =?us-ascii?Q?E2iQbBDv7jS1DYE+vdE5WVIsIhovrXjJq9VAVykXZFXSen5RCO/X8tIvvu5s?=
 =?us-ascii?Q?WvJXsopROdkOVL4PytyJl8luFgc/7cptkKBMW72iVLJU3uoM7UUmWtgbxZ/n?=
 =?us-ascii?Q?n+dl5MxpYKRGbahawyVAkP9cwvYcR2D7IIDoVWeNxEALs1jBw6I0ngB+/B5q?=
 =?us-ascii?Q?nDcs5LTm8eaiQnp+K/YyWwMVaHBBP44Blsolf/l6W3KR5Wz/bsZEBJ474mel?=
 =?us-ascii?Q?8lzaHekIXZ7Yf4AWtEuDaZdoF3nvlIhLuvkodSWszP1BEOIB10jxmUr6X/wD?=
 =?us-ascii?Q?knwuzzncMG+a+EC6OeaZPgCBGIaozpdSB75aHqEVuHbouc+0iqnNWK3/wxYl?=
 =?us-ascii?Q?5FKdmgHaTKif4bo6vnUrrT6lYXVgp7KBPeSlmmq2orCBC/+KH69BmD/SJjzA?=
 =?us-ascii?Q?UhPkOuK0IdWechfFdY38fZ+lbFrCwjhJhPJsmyqIe+258CAq6dhdzCLxqjGX?=
 =?us-ascii?Q?ZPwNxfFNNnM=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: a88ccee4-9dfa-4fb6-8a33-08da33f16246
X-MS-Exchange-CrossTenant-AuthSource: DB6PR0601MB2087.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 May 2022 08:28:25.9489 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HE1PR0601MB2092
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> >> I've also made some new changes in customize.texi after I sent this
>> >> patch. They are equivalent to those in the docstring of
>> >> `defcustom'.
>> >
>> > I didn't see any new version of the proposed patch in this bug report?
>> 
>> Sorry, I was waiting for more feedback in other parts of the patch
>> before sending it. I send a new version now with the typos you pointed
>> out fixed, and the changes in customize.texi that I said. I've also
>> dropped some of the changes in the previous path that I don't think that
>> were actually necessary, to keep the patch and review simpler.
>
> This doesn't just change documentation, it also changes some code.

Do you say it because of the commit message? I was waiting until you
agreed on the patch to write a proper one following the guidelines.

Or if you want a patch with only documentation changes, I can
update it, but the changes are just using the toplevel versions in a
few places that were missing.

--Ignacio




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 07:35:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 03:35:03 2022
Received: from localhost ([127.0.0.1]:39396 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np3Li-0004Ib-My
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 03:35:03 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50970)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1np3Lg-0004I2-BL
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 03:35:00 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58644)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np3La-0005Xy-N4; Thu, 12 May 2022 03:34:54 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=5m0ZP154fYv46mmgEHBau/E+gx8sC51e+x96JOqRKYA=; b=PCSH0LKcnwEM
 o99HjUy0gl4GVdBG8enhmXeRqV2hhkxABi+8t0FeG8WMYE/bj+jKrWDloLZtCltjoJ2JwxiauOLEK
 OybRos3AxU1p2NyCskOwZJm3dUZFMvJl5bjxB6O2GEIQFgPitYgBW12Zael42BvQj7KGypjf533NE
 IdeqenIg51J97m26xL9nfA3LjoGqBI/BEvN8JvmBbLMzNBUlN1dEHEgrPj8djgZw7Q8jBjHZe983t
 WqkcFpY2TnqrAZfXw/vs2OsMhmW6wdUBf5ua7kNMqr1YFDnqX9/N+dDN/P6oPU/BkTf9reQ7HNGhC
 8OnFBfVQ2ab/HOtzMncN6A==;
Received: from [87.69.77.57] (port=4411 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1np3La-0000pt-11; Thu, 12 May 2022 03:34:54 -0400
Date: Thu, 12 May 2022 10:34:56 +0300
Message-Id: <83r14zp5jz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
 (message from Ignacio Casso on Thu, 12 May 2022 08:58:09 +0200)
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN> 
 <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ignacio Casso <ignaciocasso@HIDDEN>
> Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, Eli Zaretskii
>  <eliz@HIDDEN>, 54399 <at> debbugs.gnu.org, monnier@HIDDEN
> Date: Thu, 12 May 2022 08:58:09 +0200
> 
> >> I've also made some new changes in customize.texi after I sent this
> >> patch. They are equivalent to those in the docstring of
> >> `defcustom'.
> >
> > I didn't see any new version of the proposed patch in this bug report?
> 
> Sorry, I was waiting for more feedback in other parts of the patch
> before sending it. I send a new version now with the typos you pointed
> out fixed, and the changes in customize.texi that I said. I've also
> dropped some of the changes in the previous path that I don't think that
> were actually necessary, to keep the patch and review simpler.

This doesn't just change documentation, it also changes some code.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 07:10:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 03:10:59 2022
Received: from localhost ([127.0.0.1]:39353 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np2yQ-0001NK-Gl
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 03:10:59 -0400
Received: from mail-oln040092068023.outbound.protection.outlook.com
 ([40.92.68.23]:29838 helo=EUR02-HE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1np2yO-0001N8-JR
 for 54399 <at> debbugs.gnu.org; Thu, 12 May 2022 03:10:57 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=i+IdaSDfAPgWsF3xvmF4jVN6KCOOLgIApO7pDkU64ig0b3K/9K7HQKFUaFiyMZMapAoiY6C4LD+nk05KElyELP/LPl3x9qXT3L6zEg5ji6uy7t5r4aw18BY5sqwK4VsmGRgjR9wT8SMbVd6yMGrgs3R+bzP6AyvjiKP77Zp0Sqsmm069g3Ex19dQcmommANmOtLf+tY5ykPDiEdFjJiCCOKfDgJpky9sB27eAtM9YnekueKiuwnbxUFdG8vsgYEnR+GFyJJ4ooFVpx2ApCQN5h4KJO+/DYrt5ne/2x8aBOobnVFyuKg9wl9z8wjwZXJowkkcxoK2SqpW42djStVqZQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=nxkxyY6gZszZmGrLI4aFCfLhBOMlxdL/eSmNBJjFeLA=;
 b=iilwwBej61S2MZremkMtHhNMy/xfrtbalsCswXsEaxVxsTdbW3hnvwZUDd6bu2ZXwqhQ137qxyj7WjAfO3UCvAEnlyJLQv3rTzz1Ll8GtPhZy2PtHYsejs8a5cpOYzGzD7Tj+FY/c4EcrfatmF9eqvbdt4tBlk7YvoPvGj9UtnzolKWqUnnR3dS8yha+n5JMLRCQw/V/QyeWpgze4kKk74LemQZV8vhq3OoDePQsmLjMWhhp+Ug13bJXYFX8XwSguk/iH8Mu3Y0tXV0S2qPSLsMrYE05cxGUw9XKyy5xxDNjgPi7wuzRGJX7Yza8p7KuloeI2/EWjrGB24h4+mP1Bw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=nxkxyY6gZszZmGrLI4aFCfLhBOMlxdL/eSmNBJjFeLA=;
 b=uZDv47TRkO7pzjZL4MYYucAR1Jn+PY0Tb6crqxNZJP6fSTDC0KqTn+qUu2zd+BYVp/JjPnZtw2NcSTK2WKTJu95GPXTeuVg5S/3eKyemnJxazGY2jmYYyyDihp7wzkBUU4wsnwp45fqv8eqMd+a7V1TuWsLLkRBSBGEhJs5B1e79W1coaGaC/F9XFY8UU+C9vxMgUM43JK5bJ30+eyXlO8avPiEb3I2Rih+b7y9JKQu6dN47HsyvAHMvFLkQxmk31BbJ3PmZ3lY7UogLlam7lOfqPU0eMUpfsqAIuYtBoiHRFqLT6818ceX0OXI91VnUZPNRlNwg0631u1TzKCA/2Q==
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com (2603:10a6:4:4f::26)
 by VI1PR0601MB2718.eurprd06.prod.outlook.com (2603:10a6:800:83::15)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5227.23; Thu, 12 May
 2022 07:10:49 +0000
Received: from DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2]) by DB6PR0601MB2087.eurprd06.prod.outlook.com
 ([fe80::cdbe:e542:a1b6:1a2%2]) with mapi id 15.20.5250.013; Thu, 12 May 2022
 07:10:49 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 <87ilqb1nwf.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Thu, 12 May 2022 08:58:09 +0200
In-reply-to: <87ilqb1nwf.fsf@HIDDEN>
Message-ID: <DB6PR0601MB208770A8C7ABBB4D7146E355C6CB9@HIDDEN>
Content-Type: multipart/mixed; boundary="=-=-="
X-TMN: [qP+P4OFB9uTcQSshT9VTqC3ypNzVE6s7]
X-ClientProxiedBy: PAZP264CA0122.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:102:1ef::18) To DB6PR0601MB2087.eurprd06.prod.outlook.com
 (2603:10a6:4:4f::26)
X-Microsoft-Original-Message-ID: <87czgjfcp9.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 81eb91dc-d6e5-46de-87a1-08da33e68a9c
X-MS-TrafficTypeDiagnostic: VI1PR0601MB2718:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: SMkX2LCJb5VJ5A9fkf7SN2gwTBsVN2oBRs9myEPXSjFemY2IMC1p84/ftB+VO35U9GwRL5tBvkY/aaqIzsXhWOloRgO/HMfla6zfo/O0ul0/zey6C6rDg3SIQY46q1SA7NCJgQuP77abV2JX8BcSQCq+1FNd0wvEUewsjN5j4MSvtnU/nGdzopCRnBpafyTxPzoVyJn75xQZRBvJ/sgHn6PoUBwrBr70+iXW7zAB4o9D+eojt+9xMa+JMcwig0bnkLwJibheVidBXEXDLMax8lILpP5HtjMfsjp1InMoLA9ruD3ZDai1fwT1A1HHAbb9rFIbmUh7gNPBQ3Grd2C+/3KPdMRDvNAf3pGpBETPcl8dVEhD47xT4lh6KAIr5FDo9yxCeSxg3KxY7jK4Fqd1NAxwoHzWB5fir+PGbfZrKZ8XfeTVRg3bD2d/52RQztnNWdaLEBbOW0qLW6qPJrfzOoWWKqMBFhbpMDo76dYsAV8aDLCRNLrk2kye9g27NV5JCXV7+SQaZ7EEEJ98C8d5gIQE6dRNDRLoeW0G3g6InsVpONy3o5JhZVMk6iN7Y5DZM4Cj0MPlr0zOM39ORtl03Q==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?ALUIYAKvz3rdQyOaeWKAoeycF+QodxIL3zgHVCFHobx37oj0YL23nBu6Zhwb?=
 =?us-ascii?Q?bMvO9/pTx/b8+Fj/LiEmy8CMAmz6lko3dZ6SoWD1NWHks1sUMESfSRbHD7Fg?=
 =?us-ascii?Q?5ZR8P6xxwHOv3l3eagSVhQtSxm4w6fhVmfbkYeij7nFx8aJnZoBA8B7bLM3U?=
 =?us-ascii?Q?KksMvqb6Cl4czfNK60RQxldgxiWzhR4+pOS7WaUZyoNTkywlMKMTq58h8z7L?=
 =?us-ascii?Q?+1elTWVBjS83eoQpNmA7KxpsyT8E/N5QZXC01Cwf/cuOpoLp6ZPT20MDIgFV?=
 =?us-ascii?Q?Dx+W2KpF2TYMGR+j/nBCrU0aKr3b1381kDhfOT4gQtCdjlms7+BUuWfEx6k9?=
 =?us-ascii?Q?NncevhIUNRFhAbgsWOcxNmhTI1x2IpAYPipbp7LF3isL+dWKyzGs+ELAH6LG?=
 =?us-ascii?Q?dGLRZCR/j3lqbn0cd6wL2tiVXNjNhjjGPZmPK2z7vi0Ekrfx4RoCl9PGAaiE?=
 =?us-ascii?Q?A7S39wvfJCKhq0k7ztAG7FZyhCOdmChNomehpSsEFkyAPpXFzYnlrEKjoakp?=
 =?us-ascii?Q?74sluQDQRTYw4NCJ1EEnvDEKgPk5kJA8iDzg7rKXQwJO8P4+iANEuB0rZ+lg?=
 =?us-ascii?Q?1HwKg+MnQKC6u5Vqs9BmdnkDgPFEYRo8BEgwooCCSMVDpy2dhBO86hxHdthL?=
 =?us-ascii?Q?4WXkd4pUkk3WRs8ovwiomyAJe1mZ0Uc51f1+QR4YLUJ+Iso0BhXjr4kF6VKn?=
 =?us-ascii?Q?ry/7T5Q6xSv0BS8E0vECkPWaHHiDcWCiFAhJP6VxL/AcNHXIKbU+Nw65k2nK?=
 =?us-ascii?Q?7UCtR4UbAUBhD01gXdWQ9fY1EQpbw0VelCTqCYMhYKyP4J3bdOF4H1ZUNzT2?=
 =?us-ascii?Q?y8lHPXKoJ5NwiUVOAGXNjiPetVy2XcLwrZo13S/AcBni1pW4CYvhP0Ggsxv1?=
 =?us-ascii?Q?KTFaM657SAcjVKE4TjsuPFu8vaFyvy6FNDi/7WIMsDuHzqStE5lENxz2P+2j?=
 =?us-ascii?Q?a88BO/ZHBImgpCAZrB0zZvF2c9dJKTyBQGtcdWbPAicHJ+i5svflvRe8iH2s?=
 =?us-ascii?Q?X5KfL/dF4eBHx0MERl1P4QkRGr9+Qo42Q4Lk4eV3KNi3giF10sICXMR1mhgw?=
 =?us-ascii?Q?01CTWp/GuuaHPTtr52xkFSfzvNHcg+lhdiz6Wx1puW1FSPG3jzMbgYJf5Ige?=
 =?us-ascii?Q?B8J83Rz+AEYzEjK8hOD0rWbzH+K7/546P/79i2dYpid7WQHJjDq7Vtd7YGA2?=
 =?us-ascii?Q?pgF7Ed4FD5ZQjLB+z5JjdgcaKexl1gCcql5OQ0s1xaU34wZR25/l5r+GKWJ2?=
 =?us-ascii?Q?tPjS4Nlav0G42FPEG2Klw8O/eOyRfoDjWSF2d80RSqiwPazRR6wfVGPTu8F9?=
 =?us-ascii?Q?R6qIaFz3RKldPYbv2P3JbTwVyO1Mb9Cy/7DUe9bYjJgyEKo3R8ta/MWPVT2Q?=
 =?us-ascii?Q?axImrelJ5wEO0Wzgpb2Hi0tPDeAYyZ5tR8GBJ5Eq+rvzUvwvacI9Ca/foEZL?=
 =?us-ascii?Q?AEgVyIicPTk=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 81eb91dc-d6e5-46de-87a1-08da33e68a9c
X-MS-Exchange-CrossTenant-AuthSource: DB6PR0601MB2087.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 May 2022 07:10:49.1729 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: VI1PR0601MB2718
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain


>> I've also made some new changes in customize.texi after I sent this
>> patch. They are equivalent to those in the docstring of
>> `defcustom'.
>
> I didn't see any new version of the proposed patch in this bug report?

Sorry, I was waiting for more feedback in other parts of the patch
before sending it. I send a new version now with the typos you pointed
out fixed, and the changes in customize.texi that I said. I've also
dropped some of the changes in the previous path that I don't think that
were actually necessary, to keep the patch and review simpler.

--Ignacio


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-updated-some-documentation-regarding-customize-and-d.patch
Content-Description: Patch 54399

From 9ebf1065c2970f688fdcafd6278ae5e239265065 Mon Sep 17 00:00:00 2001
From: Ignacio Casso <ignaciocasso@HIDDEN>
Date: Thu, 12 May 2022 08:41:44 +0200
Subject: [PATCH] updated some documentation regarding customize and default
 values

---
 doc/lispref/customize.texi |  8 ++++----
 lisp/custom.el             | 18 +++++++++---------
 src/data.c                 |  4 ++--
 3 files changed, 15 insertions(+), 15 deletions(-)

diff --git a/doc/lispref/customize.texi b/doc/lispref/customize.texi
index 54059d7b6e..06a2f5365d 100644
--- a/doc/lispref/customize.texi
+++ b/doc/lispref/customize.texi
@@ -376,7 +376,7 @@ Variable Definitions
 the value properly for this option (which may not mean simply setting
 the option as a Lisp variable); preferably, though, it should not
 modify its value argument destructively.  The default for
-@var{setfunction} is @code{set-default}.
+@var{setfunction} is @code{set-default-toplevel-value}.
 
 If you specify this keyword, the variable's documentation string
 should describe how to do the same job in hand-written Lisp code.
@@ -387,7 +387,7 @@ Variable Definitions
 option.  The function @var{getfunction} should take one argument, a
 symbol, and should return whatever customize should use as the
 current value for that symbol (which need not be the symbol's Lisp
-value).  The default is @code{default-value}.
+value).  The default is @code{default-toplevel-value}.
 
 You have to really understand the workings of Custom to use
 @code{:get} correctly.  It is meant for values that are treated in
@@ -409,7 +409,7 @@ Variable Definitions
 
 @item custom-initialize-default
 Like @code{custom-initialize-set}, but use the function
-@code{set-default} to set the variable, instead of the variable's
+@code{set-default-toplevel-value} to set the variable, instead of the variable's
 @code{:set} function.  This is the usual choice for a variable whose
 @code{:set} function enables or disables a minor mode; with this choice,
 defining the variable will not call the minor mode function, but
@@ -424,7 +424,7 @@ Variable Definitions
 @item custom-initialize-changed
 Use the @code{:set} function to initialize the variable, if it is
 already set or has been customized; otherwise, just use
-@code{set-default}.
+@code{set-default-toplevel-value}.
 
 @item custom-initialize-delay
 This function behaves like @code{custom-initialize-set}, but it
diff --git a/lisp/custom.el b/lisp/custom.el
index 76c14831ca..2ab7c69d00 100644
--- a/lisp/custom.el
+++ b/lisp/custom.el
@@ -68,7 +68,7 @@ custom-initialize-default
 (defun custom-initialize-set (symbol exp)
   "Initialize SYMBOL based on EXP.
 If the symbol doesn't have a default binding already,
-then set it using its `:set' function (or `set-default' if it has none).
+then set it using its `:set' function (or `set-default-toplevel-value' if it has none).
 The value is either the value in the symbol's `saved-value' property,
 if any, or the value of EXP."
   (condition-case nil
@@ -81,7 +81,7 @@ custom-initialize-set
 
 (defun custom-initialize-reset (symbol exp)
   "Initialize SYMBOL based on EXP.
-Set the symbol, using its `:set' function (or `set-default' if it has none).
+Set the symbol, using its `:set' function (or `set-default-toplevel-value' if it has none).
 The value is either the symbol's current value
  (as obtained using the `:get' function), if any,
 or the value in the symbol's `saved-value' property if any,
@@ -100,7 +100,7 @@ custom-initialize-changed
   "Initialize SYMBOL with EXP.
 Like `custom-initialize-reset', but only use the `:set' function if
 not using the standard setting.
-For the standard setting, use `set-default'."
+For the standard setting, use `set-default-toplevel-value'."
   (condition-case nil
       (let ((def (default-toplevel-value symbol)))
         (funcall (or (get symbol 'custom-set) #'set-default-toplevel-value)
@@ -114,7 +114,7 @@ custom-initialize-changed
                 symbol
                 (eval (car (get symbol 'saved-value)))))
       (t
-       (set-default symbol (eval exp)))))))
+       (set-default-toplevel-value symbol (eval exp)))))))
 
 (defvar custom-delayed-init-variables nil
   "List of variables whose initialization is pending until startup.
@@ -262,11 +262,11 @@ defcustom
 	when using the Customize user interface.  It takes two arguments,
 	the symbol to set and the value to give it.  The function should
 	not modify its value argument destructively.  The default choice
-	of function is `set-default'.
+	of function is `set-default-toplevel-value'.
 :get	VALUE should be a function to extract the value of symbol.
 	The function takes one argument, a symbol, and should return
 	the current value for that symbol.  The default choice of function
-	is `default-value'.
+	is `default-toplevel-value'.
 :require
 	VALUE should be a feature symbol.  If you save a value
 	for this option, then when your init file loads the value,
@@ -717,7 +717,7 @@ custom-set-default
   (if custom-local-buffer
       (with-current-buffer custom-local-buffer
 	(set variable value))
-    (set-default variable value)))
+    (set-default-toplevel-value variable value)))
 
 (defun custom-set-minor-mode (variable value)
   ":set function for minor mode variables.
@@ -752,7 +752,7 @@ customize-mark-to-save
 
 Return non-nil if the `saved-value' property actually changed."
   (custom-load-symbol symbol)
-  (let* ((get (or (get symbol 'custom-get) #'default-value))
+  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
 	 (value (funcall get symbol))
 	 (saved (get symbol 'saved-value))
 	 (standard (get symbol 'standard-value))
@@ -779,7 +779,7 @@ customize-mark-as-set
 
 Return non-nil if the `customized-value' property actually changed."
   (custom-load-symbol symbol)
-  (let* ((get (or (get symbol 'custom-get) #'default-value))
+  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
 	 (value (funcall get symbol))
 	 (customized (get symbol 'customized-value))
 	 (old (or (get symbol 'saved-value) (get symbol 'standard-value))))
diff --git a/src/data.c b/src/data.c
index 72dcf6f878..9b36ecc1b2 100644
--- a/src/data.c
+++ b/src/data.c
@@ -1939,9 +1939,9 @@ default_value (Lisp_Object symbol)
 
 DEFUN ("default-boundp", Fdefault_boundp, Sdefault_boundp, 1, 1, 0,
        doc: /* Return t if SYMBOL has a non-void default value.
-A variable may have a buffer-local or a `let'-bound local value.  This
+A variable may have a buffer-local value.  This
 function says whether the variable has a non-void value outside of the
-current context.  Also see `default-value'.  */)
+current buffer context.  Also see `default-value'.  */)
   (Lisp_Object symbol)
 {
   register Lisp_Object value;
-- 
2.25.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 May 2022 02:32:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 11 22:32:47 2022
Received: from localhost ([127.0.0.1]:39049 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1noydC-0007Eq-Sq
	for submit <at> debbugs.gnu.org; Wed, 11 May 2022 22:32:47 -0400
Received: from quimby.gnus.org ([95.216.78.240]:48176)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1noydA-0007EY-TP
 for 54399 <at> debbugs.gnu.org; Wed, 11 May 2022 22:32:45 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=8lw542tEa8CTpiORuIfVe+4VWXY59Vy8JNzxY5Rrnc0=; b=n26UTtY+zqWDfpa0P3mkx/S5Mo
 xIhOi9zEkRcjpqEDh/UUHmkxIvdBMvj/SlyL6ueyHI0CXm63D73eGpA/ymdODkzkal0qC5zPLk0qA
 7kKedK1whdccyLELH8UKp3NQ8O9gWYdmqIswxXYmF1XfKlik41Kj5eU+ZS1xuvwLpsJU=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1noyd0-0007Bw-CG; Thu, 12 May 2022 04:32:37 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
 <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
X-Now-Playing: Anne Clark's _The Sitting Room_: "The Power Game"
Date: Thu, 12 May 2022 04:32:32 +0200
In-Reply-To: <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
 (Ignacio Casso's message of "Wed, 13 Apr 2022 14:08:50 +0200")
Message-ID: <87ilqb1nwf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Ignacio Casso <ignaciocasso@HIDDEN> writes: > I've also
 made some new changes in customize.texi after I sent this > patch. They are
 equivalent to those in the docstring of > `defcustom'. I didn't see any new
 version of the proposed patch in this bug report? 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Ignacio Casso <ignaciocasso@HIDDEN> writes:

> I've also made some new changes in customize.texi after I sent this
> patch. They are equivalent to those in the docstring of
> `defcustom'.

I didn't see any new version of the proposed patch in this bug report?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 17:22:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 13 13:22:49 2022
Received: from localhost ([127.0.0.1]:53867 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neghd-0001Ee-Cy
	for submit <at> debbugs.gnu.org; Wed, 13 Apr 2022 13:22:49 -0400
Received: from mail-am6eur05olkn2049.outbound.protection.outlook.com
 ([40.92.91.49]:26018 helo=EUR05-AM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neghb-0001EN-EQ
 for 54399 <at> debbugs.gnu.org; Wed, 13 Apr 2022 13:22:47 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=f3FmJKsSdu0HQxpHSwzknlD5Od6gGcgAQ6TDbCLxc/IdqbzPAREeu98taSSoAblna1VZKk9rW6qEBBinVj1pSShPKsDCnr0QXEox0gEgqEyOYaCV8BO5bP7sgNT5l8jdXGaQ3yGhnC/HZh70vgxIFjt8ilXv7UzafK8oFRgYxvmnvC8/5TJH+pi1IkK6FcMdA/oFwSV+5C9anAnlh2NHbPXuEC1Bci7/GQifY7lZObDUZXF9+1saIm7yjSPOLB4Vi05IGAVysmVdC/txGRlPdrmN94Wy8Y+AygJQkHMtq/WCz/nM8ry1pNZacT3HX0FjGxuDuOxWHBt5alVnQdIKqw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=cZlEIM9X0Vy0L/pSupSW8UHa/PhnJpeGs5ihlYfGMCY=;
 b=KIhZpBnO6DT5VbyB6rHN8MiFRqSC1xsyq6ZAwPfIL0Y5dfvuvJDOSetpn4UJGviLb99r3Ad5EvHf+WP6slLAUQuV/j5kRfdeO5A3Uoh0LK1PK8JZSVwWZkhmad6g3j0seFjDMUCm7oPna8QipAGMOELaxbHs/6a4DB1Y/MT9ZDCDP3Frt+m5SB0L0tYQQ+hC1J6voetE+qJ/rG6GKse4tL+iA1wjRAj42K3UFg5uCHZa2iD8MJ0ZKRtEzo6+zSBU866of4Ditomq4UbbwEm1aEQoH/ao6Z3/lU5qgDRva/IsWb4DOyD4FZfKsMD2W/J6MsiYQ3bGd4shaka1BxSm7w==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=cZlEIM9X0Vy0L/pSupSW8UHa/PhnJpeGs5ihlYfGMCY=;
 b=K0//VRwGJVLbqvFf8EPJ6MtchhroeLPa/WyGq1heQx22IC2QnPg1RBJB62JpVey/fgHCv1ao0/ZnTsu1ycuAaAQaFExSTQ33ZpX+JvTPMGx40mTZrvctv0uhmqMVCRnLWJ6I3oqjErOcyqX4Sy5tkS+mgwYe1b02oQt9uhLiqYaYGyfxrHfYDM0MZEDNS+LRX8ttErBJhBHdLAZSd2oMC3roCBN56N9M46pJlyfTfnEGhoUBZNAYVlv8dSxO29w26+2IrjGXlDKQ2MFibBVILuP453YcyvKYMGsu29mvQKh9kOKCaZbd07aL+LeMIPghfNXvSgrxkSOdLr9KSnXt5w==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by PR1PR06MB5819.eurprd06.prod.outlook.com (2603:10a6:102:10::24)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Wed, 13 Apr
 2022 17:22:40 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Wed, 13 Apr 2022
 17:22:40 +0000
Message-ID: <PAXPR06MB7760E7320B219C531C730E8EC6EC9@HIDDEN>
Date: Wed, 13 Apr 2022 19:22:38 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.7.0
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Content-Language: en-US
To: Eli Zaretskii <eliz@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <83r162494n.fsf@HIDDEN>
From: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <83r162494n.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 8bit
X-TMN: [0wQ0o6kS1z039XHMb13O0mtU9rrgaQEH]
X-ClientProxiedBy: MR2P264CA0047.FRAP264.PROD.OUTLOOK.COM (2603:10a6:500::35)
 To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <6801b671-debf-f460-48e5-7214a132eef2@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 4bce3208-88c0-4d39-87f7-08da1d72369f
X-MS-TrafficTypeDiagnostic: PR1PR06MB5819:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: OT9WU4wTaSelKYFqYis9flNsS/tSId6G5o977gJksRCiFSIC0yazIUlSU8PY0YdR0thCKHfx92JTE7EXp4XHiqcrjtYvr+JlB8TLb0QpQGzw1Z/yot/8jkQzBRr2hBGak5jwuR3xdc5JSlsq1bff2O2zjWE0gqwhdRXe1veFuIc2uzGWK3rqiUpAYCrqpI6ByVL6OHgS5YzIelav4oNHcji65HPmCxKKeUEQkrNuPC2iqrc/L21aiuNOO5EN/ior3Pvrgxid7O+W1uhn0/YLvpDMmb/9oNztr2a7/PYSeueeMENYOBpTuOt2TVt7ba+mIEmOL57FqCE5sorMVU7IP+vr3DhfiKd042uMaRGG4xcQ/5pkkPNmWnjdWk6Cs0YJ0PE6Iw/togQO6wXClEaQ91yTRracUNZplI/nPMn99F+GMOTEasjmp3YnowF6Co5Up1wp78bWoY1qLEJCL67yoMxfQffMg3N8VbH0bEDoUx20KVOB45gZtcpWQSOc0Fal36Kducnq4+Uecx3G3lhl2F7rwwIy9+DODtBryGGvaOrhJwlUSzhP9LavDmKZ2jrNXQg2QgKo8ukKInPPF17/2A==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?utf-8?B?VTlEMnJxUzA5Q3d1aUR6NXBWT25aQUN0ekw5dnc4SmVBMVVNaVVON0NKMGRs?=
 =?utf-8?B?SHNuYXhMTnVPbThKT01hemJCNHkvOTdOR0RBT29LYi9jVVNCME1DQ3pVSjJo?=
 =?utf-8?B?ZFNmem5rN0NsakVVdFpFN0RVLzRZbTVjSkt4UmlURFVobStmc3oxUzVYdkMr?=
 =?utf-8?B?YnZqWXlsdEd2K1BGS2xsM2pvR0NtVWo0c05ubWZMQXFQRVlHZmpPU2hNTnRt?=
 =?utf-8?B?K0RBblluMFNiMmJRdm1NK1BCZFVkdUJNRlJidmZtbStYTGtXbk9aSWZ6KzI3?=
 =?utf-8?B?MmZGRVJXWGZGa3NZaWNjTGxLMEkvQmpzcXJhcFFYcklOcm52aE5ZK1c1a3pa?=
 =?utf-8?B?aS82MFppYVZSbXVkSUtXQ2VPT2doS2tTWTVySkJFWUw0dFU3LzgzTFNGYWhK?=
 =?utf-8?B?MzhMODZ1TzRuWU1JMjAwWFNBejZKQzlQMzh3WG05NEU5TmNNeUJ0VW5vZTlh?=
 =?utf-8?B?NGMrU3Evclg2NmJoMlNNck9odzVrQWxpZ3J4S0FuRWUxOHJrVjZjT1Z6Mmdv?=
 =?utf-8?B?c1UxSXNIVUJVdllWb05oaDAxWDBIcWNBK1RUOWp1eEpEYXlQL2o0SEZ2V2hC?=
 =?utf-8?B?dXg4eTRVVHI0cGdWK3VvYWFCbEN1NWdsaHFUUi9PMU81eEUyazJjcy9FMjdn?=
 =?utf-8?B?Ti9BOTN3Y2dFWHpTWXJ0V2lXUkYxbVpqODhWQVJ6ck1kZU1BbkFwQVAyVDc0?=
 =?utf-8?B?M1hNZ2RYd0lOVVNKcks3YXRKWm9BL0RQazlUNitxREh1aXR1RTVMdUI3ZjRI?=
 =?utf-8?B?UGdtSlI4ZWc4ZkV4bDAybkViYVBvYmsyYW5qY0V2R3dmdFFicmViTzJhY0Vk?=
 =?utf-8?B?OGFpWC8yVlFlc2s4dU9qcnBqSlhWNEJFMm5CUWJLTXN6S0pHVkgwQTZSVDUy?=
 =?utf-8?B?Z1I3R0hZTC8ySGN0NDl0NmJGMThXb3NUaUtjL1RFUFdBT05rMDgzSjVPYkxh?=
 =?utf-8?B?c2ovUUl1MlBXbGxNTit2SnpkK2NWQXR3UWIyeS9CTGxuZDlJZGtMWWlVMkpU?=
 =?utf-8?B?cW1zdlNKdnhwaWxHY0lKek85V3NERThEZUwrTkhkZWFINmt1N3c1dUw0U2th?=
 =?utf-8?B?Vi9uUHpQbkUxNlFMUWNWNWpVUU05QVN3MzBJVnVrMGxUOUs1UTBPaldwV1dz?=
 =?utf-8?B?aHBZbVhmMHlvbUkyZVBLaDY5UmU3V3VkOUN1RGRTcG80Z3poQVVSQWhrTjFP?=
 =?utf-8?B?dDFocFVSYUg0bU80eFFHdVA3TU5OWkNCUlJ6UWRlNENKWU5aYWZleG9XKzBn?=
 =?utf-8?B?bVFLWDVGNVBtQVNWd2JOckxUYmZRN0VEYlFaS1g4MzVVZ3lDL014aWdPWklH?=
 =?utf-8?B?dmliQXVhbzl6VmZMNW9BRmFSL2RBM2JUN1c5dlRST0hlaDdlQjRzbzIxOUFQ?=
 =?utf-8?B?Qk51OCtCMEsxaEpmZTZmV0tXOEszWEZldHAzMktnN0hRZEJBWThpamJsYkhp?=
 =?utf-8?B?RWNzbThuSTJqWnFkNGdrNWtEcWo5VnZ6NDdHSGlJd1BxdDlXL0Q3WUdick40?=
 =?utf-8?B?YXlLamtxdE9pU2Z3aHV0WVdWTlFkVUFORHFJcDMzV2Vhc3dZaGtFOVpKWE5Z?=
 =?utf-8?B?MnpFVHpRNUh4V053dzhuTUJKenROU0hHN0k1WjJmTkdGZjZtMlVsbncwYnE1?=
 =?utf-8?B?UHVtRE9DbXczYmltNXQ4SlF3bCtuM1FUa3VUSUtvM3VidEJ4ejR5ZXBKYktW?=
 =?utf-8?B?ZVRJL01ZdmhkOGZnK29JcGRPV2hRT0psUFVpL252enp0SWIwajJsU0Z6RVVz?=
 =?utf-8?B?S3Z2eFN4YUM0V2pPam1iZHl4QzNmRUF4V2lMQkhsbmFzSmxCUEI2WFEyRE84?=
 =?utf-8?B?Y2I4dFVIVFpBS1ZTbVlvTUs0SDRjd0s4Y1VlektJaHZSRVV4UmpFZDlId1BM?=
 =?utf-8?B?bmZpeGN0bXpzRHdZaTVaa21EallMb2ZtYlk5dy83V2diRUFjTC8xV01URFAy?=
 =?utf-8?Q?eOW88hcGNsM=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 4bce3208-88c0-4d39-87f7-08da1d72369f
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 13 Apr 2022 17:22:40.9060 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: PR1PR06MB5819
X-Spam-Score: 2.6 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Thanks! It seems mu4e can't visit mbox files,  but I'm trying
    it right now with Thunderbird. Let's hope it works. On 12/4/22 17:24, Eli
    Zaretskii wrote: >> From: Ignacio Casso >> Cc: Stefan Monnier , 54399 <at> debbugs.gnu.org,
    >> larsi@HIDDEN, michael_heerdegen@HIDDEN >> Date: Tue, 12 Apr 2022 14:16:34
    +0200 >> [...] 
 
 Content analysis details:   (2.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (ignaciocasso[at]hotmail.com)
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [40.92.91.49 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [40.92.91.49 listed in wl.mailspike.net]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 -0.0 NICE_REPLY_A           Looks like a legit reply (A)
  1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla
  1.0 FREEMAIL_REPLY         From and body contain different freemails
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.6 (/)

Thanks! It seems mu4e can't visit mbox files,  but I'm trying it right 
now with Thunderbird. Let's hope it works.

On 12/4/22 17:24, Eli Zaretskii wrote:
>> From: Ignacio Casso <ignaciocasso@HIDDEN>
>> Cc: Stefan Monnier <monnier@HIDDEN>, 54399 <at> debbugs.gnu.org,
>>   larsi@HIDDEN, michael_heerdegen@HIDDEN
>> Date: Tue, 12 Apr 2022 14:16:34 +0200
>>
>> P.S. By the way, I had deleted the previous emails on these thread, so I
>> could not properly reply to the last one, and had to just write to
>> 54399 <at> debbugs.gnu.org instead. What is the proper way to reply to an
>> debbugs email thread that is no longer or never was in your inbox?
> You can download each message of the bug discussion as an mbox file,
> and then visit it in your email agent.
>
>
>




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 15:45:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 13 11:45:22 2022
Received: from localhost ([127.0.0.1]:53689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nefBK-0006tA-MR
	for submit <at> debbugs.gnu.org; Wed, 13 Apr 2022 11:45:22 -0400
Received: from mail-oln040092072082.outbound.protection.outlook.com
 ([40.92.72.82]:10149 helo=EUR03-VE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1nefBJ-0006sx-20
 for 54399 <at> debbugs.gnu.org; Wed, 13 Apr 2022 11:45:21 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=GsKV3LppNL3gBs1hDQpB6ihEuuEXEVPEoGkQ2p0W1P6KNecxPzvjoz8G3uXIIABs2lgJ+cBOawaepYX6lk2yPpzdtI3p2xNhp9WPNDczt8O+Q6J75gO2yBmaTHY30pKUAcvDLrY61FlePeAVZsOursiXE37RdeTNDfOpOGJNWCDa3O3tDzBHmtyKYioGlctS4biiytGz1O6FWOCrpBUzFaDF1QXRySILAgdi5e5+UrmuTubUdrjEIN8KTQcbNYjgdKbcBOM3/B5tp9RdlhCXrLFx8uWk15/6j5pV1MRGLJOEBiO85cyPgiB9dtatX062QDgWXjlT0mHq2MnnzME8zw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=KvWuLzaFS9VApR+Izv2RuEpqSziQYmH9IQaQWDlnMfc=;
 b=n4phhoDQblmkbozmQQLK9VI6TpEIvs7lWwYHNsLcYOj3RP6uNG9Cwf7xqpOOhcojhLJkiU5EM1s5WXTbgmv/mtphAP5/t6FAZeILi288kJXM3BGeYFNGn+/jT5R7ZSG/bpumaWMZk9lFokG1OUWJguovJZdr6Ck2YkIdpiCieX5o1avC4ASLrCTY8onIY6bUiiMXdEwltNpUB9zzTIKXS6/w632GGD6jBbaR2rZV6j3qTKqLAl+KBrTtTNKk/Sa+stLhbJ94qQOmdU+3aVv9S2idYtYamY6QnoXwXAyzvIISv7cy+LoD/4biiY/kuzzeR5vGUOcLUsqbZGcGKqog5A==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=KvWuLzaFS9VApR+Izv2RuEpqSziQYmH9IQaQWDlnMfc=;
 b=mrUAZUz1POg8LvwQiRMm3ipOm6/xk4hYrrVx3KiHWD9Q+h7vsr5HVk5nwn9Tfh5Igif6sfxE6EsngDv0zAAx/c6VvlOWgQtDG9vUnubO6FHq9YQBWiVGlpxktCFkgbMGm7/LCGj+o5tvLLxX50WfyZw9fc8rabO+s7PURJVsT16jHoJ2tUcEmz+lCDn/hdbfr+BU4uc6mTWFoR6E1mKeNfpgzVuwun7lnIcTQUO2eXRcYFEy6Rou/FvfNHHCmn/+HOwIdsO06Tc7yJa+PoDHobvogSxUYGKBU412BrK/68e4bLDVqUwMHygs6Kdt6LDmTCB95qPyfvjWvTkqPH0Nfg==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by DB9PR06MB7372.eurprd06.prod.outlook.com (2603:10a6:10:23e::16)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Wed, 13 Apr
 2022 15:45:14 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Wed, 13 Apr 2022
 15:45:14 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
 <jwvlewae47o.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB7760DF105CE1221A4B6B1FAFC6ED9@HIDDEN>
 <jwvilrearb1.fsf-monnier+emacs@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Wed, 13 Apr 2022 17:26:07 +0200
In-reply-to: <jwvilrearb1.fsf-monnier+emacs@HIDDEN>
Message-ID: <PAXPR06MB776009D49A585C9FF1B864EEC6EC9@HIDDEN>
Content-Type: text/plain
X-TMN: [XqW2hYNncuv2xWDLUsyLxhTldNuNuIvL]
X-ClientProxiedBy: MR1P264CA0107.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:50::26) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87k0btj8cg.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 737b2fb3-e205-4332-6aa6-08da1d6499ba
X-MS-TrafficTypeDiagnostic: DB9PR06MB7372:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: ODTPMahRQi+0kXn64ME+A83LtD69SA0La4/3TONpmmva/VWHg6udtOY8Uq7ZvyN8KuJa8uKtnRb6nVpDG/EOC/A2EBQJSsI+rjiS0Tz4kr8Qw0Jre/Rw7o5NoRBDH9OI/0ttjsmsFTBgYY7PPb6QmeMVKQK5uBejlA7IeKW3jBHgKO+RiLye36ai0hSz8C23HwFPQ+HjWhG6E0vY+j/WZAstDIYJKMBjmsv499u4ufkvlJjA7GZoAKdLpws9G5ybUn6AKbRN4FXpopVZ3XrqUF+/YfzC43c957dH8oqSLJGm/y/W7CGupLARodiRMkqQheVDtTY1pPSHThbg5lRgnIF2wFcI1OnWWeZh8aefOKBg/FDpiwSsll3b2pX/P3FfNAvbcMshJyS4hQzUQkkQJqR0xo5Ax11aKfu1Z1BOdNfgHM2Ebh6lVAuzUs5NCvzh4Lu7TbxIsjOsYK3jI+GMvP4WNa8LS1wfbXKJkPNwnxaqpvCPilYPYzjC2c110rO5o9FExB7v/us3OUHS5cr0nH9avQIgrWJ56IXKHcGVEgXMTMNvGQkxGGn0QevUfGPc3IiiJov3BfcnHOoqvv7I2g==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?gJ9PY6dKw3T2xEOQQEokL8Iu7iwIXFbK0i94LPaE0yk9h+2Lbp8XVhHppo41?=
 =?us-ascii?Q?7KXG2KJkS1wHhRp9SfBy6yDTrkCFzUg0bu3TlRZiNDjV4sEpwaFgpcZkaOTT?=
 =?us-ascii?Q?Hw7iMOuNnXON6A4ErTxA1NiIPHItHZM97RUu3zXeY37zSpYgefVBAWsKuSqn?=
 =?us-ascii?Q?G/ghIbT+6OfXR668c/BF5tIDOm5/mwG/qcVq3qzP/+AEJxhKO6CT/Bqzr97Z?=
 =?us-ascii?Q?hZZMmshyklV3AHfrZRsJ14CPrKEWzbhfozqF38mRTERRLtmValiUOMBckTpy?=
 =?us-ascii?Q?ty1c49hdlAgVO9s/Nse7ybyn4+PZPkOHRM8tI6Jl+de9LONhwVkh5ndHDOtL?=
 =?us-ascii?Q?gN52UYnZIKLoImkJQpqkUd5gjTKqmkmgZ6BQxM7KMw/36lJrJNhclii7UqDb?=
 =?us-ascii?Q?8JGmfjSMvrM6wOgakoAsN2Ud0+n/cF4cJsd9PSQWac/kM31TZuwNeZkhVpZf?=
 =?us-ascii?Q?fMQ9Sb9KzH1Orq0R2AwrauuyphfkDuiMB907lXgHUaV2YzsW357zWnlaeNtS?=
 =?us-ascii?Q?x0ZqZqUjp/nVhEeK+jCzs+c3a+joa/FZXtShQ1AklbRgENmvDVSZw1uRvipg?=
 =?us-ascii?Q?EiIwGFX6dr+OB+P/aLGbCIYqmcsvcpgbTJ/4s1Q918X59wh6jV7Wr9Npaqs2?=
 =?us-ascii?Q?RfiichZ7JR09DHz9ywVEHwGW7pAqWZNLDCytt7K73j4QnpWi4lPFMCuInLI9?=
 =?us-ascii?Q?rxsFby6sRNWsV7/YQsTFnJEgIvwoCvM3rcV15vmhF8jNNaxj8cTjuFvP+9DM?=
 =?us-ascii?Q?AQXlE6MAZujiwD6Qp8FLiNqXx/Wt8Bj51J3x6751LPBbQY0pX/R01Xc9oMNV?=
 =?us-ascii?Q?aS++oE2Qg86YTtMIxDcNJTYkJ+uVQnEjAQ+8WCkNKi19FxE7JZ9xzFcg7jus?=
 =?us-ascii?Q?72wy6iA9koSKoBM6f2YHpCdA2lgNpjiwlxVh/HKOfl/k95k+Kw+cPOYBvpho?=
 =?us-ascii?Q?28k2f4I/JQkcPebw0yA6ShH6mdjV96rjvS9CdvPVf4wc/9pULq1E858J9Ek0?=
 =?us-ascii?Q?nHsZYnrw4G8MFSSgz9NJNljzoMZiQ7xuoXXHMXWYuKdiDVzLLAX2G5BU3vBP?=
 =?us-ascii?Q?ca1c0OPaEq8un8xVsgH0FQRaEfPxjJdspbDCMH7NNfbzrQ6/0Pw7uoo/mttP?=
 =?us-ascii?Q?DAxMK8pL8Vu4lvPD1jC2aQwZcA419uBFPWMdIKzYTrZcBur6f7Jp8Tb6DuhP?=
 =?us-ascii?Q?ASYcaEQx4m/uLIuWYpP1djqsxc7rxuFlEbewLOw+t25Gq5xd3HWPTQyr/sOF?=
 =?us-ascii?Q?q//w2OU5wVca/0fG98HmT8YAw0EaQHQcmGvxb66b3zFtolS5Zxnl/0iGywHN?=
 =?us-ascii?Q?otzECfPGCKaAZ6Le3Hxhllfe2jB1VW98//DnE4aUyqzRg/ZFZyMBX2Us5z7/?=
 =?us-ascii?Q?QVyj8v9xoAmUUzT/Q5cevb5EGcz85xLW5+T2YpaP4gu0WxHKq5ZVisqktpLq?=
 =?us-ascii?Q?hPlXXb3NRbo=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 737b2fb3-e205-4332-6aa6-08da1d6499ba
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 13 Apr 2022 15:45:14.3318 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB9PR06MB7372
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> When I say that `default-value` operates on the buffer-localness, I mean
> that the difference `default-value` and `symbol-value` only differ with
> respect to whether they consider a buffer-local value or not.
>
> They're both stuck in the current (i.e. most deeply nested) let-binding
> in either case.
>
> IOW, the choice between `default-value` and `symbol-value` lets you walk
> along the line between buffer-local and not-buffer-local, but it does
> not let you walk up the stack of nested let-bindings.
> Only `default-toplevel-value` lets you do that (and it only does that on
> the non-buffer-local part of the space: there is nothing like
> `symbol-toplevel-value` which would let you find the "top-level
> buffer-local value").

Thanks, I get it now. I didn't know that there were different stacks of
let-bindings for a variable, one for the default value, and another one
for each buffer-local value. I though that there were only the default
value, the buffer-local value for some buffers, and a common stack of
let-bindings that shadowed all of them.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 13:12:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 13 09:12:33 2022
Received: from localhost ([127.0.0.1]:52070 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1necnQ-0001vm-OH
	for submit <at> debbugs.gnu.org; Wed, 13 Apr 2022 09:12:33 -0400
Received: from mail-oln040092075043.outbound.protection.outlook.com
 ([40.92.75.43]:44100 helo=EUR04-VI1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1necnO-0001vY-UQ
 for 54399 <at> debbugs.gnu.org; Wed, 13 Apr 2022 09:12:32 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=nIpXPw8GpGP6F17IWf0QmnizjTMsai+qewLMGlODk4hlXi5xQ2KgfIYyuo0iHObcOkysKmL38YJhHqXtPSPQw71EHuKeZathq32UKV4PYBYpE2DOk4vuKjNugPU5bqltterORprl71HhGOn9lXTnw+fbl5KDfunGaQz4nANIc8aG7lT/pyG5S3s8+9xcZ0SwokLpNGvwDKytvr4pS12OUEd6OMhCAM7jAJwKgkN6u7q4SvG03u82EpySMk7P8u6fkDP+qoSn+Fk+jFTubG0a/1JSFw9DL2YVKedL2i8qFn+OMau6Fu7MkC3QqfRT/qDfuabkVXMs+t0DmLBbKaPN1A==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=2eFd4iXARXSeitnGUYkes9aukYsKTPH/mbskJy/dFAA=;
 b=W0ZDFIUw2mKbTdh2VXy+c6q1DSnW/RuQSG/RdWjPB/X7ojm1bYZ851rPtsCaWxy7rICDkCpnc/4Cl5gCoW8uIsLTa5otu0C9f4bwcrx+XsopNtRQl/WWos/bi+D/eMOSm0ENMO9Jj5nVDKNdqtOIY/lGwOkXtclPVcgreZPcTXUZDGJ9LR3PvVgDsdDObs6nx6h0O7ODVkEMMCPiw0BV0qaOPR/SvpqaJEndwpNNjNrwbL14Ka90ioYT7OYLgfwaucB1y4ChOD+R3mWJpNw/hJJS2ivMGbBlKGBw/hqGDXTApfwTezKXWkrfQxX1W+/Ht73Yg7liz28Lr8UkhAGOzQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=2eFd4iXARXSeitnGUYkes9aukYsKTPH/mbskJy/dFAA=;
 b=UnipKXwukmUnhQcwl2ewraHXuqWs+3lOor0wn9/tuWe2fmRqaSqCLWbqltDUmfn2C3FHBNi1ewF9wYiHgeMH5MiztR9rfCGReRmZZEeJ90/s11P0srAyPdDFHO0EKDcnUJLSM5KmIzYyrZZDfSLpTesho5vkge1+xZO0HeOixjJnmRSDdxmfQ2eLWBh80XuhHnmCbEMAxRoY1cMu45qMxbT0QLFza5Z4nnhb/fDgdPLYFJh8U0BwEmRmEte/+Dm3ouc+BZTRVGpXiViM80JlsocdCJZzTa45pZYcGsp4JLX+UqXZeVy0f3CWFlbdUkbA2Ru2Zg3XwB5q4/xMunnVeg==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by AM6PR06MB4646.eurprd06.prod.outlook.com (2603:10a6:20b:66::32)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Wed, 13 Apr
 2022 13:12:23 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Wed, 13 Apr 2022
 13:12:23 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN> <87ilrdg837.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Wed, 13 Apr 2022 14:08:50 +0200
In-reply-to: <87ilrdg837.fsf@HIDDEN>
Message-ID: <PAXPR06MB77602D6FBDBE71E180D6850FC6EC9@HIDDEN>
Content-Type: text/plain
X-TMN: [5daSP5X7x81ZbD//9GoUBeyXYgpl3Lv+]
X-ClientProxiedBy: MR1P264CA0086.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:3f::31) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87sfqht9e6.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 3817b653-623c-405f-8c24-08da1d4f3f7b
X-MS-TrafficTypeDiagnostic: AM6PR06MB4646:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 3pumq0I6YLWMeSU94cQIpXda5ta541SJxe7zijoUI7nL/QTJnKul9jRFewpOVRVc2/Fm9qJUu13FiqRBCrKLcqrYftzh4OaJQZAvDRIGaw5/HAhMlNU5qm1fFb8x/+hQBX6BIZvOsUDNmu4wkRVdRzQuR7o5Wn774knIkA2X3Q6Zc/fBFw537DTU2mhJbDeCbgwmzT/gfJ1TlyCNo1W7SZdwSmlj8frXAY/AKx1AqBmX+58+IqmggNObfE4cXt+M6lk8+wTormLCE8Q2LGriDnbsqdXi85Zc1znhpWh6B4temKwX6wufB9up3YleKfpJKRJzucSkKTvLLFJzW4PJev87ioSJiBVHfZ14gGrFjtv9QQb8qVYsweI3TgUvZKEf8EOOLvEN9cYQp5vmBL4Gm17qrT0zPu7nRfIEoxBWLnPeLhEx/yYYLWTCAevsKlDkN8kvQ2uqr51CLy/VnrcGDYnw6gqksdrbqasjRdHQA+ObMWLZGfS33DfwsQBn1nFwO5nhx8T8rBTb8kUAnZP+ifAHFMR/sYssVhXggyLqyz2/g0mg2yPCKywxVHLJ8fCBno9d0IyN+OChCPydtQYhTg==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?1Zu7AZDLNBz9KocZLyVOfJCiQGecUYABlUCqgzfG+qVNd0MhCyC87lwepZzL?=
 =?us-ascii?Q?LMWtbpf/O3GvzsggfbN14guaGodZil4bqJhKo31DO2FGrvWYkoxp6B/98t4K?=
 =?us-ascii?Q?2PqKz9E45pwuyYSjdtoFJTsgP/Cgymd0rRZzrMFtoddGpBQM3X8nNwzl0Mcr?=
 =?us-ascii?Q?Pl+UUbpeTYilBjlFCtY+G1EAjNUqvx4TwVfYQqVCQCR6q+/ohmADpSUBVsvl?=
 =?us-ascii?Q?bhE32JWnUjbQ9+NrkHxKrf5B5qUZdmFApvQdgyxzRLCcU7g5PYkv08nOiStk?=
 =?us-ascii?Q?X0wPErMYJNLrpH+IeyqjoubzCFEMmdCoOGmEajsZPwT3EdgTsO4MUuWIlkmu?=
 =?us-ascii?Q?RJs8psdveyYyzujBMS2aYCqwgLKGh/DB2zgmniLDm8ypVL3ezrvnd/UALHQj?=
 =?us-ascii?Q?5uv1mBIBCe/49dGZLM1Z4nDtBZia8hAxAdXAyr/jGXZUAKrrlym7WBlm+KP+?=
 =?us-ascii?Q?W3X8WS133+6EMGIX0UiCMez+yao/Posrzz3ICTtH1wBGwGZTruNyqePzCUxH?=
 =?us-ascii?Q?4XeE2Z6yDlT2j6D48Lmzkl2mvTPQy+VwZi7XPh3Pg72PXxAzzbH0OaHya/6k?=
 =?us-ascii?Q?mjrFT38A82sJpAlhMHXJGg4REW0GirEaFSeeG2OWxlTg90gglz2bw81yj5Qw?=
 =?us-ascii?Q?EhriUHRWyIyZIozNW8iP2lc58RPIABA+IZOsJZc+Gqe4Wub5QgjmqcQ5AZI2?=
 =?us-ascii?Q?XXGMldzjgJK3+GYLll8/bhUcLDNB8A139tmcNpBH4lLXjUJr1n8retApfiay?=
 =?us-ascii?Q?ZA3O70vW744AaetpP20gjkIfa/0Tpu5qT4gVRlVH00TEPEX0+YEE/7OJQEEF?=
 =?us-ascii?Q?329H8+HKLh2artYIbEIoTaG1t/PAm6dR5QhOHYxsSOQmJMdpoANEAVwMEMk/?=
 =?us-ascii?Q?s8i0W0ebEhwWdEP5v5u7RAHSwsaV40mn5NTKE9EvG1EAu+Vl5RPA7xSqqSOh?=
 =?us-ascii?Q?gb49E5qDhDD79ebpLQ0Hvp9cGv13yC0UUOcmJNVQ/bajLQGAdtuHEvp8+L5T?=
 =?us-ascii?Q?TKUsRQaZT660FuIlPaANM8Yl+pGgkXwj9Y9K8DxI6p1/JOb8SRC6fl4SpBFO?=
 =?us-ascii?Q?hJ7H9zaN1upAkU6tbulF2buPuAXC0+4BGTj+Lyju15cKCDxiLSamXoLKpL9j?=
 =?us-ascii?Q?Iz5Lf0lHnagU0UUbUryyg6RzTZj2SkDFsQDbgovVsNoZpAS8I3AcCjTTjHE0?=
 =?us-ascii?Q?SOV2PIY4y9G1nE3Pu1NUfa6vVscRtD/qauvxO2YHX8vYT5HPVqkEVgT+XlZ7?=
 =?us-ascii?Q?EnaxS31y3SwlJfQ14TC8VS+75e4B8IPDqQs9fYqJVRIWmH/CmPuPrN7sZX2r?=
 =?us-ascii?Q?uCg+wz4R6Jmu3Qqt38bfgkfFs7MWf075WM9r4kh11t0vUKSo8nJh90pYP2VW?=
 =?us-ascii?Q?ztcJlpCYVhH3u7Yqrwd3KYPvml49btasdt+TXwOXxGRvp2ucTUXIMu75ciRB?=
 =?us-ascii?Q?wWIiK+zd/NM=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 3817b653-623c-405f-8c24-08da1d4f3f7b
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 13 Apr 2022 13:12:23.7434 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM6PR06MB4646
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: larsi@HIDDEN, Eli Zaretskii <eliz@HIDDEN>, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> > +for this variable. This function may no behave as expected inside let
>>                      ^                  ^^
>> Typo: should be "not".  Also, only one space between sentences.
>

Fixed

>
>> +values for this variable. Let bindings may shadow this default value.
>                            ^^^^^^^^^^^^
>
> "Let-bindings" (with a hyphen; appear several times).
>

Fixed

> But the more interesting question is whether the changes per se are all
> correct.
>

Most things are corrections to the docstrings. I explain each change
below, as I should probably have done earlier:


>  (defun custom-initialize-set (symbol exp)
>    "Initialize SYMBOL based on EXP.
>  If the symbol doesn't have a default binding already,
> -then set it using its `:set' function (or `set-default' if it has none).
> +then set it using its `:set' function (or `set-default-toplevel-value' if it has none).
>  The value is either the value in the symbol's `saved-value' property,
>  if any, or the value of EXP."
>    (condition-case nil

docstring correction, the function used is actually `set-default-toplevel-value'


>  (defun custom-initialize-reset (symbol exp)
>    "Initialize SYMBOL based on EXP.
> -Set the symbol, using its `:set' function (or `set-default' if it has none).
> +Set the symbol, using its `:set' function (or `set-default-toplevel-value' if it has none).
>  The value is either the symbol's current value
>   (as obtained using the `:get' function), if any,
>  or the value in the symbol's `saved-value' property if any,

Same

> (defun custom-initialize-changed (symbol exp)
>    "Initialize SYMBOL with EXP.
>  Like `custom-initialize-reset', but only use the `:set' function if
>  not using the standard setting.
> -For the standard setting, use `set-default'."
> +For the standard setting, use `set-default-toplevel-value'."
>    (condition-case nil
>        (let ((def (default-toplevel-value symbol)))
>          (funcall (or (get symbol 'custom-set) #'set-default-toplevel-value)

and

>                  symbol
>                  (eval (car (get symbol 'saved-value)))))
>        (t
> -       (set-default symbol (eval exp)))))))
> +       (set-default-toplevel-value symbol (eval exp)))))))
>  

Everywhere else `set-default-toplevel-value' is used instead, so I have
changed it here too.

> @@ -262,11 +262,11 @@ defcustom
> :set	VALUE should be a function to set the value of the symbol
>  	when using the Customize user interface.  It takes two arguments,
>  	the symbol to set and the value to give it.  The function should
>  	not modify its value argument destructively.  The default choice
> -	of function is `set-default'.
> +	of function is `set-default-toplevel-value'.

Same correction

>  :get	VALUE should be a function to extract the value of symbol.
>  	The function takes one argument, a symbol, and should return
>  	the current value for that symbol.  The default choice of function
> -	is `default-value'.
> +	is `default-toplevel-value'.

Similar correction

> @@ -717,7 +717,7 @@ custom-set-default
>    (if custom-local-buffer
>        (with-current-buffer custom-local-buffer
>  	(set variable value))
> -    (set-default variable value)))
> +    (set-default-toplevel-value variable value)))

Here and in the rest of the changes in custom.el I have made or
suggested one of the following changes:

`default-value' -> `default-toplevel-value'

`set-default' -> `set-default-toplevel-value'

`default-boundp' -> (condition-case nil
                        (or (default-toplevel-value) t)
                      (void-variable nil))

But I'm not really sure of when those functions are used, so I don't
know whether they are necessary. I actually made the changes just to get
the feedback, we can discard them if you don't think that they are an
improvement or that it is worth to invest the time in finding out
whether they are an improvement.

> @@ -752,7 +752,7 @@ customize-mark-to-save
>  
>  Return non-nil if the `saved-value' property actually changed."
>    (custom-load-symbol symbol)
> -  (let* ((get (or (get symbol 'custom-get) #'default-value))
> +  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
>  	 (value (funcall get symbol))
>  	 (saved (get symbol 'saved-value))
>  	 (standard (get symbol 'standard-value))

See last comment


> @@ -779,7 +779,7 @@ customize-mark-as-set
>  
>  Return non-nil if the `customized-value' property actually changed."
>    (custom-load-symbol symbol)
> -  (let* ((get (or (get symbol 'custom-get) #'default-value))
> +  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
>  	 (value (funcall get symbol))
>  	 (customized (get symbol 'customized-value))
>  	 (old (or (get symbol 'saved-value) (get symbol 'standard-value))))

See last comment

> @@ -1054,12 +1054,12 @@ custom-theme-set-variables
>  		     ;; Rogue variable, set it now.
>  		     (put symbol 'force-value t)
>  		     (funcall set symbol (eval value)))
> -		    ((default-boundp symbol)
> +		    ((default-boundp symbol) ; condition-case + default-toplevel-value?
>  		     ;; Something already set this, overwrite it.
>  		     (funcall set symbol (eval value))))
>  	    (error
>  	     (message "Error setting %s: %s" symbol data)))
> -	  (and (or now (default-boundp symbol))
> +	  (and (or now (default-boundp symbol)) ; condition-case + default-toplevel-value?
>  	       (put symbol 'variable-comment comment)))))))

See last comment

>  
>  (defvar custom--sort-vars-table)
> @@ -1608,8 +1608,8 @@ custom-theme-recalc-variable
>        (setq valspec (get variable 'standard-value)))
>      (if (and valspec
>  	     (or (get variable 'force-value)
> -		 (default-boundp variable)))
> -        (funcall (or (get variable 'custom-set) #'set-default) variable
> +		 (default-boundp variable))) ; (condition-case ... default-toplevel-value ...) ?
> +        (funcall (or (get variable 'custom-set) #'set-default) variable ; set-default-toplevel-value?
>  		 (eval (car valspec))))))

See last comment

> diff --git a/src/data.c b/src/data.c
> index f06b561dcc..b73a997341 100644
> --- a/src/data.c
> +++ b/src/data.c
> @@ -1927,9 +1927,10 @@ default_value (Lisp_Object symbol)
>  
>  DEFUN ("default-boundp", Fdefault_boundp, Sdefault_boundp, 1, 1, 0,
>         doc: /* Return t if SYMBOL has a non-void default value.
> -A variable may have a buffer-local or a `let'-bound local value.  This
> -function says whether the variable has a non-void value outside of the
> -current context.  Also see `default-value'.  */)
> +This is the value that is seen in buffers that do not have their own
> +values for this variable. Let-bindings may shadow this default value.
> +To take them into account, use `default-toplevel-value' together with
> +`condition-case' instead. */)
>    (Lisp_Object symbol)
>  {
>    register Lisp_Object value;

Corrected `default-boundp' docstring, which said that it can be used
to check if a variable is non-void outside a let-binding context, which
is false. I just reverted to Emacs 27's version, which was correct.

Also, in this docstring and the ones for `default-value' and
`set-default', I update them to suggest using their "toplevel"
counterparts when let-bindings need to be taken into account. But I
probably use the wrong vocabulary to do so, and that information is
already on the pertinent section of the manual, so we can discard these
changes too if you don't think they belong in the docstrings.


> @@ -1942,7 +1943,9 @@ DEFUN ("default-value", Fdefault_value, Sdefault_value, 1, 1, 0,
>         doc: /* Return SYMBOL's default value.
>  This is the value that is seen in buffers that do not have their own values
>  for this variable.  The default value is meaningful for variables with
> -local bindings in certain buffers.  */)
> +local bindings in certain buffers.  Let-bindings may shadow this
> +default value.  To take them into account, use
> +`default-toplevel-value' instead. */)
>    (Lisp_Object symbol)
>  {
>    Lisp_Object value = default_value (symbol);

See last comment

> @@ -2045,7 +2048,10 @@ set_default_internal (Lisp_Object symbol, Lisp_Object value,
>  DEFUN ("set-default", Fset_default, Sset_default, 2, 2, 0,
>         doc: /* Set SYMBOL's default value to VALUE.  SYMBOL and VALUE are evaluated.
>  The default value is seen in buffers that do not have their own values
> -for this variable.  */)
> +for this variable. This function may not behave as expected inside let-bindings
> +of SYMBOL.  To take them into account, use
> +`set-default-toplevel-value' instead. */)
> +

See last comment


I've also made some new changes in customize.texi after I sent this
patch. They are equivalent to those in the docstring of
`defcustom'.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 03:44:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 23:44:13 2022
Received: from localhost ([127.0.0.1]:51099 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neTvK-0008Ej-FH
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 23:44:12 -0400
Received: from mout.web.de ([212.227.15.3]:55973)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1neTvI-0008E6-W2
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 23:44:05 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1649821431;
 bh=2Bg2s+0N9Ty8lAIYhwLQcSYvjCvtx7iRj0O1KunFHFA=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=i1ObugMMagrmGkpWAziZP0zadwMhTUeaj0JbmOZyVQp/GIsJL0sNifQuE/JB0HxxZ
 YfQxykUQZqFtt0fuflkfcai6gxHxisDxdECixqrkqw2fW6kIIBoL81DEkkcPpgYaCN
 vmGTRAqVIV1pHtrWHvNVfCm1bFGAscbHxmprRTUA=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([109.40.242.21]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MRk0k-1nXItQ40R0-00TOBX; Wed, 13
 Apr 2022 05:43:51 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN> <87bkx5g78t.fsf@HIDDEN>
 <8ee21zmrp.fsf@HIDDEN>
Date: Wed, 13 Apr 2022 05:43:49 +0200
In-Reply-To: <8ee21zmrp.fsf@HIDDEN> (Glenn Morris's message of
 "Tue, 12 Apr 2022 23:26:50 -0400")
Message-ID: <87y209ejgq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:Kt505bWyTYo1eEoHMORVjYPsrJGsqmQsT7VJW6Bia8s5UFGcCY4
 lY8eafr26Lb8X5VpiumI4E8EuCFu1zabQR77lTc59ppx9fcrwhg8QzDDokVFgngPnPoinhO
 V31a3TzpKU6LyccCzV2+7al4Lpk502fokLG5/15gzWjJJPunNxUnUUJAhq/bK2Dy4rqvgTD
 Yl+H72FBM2q2s2qeuWkOg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:gYz9vO+c5Ss=:5QDUcbeVMQQZ6P+5hKAd9j
 Yrm7hS6yQjt8HmzdCEX5JA7qrN59uqz57VpRB1lPI99asZwlgKDwtIu3NORz7ZISXl+3gmPD0
 +p3idf7E7JAq7rgHF52g14I+SWe4y7OmuFgHYM6Txb5Tij3VhkuzODmJILSwaFCNeWQqJw2FE
 S0Y44G7tkxJZCCKBOHBqo5FSZwclVadDLsZ2lRexOC+WZUW7QjOIXonDxY93hZJU5tcizcYb1
 W8ie3L383R06vkm5s8dLFVLEAatTVcpofZ0/QqrL+ly9HZzXdAZsQfaUfqd0v0Dx03ijx7W4X
 mRFknh9DbBwvYlgVhWvyjpifxuA6JHAvw50uLrnu/dUxNoZkaG4BeZNw2tpHsu+rQX3j+BvsO
 FKoCcwu5xRwFN/ni8JpivbAgUg3iBh4S7Zej/SOWiZVK875vOpt/YsoEopbHzvs7LKD0nJ3GG
 OuNSyoI9tbM7vItsibwecp6NpjDE+pF9ij8wnVTSwdZSCrjtC2ow5bSK5onDxNvI/zLQumUpB
 7Vkfbz6iqGFnfHuJDP4bFFL5TcEZd3rgzYnkRQ/2thoyLVkQrpQWqfHZsfp4FP7W0TxdrmXpq
 OmqY+YOJTzS75i+NqKZkakqb4gG8oJ+2Y3Gi3waAE4MbFwseIk+qkg2c/6parP1sNupaqb4PT
 TCCMS9/oYUO0gxvmPe0Un0YlLyu1Bh98QO4iCm6I2QYGgZ1yVg4JURlJI169cytxIWoYdaz2y
 pDVAfvtHvISoMUOqcYaRn6I00aatEo0bChfgSqf7Vls0XUu8OGSjQcTDdnTCf1vs8CC1mGg2/
 JOVsA3r8Pu7336Ew3khwnEOuh4fBJAkVlzO2+ulPYoLG4yDa7+7OZmbrgOHwjkMF9QoXWtdQ1
 MkcECeTMS4LtEF+m/P44ca2AUimGHJpDowm6ZN8obhBg2S/VZ0ILdsT3b1QmZOSyI7HiubOX/
 faqP6TLTC/+TjQgcGRL369Mn1sgqAkA22CVM4woRdl4T/R+MCpHjWx+BUuwdnIS05eDBzTAdp
 7NyKBMmt9dfFWBybTfOT3LermFnNslhFz0jdNGbW3DVw+h4E6e8LYHliCxQMZJveyi/w8SZ5Y
 c8/WvkwqF753VA=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 54399
Cc: Ignacio Casso <ignaciocasso@HIDDEN>, 54399 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Glenn Morris <rgm@HIDDEN> writes:

> > If your mail client allows it you can also read the newsgroup
> > gnu.emacs.bug (or gmane.emacs.bug), look for your message and answer per
> > mail "from there".
>
> Please don't post via usenet for bug reporting or commenting on issues.
> It creates various technical problems.
> Please forget that gnu.emacs.bug exists.

Thanks for the important hint.  That's why I said "answer _per_mail_".

But with the right setup one can have a convenient workflow.  I more or
less never post via News, but reading the bug threads as Newsgroup is
just too convenient, for reasons like this one (how to respond to the
correct subthread).

If you can't ensure that you never post via usenet, then it's better to
forget gnu.emacs.bug, agreed.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 03:26:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 23:26:59 2022
Received: from localhost ([127.0.0.1]:51048 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neTel-0007ko-AD
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 23:26:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1neTek-0007kb-A4
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 23:26:58 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52990)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rgm@HIDDEN>)
 id 1neTee-00041B-Bz; Tue, 12 Apr 2022 23:26:52 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=Y4nPZBs2oRO3rc+WlfYQ3c/vMAELg/XBWy/2mmgToSE=; b=Zulr93Gxl2SvxyIme41t
 p7i9yGBBbmSP+V1sDVgoRdijkxz01QgsIrjX3iIsjK0X8GBNQya/RuBtegKbE6wUh+noh61hIT0KX
 zpHwGWUrk4OmqFay7RKmafwt1ceNS4sRoAV7LulJeqVQGWJGkrvf4yBpLooaI3fWzRvSDuqPCT+yv
 N3UTLg5nsN55+hXNZozTP3SSRXfqc45eG6MdD4qKunkrE8KJYeBA/Z7EYYdoijsto3JPlvd2owLn/
 a2nDdLBuu94aPfkZlDtEhZuICIJrQME4uqqgM4igehPkbo5OEhPKtqlsIoAJKzCJAcXAKppL30ztV
 x4TwrcBDAx7/+w==;
Received: from rgm by fencepost.gnu.org with local (Exim 4.90_1)
 (envelope-from <rgm@HIDDEN>)
 id 1neTed-0003zA-2t; Tue, 12 Apr 2022 23:26:51 -0400
From: Glenn Morris <rgm@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#54399: 27.2;
 Problems with (let ((custom-variable ...)) (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN> <87bkx5g78t.fsf@HIDDEN>
X-Spook: BRLO CDA Standford Prevention militia Sarin IW USP
X-Ran: "Mk_<,EAA}l6`|*{S}c)PrN%8Rt/$.4xP0"XS/#OhyyuVKE1Msvb*swQ(.$zztqpI!0`bR
X-Hue: brightblue
X-Attribution: GM
Date: Tue, 12 Apr 2022 23:26:50 -0400
In-Reply-To: <87bkx5g78t.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 13
 Apr 2022 02:24:50 +0200")
Message-ID: <8ee21zmrp.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Ignacio Casso <ignaciocasso@HIDDEN>, 54399 <at> debbugs.gnu.org,
 Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Michael Heerdegen wrote:

> If your mail client allows it you can also read the newsgroup
> gnu.emacs.bug (or gmane.emacs.bug), look for your message and answer per
> mail "from there".

Please don't post via usenet for bug reporting or commenting on issues.
It creates various technical problems.
Please forget that gnu.emacs.bug exists.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 00:25:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 20:25:04 2022
Received: from localhost ([127.0.0.1]:50688 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neQoh-0001ji-Nl
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 20:25:04 -0400
Received: from mout.web.de ([212.227.15.3]:52863)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1neQof-0001j8-JG
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 20:25:02 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1649809492;
 bh=03UmmDA5Y5eGIhdGfRKp7rss1DVfb5/mhyw6MfdtPsk=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=s2By1uEJMpgtqGtUcH3T30kHkXy9ksC8jWJKfyKiiokhlJHgzXHFU0U505l3gzTrZ
 sJQzXGfoor0SmtDkn9m2ekMRU2BCDtZaG3m2CWxVtfes7D2/KMnlhgm0LggcYQWRAS
 nkV6rVynmK4rAhqCGRT97YiMs6e8mUzZqk01XY0Q=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([109.40.242.21]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MXXRL-1nS8rc37lP-00ZBaR; Wed, 13
 Apr 2022 02:24:51 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
Date: Wed, 13 Apr 2022 02:24:50 +0200
In-Reply-To: <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Tue, 12 Apr 2022 09:35:14 -0400")
Message-ID: <87bkx5g78t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:CvPmmNZZScC3+N/QyDaNXoyKIuOA74bwKch8R4FYHGFdfYmRG96
 SF6sBHD+c5nDPYWr0iqZRWSyCP28zidttFuldk1JAqh4b660wX4+T0+cVdABrUflCBRDr9c
 CwNQ4ZY5aKsc+Gn2kWUbKqzshSczGdMPJ15e9/DMC/U53uPcmVdL3yfcXeLcZvO/yf+Ugwe
 dMj2z6psKg9cEz0kjmLTg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:kfOiYhZRKuQ=:S9ZPkZho5A7ttX9UqeRjcW
 cJn9khN61gHzNVjhLNDdrrzU1WyH9j8JmlvFXD2LE6rHJgwE4ZIRTOIUZnVvHN9kIFN0LRJYG
 EjY7mLJJ5tw30O2XqCAoKkQflqjbIKgmAl3XUigTCPgaSis70u03JJObeXZQhrVawaRZct1bh
 EKCMljbb7jTEW3N4EuKiwzHQKK+x6N6CVbEm0Wubmb9O5xz/WEoNMasA0L0O+spUdbgDaKlIp
 MTsHy8pb/ktX3TuGWMZadUoawDKJ/AjO8eezYmAWE6HeoIDhZG6RFcsXuMuReQk++S17xhqhm
 iMx0uKPhqf7CBu9n/n+brLKd6hhjh0oZ14yRc5NhaZ0ncElUq6Pg/+22sUfElC3YJa/iudK2f
 LRSzTBtZ2gna7euwj1mV3dQ7AuaUAuthlTgMk7zVszRoYLoeHcrkMbfXCMKeHNVPz16ed+ICE
 1mTIu/GnKQejqsFADrIWYSUNYaxYl5kiKZTC66F4m33PyuUGnXjFIqL2T8i/DidG20EOJ6yYL
 fIDy+s/P4gyWor0GkQV00BK7NrAh+hIApdtQyn+J1EoQp1UmwMwjCfUE8E/kGdTK1PdYDH293
 ROFy0bYPY57e//HsM3WXTLQkGNzSY4ZOLy3vpeJ7m4b3/Uhv7ZNWMCbZnetQ8UjdchPSCtfzk
 yJtOpiHKfpWlySsh4rDxyG42wVTSohMbGtKPaR3VfRjP9SdWjzt8UZFDToBqXj+kxX5v9ULBA
 deyrhYLM0Sq2CQBOOriIY0EOPuS5hGxRVnnxXBitX/QyZxpt2imZG3XtnrH3NEDS5tmwQsEK9
 1lSB3Px/1XVYYHqlBoTPFhIkh+wCGzK1OVr1qpK4ZWX4j3tzYGKluGjYf/Omdn3j1b5cm9ylu
 u7nL8OmuRsAAFs2AP1E/P748+aIFkut1NA6AIoillK0O7Xvz+ce+rTk/FuaJL7B6+u58WUEY7
 NzI1Yf2Ff7RUbIcNo7mV264DOl/MmwOuCyE4VoVRzaLMEcH7qe5DpAGlbFwVClGrblXy4m/LR
 1x3JKZ2Dtwed/i3oxL/ZsPO24+8rC1XP/MoyViWo8Kwso641KKmKzvXoADU9GeVVcbv8dUa5B
 RTi/qcoDqxEjXE=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 54399
Cc: larsi@HIDDEN, Eli Zaretskii <eliz@HIDDEN>, 54399 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> You can M-x gnu-emacs-bug RET 54399 RET and then you should be able to
> select the message to which you want to reply.
> [ The name is not `gnu-emacs-bug`, but that's the mnemonic I use, and
>   the completion does the rest => `gnus-read-ephemeral-emacs-bug-group`.  ]

That, or the "debbugs-gnu.el" bug browser interface.  But then it's best
to use Gnus or Rmail.

If your mail client allows it you can also read the newsgroup
gnu.emacs.bug (or gmane.emacs.bug), look for your message and answer per
mail "from there".

(AFAIU, there is a "References" named mail header that controls the
associations between messages.  Gnus allows to show this (normally
hidden) header.  When your mail program allows to use given references
you copy from somewhere as part of the mail header that composed mail
should be correctly classified as an answer to that message.)

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 13 Apr 2022 00:06:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 20:06:53 2022
Received: from localhost ([127.0.0.1]:50660 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neQX7-0001Fq-4a
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 20:06:53 -0400
Received: from mout.web.de ([212.227.15.3]:36497)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1neQX5-0001Fa-AT
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 20:06:52 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1649808399;
 bh=GP47CWbnE2QOaawqS+Hp9dyfphwaQ4+DMqdpkG0ikKM=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=HCIXXhZ0W6sgNTHxKjphLyDlU2b7b1XJ9N+nJAbyo8b+sSNfdHYF9s8wxBmWbIzAy
 oCjlfxhw6yZR9QnMi7UyHsDC151owhawBN/mDx6ypZsRENGTVOT3XM9CRCZyfhmCVd
 d2ZR1yztj588ReM1NAPiYtfJ7/+BY1arKbxj0tIM=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([109.40.242.21]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1N30dV-1o6Rm60u4L-013HSf; Wed, 13
 Apr 2022 02:06:39 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 <83sfqi498s.fsf@HIDDEN>
Date: Wed, 13 Apr 2022 02:06:36 +0200
In-Reply-To: <83sfqi498s.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 12 Apr
 2022 18:22:27 +0300")
Message-ID: <87ilrdg837.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:Fav6KCQ6u9BbsT+Hof0LmaFBvY3cCh1c6Jb0lE4DYJRMfZ3RlL3
 XhEDYKQm9NpPOQEnn8EUF4KwT801mb/9KiwdFmgeX1/WU1AemZveXEGRm/TrlMH/BAL7kaB
 vLuPH4CHzuSceJOLK/ZZn/z2iBuYIHSKGSI0lkIK71vGFgGUzYZWkAIu+wNWH6IdwlSgcDy
 CqGPssqwVjpZbBxpqF7Sw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:yjFguftBbV8=:NgoEgcX6/ZIZqEPuj3wSV0
 EKlwLkiuWAOaxdTKwgSVDr+vFDytTlIpSkyNIbVQZlKpyMvpi8IJZ2JlX5L3JdQX2Dllba8wo
 xTPm4sbfzn2v3ViOq1rgCUyGPftw3I6pbTpKYjOUQr/bTr0f1dkuWGct0r6BWfyncXZ84hYDJ
 HsO0XKL8JIEW/wdwfg996aWGq/T0xrUt+S1/yxvSf+Dq/tKlFjTBtZvy4xv42i0yaN5CfMxLS
 1LdLKmDIv+J8OnfgS+3lXrsHp+kg7bhrUGwO5HZY3Z5CUR6XiwppMIuGOTUBB5SrJ37b5E2E+
 IfTt79NG/YBqXNvocLIM1YRqjTjCP6e99jEMCj4iYVQAN9Uq5lF9bxNixPA8RUjbVcvV85C+8
 jYEjWN0rfSldmDxNUxmeZejnX2Jrs/bZQ6zoVHvJ6OeT1yB+v2F9vkSJ3x1W2b1DbMwZaflqq
 NcbERc1zSRDJ75avHVJJiXtHFgldMD1ojYKAbDMhyusb0EwHRmRtI4pm5+E6vMuIcLVeUztXd
 Nd47YpDPbIy907AqUvOc8zs+Sl67OgjYPWvI4ueO80fh2HHtsr5X2Iyon0sI/+GAilXbgM2pd
 FBkoxhEIZ9atONEX86bt1WK4yYYxaeECbiM3daHwoRpP4K2+YDfA8sOkF+61rXVhPSYOt7Y+s
 6Hb0ErG29oX5EGc/QPAULEIU1GxPJmiMy7AOUNJbd4u3EJrfeEcLSwZs+HoTAJbf8z3BNI4aF
 b43LPG8f781BXeDuUgJoBtwgerR6gW8hpn7uB9CmPTV0LppNZn6XxdWTgWf6IlUNKEFZqMp9l
 UC/DT935BqII7ycszNE2utpvwrg7r1fz1DvjbEbgLmHOWdUSXxOLX0WNMidXwU1cWppAI+E11
 rRPVuoPlWQe9ZNJ5Nm9ColD1g99xNIAwU8ccvmAxBQn3iacF4N36/JgZodwHP4xVP/cRgMRLz
 kMRFKnihcirF3pEerSFtRgkD29khcAq0aNitx/FRhccPlBweoJAYyNvrPWrVg2/S/xeyykXHr
 7/jRA4s8GlA7HgXo/tmKNuHA3yFZ47OgaXmOPFC55wXxhHwEOyCLynwqxn98yIH5iSvKkDCiR
 SGX+X67pJkAEQU=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 54399
Cc: larsi@HIDDEN, Ignacio Casso <ignaciocasso@HIDDEN>,
 54399 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> > +for this variable. This function may no behave as expected inside let
>                      ^                  ^^
> Typo: should be "not".  Also, only one space between sentences.

And

> +values for this variable. Let bindings may shadow this default value.
                           ^^^^^^^^^^^^

"Let-bindings" (with a hyphen; appear several times).

But the more interesting question is whether the changes per se are all
correct.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 22:15:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 18:15:28 2022
Received: from localhost ([127.0.0.1]:50480 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neOnI-0004Ud-4N
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 18:15:28 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:2200)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neOnG-0004UP-Q0
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 18:15:27 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 77815100166;
 Tue, 12 Apr 2022 18:15:21 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id EBE47100091;
 Tue, 12 Apr 2022 18:15:19 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649801719;
 bh=jBsUTYOBcs9MXbTxgW7vSoYX+fYClEjUoRcnDwDVo8Y=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=dQfg3hVYIF25WH+5Uqbyd1fv1bgSwppBnyo+16MWikOBvmVeSTlPX1YGf5YfOXp6k
 PpbNCHdm77WWzamo7+GQcmBNawXun2a0S6TY9hJIuRch3LtbQahXLdUZF+A4R2/zR9
 8op7W1Kl0suAydWPzPFenhM9x/lGb8WlgS3ieN5QsMhIYoF0dZp+kM64Fi0WS7a6mt
 z1hRWDI1g3eXila/pInb1TgBHP/f0qHLB6S4UrxTf9O/+H+/o/u06vtpe6qyUnZ3wA
 rJxwwFqbbZQaBSg7VYSnoGRFgC+8VcsTv+ROX/pXqfRly4K0zxGwQqmkNW+iFSHq1Q
 tGuZFHyvoJ/ug==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 9AA70120328;
 Tue, 12 Apr 2022 18:15:19 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Message-ID: <jwvilrearb1.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
 <jwvlewae47o.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB7760DF105CE1221A4B6B1FAFC6ED9@HIDDEN>
Date: Tue, 12 Apr 2022 18:15:18 -0400
In-Reply-To: <PAXPR06MB7760DF105CE1221A4B6B1FAFC6ED9@HIDDEN>
 (Ignacio Casso's message of "Tue, 12 Apr 2022 17:27:04 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.048 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Probably because I don't really understand all the concepts involved
> here. But I expect functions that operate on the default value of the
> buffer-local dimension to behave the same way regardless of whether the
> current buffer happens to have actually a local value.

You're looking at the dimensions in the wrong way.  It's like when we
split a window in two.  Some persons will say it's split vertically
(because the two new windows are stacked vertically) while others will
say it's split horizontally (because the line delimiting the two new
windows is horizontal).

When I say that `default-value` operates on the buffer-localness, I mean
that the difference `default-value` and `symbol-value` only differ with
respect to whether they consider a buffer-local value or not.

They're both stuck in the current (i.e. most deeply nested) let-binding
in either case.

IOW, the choice between `default-value` and `symbol-value` lets you walk
along the line between buffer-local and not-buffer-local, but it does
not let you walk up the stack of nested let-bindings.
Only `default-toplevel-value` lets you do that (and it only does that on
the non-buffer-local part of the space: there is nothing like
`symbol-toplevel-value` which would let you find the "top-level
buffer-local value").

> But never mind, I just wanted to ensure that the current behavior was
> the expected one

It is, yes.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 19:14:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 15:14:44 2022
Received: from localhost ([127.0.0.1]:50030 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neLyO-0007lw-G4
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 15:14:44 -0400
Received: from mail-oln040092073031.outbound.protection.outlook.com
 ([40.92.73.31]:31518 helo=EUR04-HE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neLyM-0007li-5I
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 15:14:42 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=VP4YO+VdDJNsGS+AFOt0gYAN9kPqQu9ZEtTpJ7M/36jtZnMIiNJkbfNiF+mHZVhWtZoWhWO7DinhEkluE4sNojbeCyYtnLL15Ulh/eztu17Q+mVVEWVAhsVVYRB+aG39nF8jmx70izqGcpd+E6hpZm5cAit7XemB23XpGQhbCc0X/3QPplHHAlbmWmbUYJmmYSYuuw7S/UFpWKl2XGyjWsSAC6TxpRB1TdWobA3DdhRK96oIo+/KPfkjfTYGc/TIsVmNK2KbvvcgSgK5/Ea7HIT5ma6XZ1DGBbNxlPtlTBqCZGd0055Hcb24Y5l3TJAaNvzQUuh/4t8lZdlrqQIy3w==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=403LbHebQVZsyiRVMYiXlO7yCMryEZctPrFBgcypzEk=;
 b=T9LJo0mN8UKJH9+QBskWjTQYQ5JE+WJfmr1EH575G8GIX9yLsWE/AV/UqdbbADgq2A57EPMZ4n0AgHOvnMYAmmYoM+jwlibgBQhT3+l4IBwc1RpeFD6wzz9I7vfxi05UeBOLTKCeQI1P83PHGVqr/Vw1Ls2lGuXL6B3xG/mauS0K5dyJq1NmREpA0etJIcpYZQNnXcgcSa49SwzEPXrmn137csAiJ7io1d2x88ffDG6z+aazghQicqdOqHtJriYySXrJzUgKYCa8h4XvLOYCk8/aFwwN3jZjptGh1qsceqYQfAZoy0gj68JjtYMcCoejwF5C/y1flzzPXs4AhMgxMA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=403LbHebQVZsyiRVMYiXlO7yCMryEZctPrFBgcypzEk=;
 b=Hm/lyi9kBwCU+y2OyiTjp2VoEn7Av3hKsmo9I/2tEQ/h5RHqVv7QJJMsssPIpmvvRpwny8t3Jjm1Mak36VYzbC0PpTiEh1CHB+4D3anyOn6DGAoi74nvMUS99AjNtulfOe6jivpAGFY07lcBpTTN7EGy76+yflBVw5ICZaMNummiSwJ6jBM0bLySNFrleFpaqY6O/FxoBFMSVJoR5djYdEwyOlEdtGJchBXVTHtyUG7CQLr5OO82VUTXK7wvTZe/EPRFRC9E1TybwMhE7bBNbTCwsFQ51f5G9eMeQ3Q6u+q1KJQo9MfSmPb7p2od0lCmmFDiWiAQEBdBR8f+8e4ogA==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by AM6PR0602MB3638.eurprd06.prod.outlook.com (2603:10a6:209:8::22)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 19:14:35 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 19:14:35 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
 <jwvlewae47o.fsf-monnier+emacs@HIDDEN>
User-agent: mu4e 1.6.10; emacs 27.2
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 17:27:04 +0200
In-reply-to: <jwvlewae47o.fsf-monnier+emacs@HIDDEN>
Message-ID: <PAXPR06MB7760DF105CE1221A4B6B1FAFC6ED9@HIDDEN>
Content-Type: text/plain
X-TMN: [2O37yEfLM8FBaq5PlafESRxgn1UPDnz7]
X-ClientProxiedBy: MR2P264CA0165.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:1::28) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87czhmunaj.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 29471fcc-1010-41f6-b8df-08da1cb8ae28
X-MS-TrafficTypeDiagnostic: AM6PR0602MB3638:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 0CQl7lGbLym9uoXms7+vkQEkgkv7qMiqfeWavwP5lZHjhUT/PESVRqygGpvlVQJdwEKX1BzSigiXYPQH8zJnZzGOJht7XgQ/dfgbZhyXNhE2uncrHsZkDU9oE4PJykywjGGnoI6iV4t4Cc/u7fGS6AA4psyPMDFngE7EpoNtm7zteuH4mriYgijF3k43KHnBB3fJRI3snwYOY3nc0lCYj/c7ILJwBH6T+rmPzaqINN4TYWv47sjbey4YtUE3r9AykZTCVDT+x+SL7FtFhxdWdge0RxfTZXmJDaMpttuxyuMSSJATecY8Lxu7V9y3o6fm+FClrYmUpc0wXoCoCY3GlmfLEC6X8TsBu0YMHHAJbBQGyQdFYls4M6YKtRo8ahSVDWlANLA3qmjIzqaahvAqpLkAG72XFTMfTUgEpEvYi/j4gbP/0HN575RpbUuGETruvaa5VCWzKnuVgl2rq2ynBFsChX+P5QvDxQEGHoBG03qIaLCvu7sBkUQL80f4s2f77XimDMBfAt0UrL2wC0r2NobrVmm3Sda6iEdpzguYf2a2UWO9EwOGwpRtlY9V80ZwblsZtH3Z23nbHNEyENa8hQ==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?up8pwZtwi75gX8u7gYTCcRoi/8IEecQI3lgvDKAAlnGehJB9SMjscqbzTKoO?=
 =?us-ascii?Q?xTdHE8GzsvpWSrBfomGIGdZC3AR8fxtxXepUtzP/CRTK2I1Ycg4WT6OjsvaN?=
 =?us-ascii?Q?HH5YVO+8hPDx/LbRfLw9WaAkwZQDB0IfkILBEl3Lmwp+iau5Sd57tu3DrOFn?=
 =?us-ascii?Q?Te8m8H+w5A8j2rxS45Qo5DgjDB6rtJCDlfJ+EJb2py9XbyJLRNbl45IB24hu?=
 =?us-ascii?Q?tjUzvnmZUhgQVVkLQM8EI/7VLh9hJWiJx3CSWAnfZVh/Jtdl4O69BIi4cbhV?=
 =?us-ascii?Q?id8brzPm4n9pC/pWgESJ/uq5FLZIJD1YpFie0WRkaFd+ymNy5Y0j0/KUVZMi?=
 =?us-ascii?Q?EDY8eCFyPD7wwuXDydIS3T+c0UBbV4IBtIMIJzlpSn/ViiKzmETz9q6sJ/Tp?=
 =?us-ascii?Q?CMHVsmk9dxS2wZ7aJahuYgL+wpGVumzP3yVYBh5sCaVB8XPkG4xocvam/ZiA?=
 =?us-ascii?Q?/7Nnom5rODDw358gSDCM8hvre3CMjmWc18jFFxbAUpu6w7IB7BpG7ef2NI3I?=
 =?us-ascii?Q?VYdZ8FMp8GqbAU84Ppc/NGGtHgqm4CA9X76tuBqdQbFC7sn53JzSy3FrxWKc?=
 =?us-ascii?Q?WNXlGRtGlzseK69xGf3l5J2ad0bSMWHJvUQHynIEgk9qDRSC9CCMSqph6IAw?=
 =?us-ascii?Q?oKrFPI4g2YHuVrzSvijINgmBIu/rPHFKYudKcLfXk9JYDm9WG9GMfZWmGboY?=
 =?us-ascii?Q?0qL5wRoFYDrU6gp+/mPOr1dXkQqqX0+15LK47RqX8lTKqhsP+BK0aS5J504a?=
 =?us-ascii?Q?vQ0AWdcN1tysUrBozYm9XNPYkXqGwIG5SQ/pFZ3xFNXyjkkOghECJdvbAtLD?=
 =?us-ascii?Q?Q+oo65kPx//LPapFlMWYsWXeoRb+Dtn0KUC7B/Ij4+eSq5Q6PCZFg3eQDQQp?=
 =?us-ascii?Q?ADB25AMkwL+E1Zbq5u2dy77rIvFAd8dLzzVB4upgVoC01D58ACxigvtmFO5L?=
 =?us-ascii?Q?FTlYlZXspokEXjb4KVeO/ce5AbjTUVQJIarH9xqi9c768mpH3IrrXABODJQG?=
 =?us-ascii?Q?8w25WahBMQCNDLJrt26MgdY9uwuo6y3UYTSnLzvIGlZcIrjqChEYbHmr2Egg?=
 =?us-ascii?Q?rNu8nb5NrM4rBuwccUt/lSby1oGBr2yL2L5f3v2DlPlPpt1juHHPzfKhgxfI?=
 =?us-ascii?Q?gnPXvgSHt94YlFzf5GOfSXuJ5LTttnrjaawAHkOeaah01bIjf9Eaji759WOB?=
 =?us-ascii?Q?5blX+EauMNPMsjZhcY9f482su2+BqckM7gsGhjUmJQxAVv0C1rj861tZVhzj?=
 =?us-ascii?Q?Gq7CRovqIPgHW0Kkolq+9B/LpjzyLsAs36v2TrHER+SERhLoOJm4xCGyMqeA?=
 =?us-ascii?Q?22Q6yWhwDGJ2oNhh72gEWUse/9qXRhcnGbe+zMfzfOTVAMqt/6Ui41k/YGB0?=
 =?us-ascii?Q?NBTeG3MbnPry6cvkzzCraDM4JsurumqgsXx+z9COZ0q30o1SKdnogcSFwrHd?=
 =?us-ascii?Q?B15fj8tzVlo=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 29471fcc-1010-41f6-b8df-08da1cb8ae28
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 19:14:35.3604 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM6PR0602MB3638
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Stefan Monnier writes: >>>>> ; ;
 default defined, buffer-local
 undefined >>>>> (defvar var1 "default") >>>>> (let ((var1 "inside let"))
 (default-value 'var1)) ; ; returns "inside let" >>>>> >>>>> ; ;
 default defined, buffer-lo [...] 
 Content analysis details:   (1.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 1.1 DATE_IN_PAST_03_06     Date: is 3 to 6 hours before Received: date
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (ignaciocasso[at]hotmail.com)
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [40.92.73.31 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [40.92.73.31 listed in wl.mailspike.net]
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.1 (/)


Stefan Monnier <monnier@HIDDEN> writes:

>>>>> ;; default defined, buffer-local undefined
>>>>> (defvar var1 "default")
>>>>> (let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"
>>>>> 
>>>>> ;; default defined, buffer-local defined
>>>>> (defvar var2 "default")
>>>>> (setq-local var2 "buffer-local")
>>>>> (let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"
>>>>
>>>> I would expect both snippets to return the same.
>>>
>>> That's because you expect the "default" in `default-value` refers to the
>>> let-nesting dimension rather than the buffer dimension.
>>
>> No, I just expect to refer to any of those consistently, I don't mind
>> which one. If it's the buffer dimension, even inside let bindings, both
>> forms should return "default".
>
> If there's no buffer-local value and `default-value` operates in the
> buffer-local dimension, why do you expect it to return a different value
> from `symbol-value`?
>
>
>         Stefan

Probably because I don't really understand all the concepts involved
here. But I expect functions that operate on the default value of the
buffer-local dimension to behave the same way regardless of whether the
current buffer happens to have actually a local value. So if
`default-value' returns something different as `symbol-value' when there
is a buffer-local value, I expect the same to occur when there is no
buffer-local value.

But never mind, I just wanted to ensure that the current behavior was
the expected one before updating the docstring for `default-boundp', and
you already confirmed that. And this is an uncommon corner case for
which I can't think of real use cases, aside from the one of autoloading
inside a let binding of a variable a file which defines that (custom)
variable, for which we are already using `default-toplevel-value' and
`set-default-toplevel-value'. So let's leave it at that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 15:25:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 11:25:01 2022
Received: from localhost ([127.0.0.1]:49391 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neIO5-0004k7-86
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:25:01 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44134)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1neIO3-0004jk-0m
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:24:59 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39682)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neINx-0003fq-HE; Tue, 12 Apr 2022 11:24:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=67kDCOKUtlNG5t/0rPBXHd6vqE6cfsW72Tbeauu3HO4=; b=f9rT2YA1+G7x
 SIo5oNi9WpLV7omfr82XO8BpYzoNXA9hv+lU0gET66q8B6dxcVo0PGOQlParVStGV8WY41eFlMRmg
 mZHEDSc3tbdNT4LTUuRHhLTJds7p4PXIinPmhAqb4Ku5KQF+h6Pu1vOTovP2opZ3zGhb+6xnDA8zj
 /Iai7AUyf0K9F3YyMtmyIHd1m5+/+AIOoAhIUy52vYt8SPixvGWXlEK4Wh57hjWR7zNqunRcuB3tL
 ASjCQhlViDK+ISiD3cq0YOWj+vFl+KwFqGM1d03aS+h16mLKeVjRFWInP94CLWsPdToKx85x2amC/
 sFUQYSnOZZ4aBLAyPLTWWw==;
Received: from [87.69.77.57] (port=2785 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neINw-00088W-Vt; Tue, 12 Apr 2022 11:24:53 -0400
Date: Tue, 12 Apr 2022 18:24:56 +0300
Message-Id: <83r162494n.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 (message from Ignacio Casso on Tue, 12 Apr 2022 14:16:34 +0200)
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN> 
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Ignacio Casso <ignaciocasso@HIDDEN>
> Cc: Stefan Monnier <monnier@HIDDEN>, 54399 <at> debbugs.gnu.org,
>  larsi@HIDDEN, michael_heerdegen@HIDDEN
> Date: Tue, 12 Apr 2022 14:16:34 +0200
> 
> P.S. By the way, I had deleted the previous emails on these thread, so I
> could not properly reply to the last one, and had to just write to
> 54399 <at> debbugs.gnu.org instead. What is the proper way to reply to an
> debbugs email thread that is no longer or never was in your inbox?

You can download each message of the bug discussion as an mbox file,
and then visit it in your email agent.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 15:22:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 11:22:31 2022
Received: from localhost ([127.0.0.1]:49380 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neILf-0004fj-3D
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:22:31 -0400
Received: from eggs.gnu.org ([209.51.188.92]:43724)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1neILd-0004fX-Vh
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:22:30 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39608)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neILX-0003Tk-FP; Tue, 12 Apr 2022 11:22:23 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=dy7sbWzhs3JIaOWV6virFnONp+8lhoksVjMvo/uEifE=; b=TOBu5YJoFcxn
 MeD8o/rnf9OmmSYTVmClsA1xN+H+cHT1V6fEvuJ+V6gPtVxcZaaUqQEjpht2BlnoxEmu4zwaI7Mzq
 cTGxAKENS2nVtHbKz0PldKRB0B9z5kFUUsDlDz1kqSiLyNFpXYoGP3DwI5xuVW0ZM13+bbmRwqPHu
 16zL5C/8e7fj0rWbSeq09NA6sTdnGHRpY/IAe6FBB5JHqOfJGRe1zoswZ2WCG5K++CG73l4h2t8sH
 2/9VYeVMkIDYlJjjGfZhOPjRWUGEuODUdS3T2UJKcAxz/iDs0Ws1hY3RxQLo3FM2E13+xNeDRDWuD
 3Reslt7AQ/gN9z+1w32whQ==;
Received: from [87.69.77.57] (port=2631 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neILW-00080T-S7; Tue, 12 Apr 2022 11:22:23 -0400
Date: Tue, 12 Apr 2022 18:22:27 +0300
Message-Id: <83sfqi498s.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
In-Reply-To: <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
 (message from Ignacio Casso on Tue, 12 Apr 2022 15:51:17 +0200)
Subject: Re: bug#54399: 27.2;
 Problems with (let ((custom-variable ...)) (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 12 Apr 2022 15:51:17 +0200
> Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, larsi@HIDDEN,
>  54399 <at> debbugs.gnu.org
> 
>  DEFUN ("set-default", Fset_default, Sset_default, 2, 2, 0,
>         doc: /* Set SYMBOL's default value to VALUE.  SYMBOL and VALUE are evaluated.
>  The default value is seen in buffers that do not have their own values
> -for this variable.  */)
> +for this variable. This function may no behave as expected inside let
                     ^                  ^^
Typo: should be "not".  Also, only one space between sentences.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 15:05:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 11:05:09 2022
Received: from localhost ([127.0.0.1]:49289 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neI4q-00049g-Qw
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:05:09 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:56080)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neI4p-00049P-D6
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 11:05:07 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id C7C64100166;
 Tue, 12 Apr 2022 11:05:01 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 23146100091;
 Tue, 12 Apr 2022 11:05:00 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649775900;
 bh=6CXw+kFmXwGhTACvY4htDF5MIsKV9Ys054o2E8oOSbY=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=c0jogADrvdbq+D4OyIiDWgjP7FmEF/N9Bi0tvMlsqDlhg55DsuDGrqhzXIjmfRJYv
 zQWQ9OY/48vPckktzXJpaPbJJ6IzksGo4W8Ad4k9kfagfoDCFtmx04upsRr8/tpx+g
 aQrX5O+aq+Q8VXJKDS9X/IHlLoCm9OqugeyKl05pj5My2zE6M7pvhi5a+Gkmg4ENGU
 C4H1qFPixdzLhObPYlQnrVLgx2+q648j71Zw+C2L5ILrKQj+54EDdTmLzlgeQ9JlHl
 R659ilfLdKjaYf1Yn0Xr/+gcuPRB8MqoVWWr9uypfh5jDq5simDjLGFaNnJpp8lTp6
 ifcHPbtucoGnA==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id D9BDA12056C;
 Tue, 12 Apr 2022 11:04:59 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
In-Reply-To: <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
 (Ignacio Casso's message of "Tue, 12 Apr 2022 16:27:54 +0200")
Message-ID: <jwvlewae47o.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
Date: Tue, 12 Apr 2022 11:04:49 -0400
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.048 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>>>> ;; default defined, buffer-local undefined
>>>> (defvar var1 "default")
>>>> (let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"
>>>> 
>>>> ;; default defined, buffer-local defined
>>>> (defvar var2 "default")
>>>> (setq-local var2 "buffer-local")
>>>> (let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"
>>>
>>> I would expect both snippets to return the same.
>>
>> That's because you expect the "default" in `default-value` refers to the
>> let-nesting dimension rather than the buffer dimension.
>
> No, I just expect to refer to any of those consistently, I don't mind
> which one. If it's the buffer dimension, even inside let bindings, both
> forms should return "default".

If there's no buffer-local value and `default-value` operates in the
buffer-local dimension, why do you expect it to return a different value
from `symbol-value`?


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 14:30:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 10:30:44 2022
Received: from localhost ([127.0.0.1]:49198 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neHXX-0003AO-Se
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 10:30:44 -0400
Received: from mail-am6eur05olkn2090.outbound.protection.outlook.com
 ([40.92.91.90]:1249 helo=EUR05-AM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neHXW-0003A7-Co
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 10:30:42 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Z3CVCDTJWVI8gCbIxoVgkH53diN3yjpXKNAysnc2E5AQ4fu0DY2nBMZy8iJZ+ohimkffCRDVXln1jXLwrcrDJndOMgK+3RXo0Vwm7TNs/J9ABls035K3wGvzrKPdciAB7De/oNLNZUdzHuJzXdSpr0KlK8pHtE3eGgKwu3CHFeFIXavJbksMFsKDlfTZy1bRVY/Bq53fuLNafX165uBsbJRSILF2tMlgG60mgiD1z/ofWK5gsAk4eHbhlL5rxkJCYs+fCUu3kDJLClxNa6Su5l/SI3J1L1DMUcaOsOrr23kvxX/nga72UmlK83+jmkAFgUamtkVqQkmn9X3VsMTl1A==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=9Jnaft/rg368E0FtY1KMqFdfckgtKN5eglqgkIfHMYI=;
 b=bLAdn1YSnDz1DkaBhpC+bLC3cqOy00d3stwFhnJidIv45/3Vckn0jSfZvawQubirTwpNFhuWyiue3xKzZbyBR0IbBHv49cpj8VByY2aiKCr1EAW9UEN9/lvEP2q9ETnmwEUSz8scj6IXdLw4uhZVbYHPbSfIBgun0p78lthDo40BzIlGclkLqVQQHbL+pebYknuqtX368dhaq2HJdvDodsmHU0j/Gzw21Wo01CnbGFSIF4BsiEu65jmE9xe9fN7p1Ry06w3P9SlIqAxvEWIFeHftz/Ct4hLaX8b6lJmMRCTPw24Ru82zXNowSKmUB+IwpLbk94p7QfXRU1YakYba0g==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=9Jnaft/rg368E0FtY1KMqFdfckgtKN5eglqgkIfHMYI=;
 b=f4u5FLtgTHv+UTBE224a2dXVe/eyKftSJlUuhSFGddz3wwuD1NLh2KQQV9g/8C9A9wZx3iDTbLI8mo1VvwAxrZETMJAzm/BSUMoh6WiJNPCFy35HCVFRF7Kn0g6Grj2FXvhJtUAv44ZFekOJDKcxSPWEOqtph/jvnEjp0X1AGmc6mhaEdQJRirluOzbUV2qO/+Wjj5R41WJBnq9eZnzXhsaj2ReQYQlNNj7NhZCcQe205ba/ynRzZCZybD/vus9WfkogNObBh+RrlSrhLlSZPco3hxg+y95RFd4Y2h+MspdblWEV8jDHCwJDwsHvcJ17NWZzKmbOcCmF/ldNKZjFsg==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by DB8PR06MB6473.eurprd06.prod.outlook.com (2603:10a6:10:fc::11) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 14:30:36 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 14:30:36 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 16:27:54 +0200
In-reply-to: <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
Message-ID: <PAXPR06MB77606ED65C6E69110C30AEA1C6ED9@HIDDEN>
Content-Type: text/plain
X-TMN: [kSCNkh2JP311aK5twrLCY2LHFvPaL6eb]
X-ClientProxiedBy: MR1P264CA0035.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:2f::22) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87mtgq2x2u.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 18121b82-5f37-4637-26d2-08da1c9101f4
X-MS-TrafficTypeDiagnostic: DB8PR06MB6473:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: mNXPWtBKaWHC+N2ulft85xAAQfQha0EAjt15ZazRIXPd/EdLLr9ESbUPoko9UiGMv/jgiMwC8fMKrXTsz54dxDsuD5Q1h4BiRUoromHcaAlP876eaR0ZQ24z8/A9sT1ZfwSTr+UM7dCeEvcArRvGIwaGfyW8gwPU2FfCcXuTelOrNJDKTfxd5s/0KJqy5arjtsD0Tbc4jCvXYuGBrTPto4gNM+BlN+3p0bd6C6O8atGmXsEVxTMnwDlPq99OZQ9SVl00mrftNedBUtgo5UXYrjYF35ZJnTmZ+QU0hdvVd8ia5dz01OgOVTftdRBQlk1RzKqI+Zia8VMapRncDby3GOeTN4hBMkbDqGVC12f3u2uolW5LDAWiHLsa+jbHvM/uN/sFOtu1JN4QLvO4GmSt9YHP9D3zTw9oWh2ViCpKoBH1Kjtczq5wbaWVA/lgGTEu2bHj/TfQR0mFG/nUKknNO8mhxIu4HB8fW8IL/sTW1xXiCj+G2OsZrkXKBKS31mMUuFAc5gkoThqueQz5lTWTTsmAzOGwsb1RGm3aqMvfYZRY5U3A5RxGReUSd/N2hLJs7xxM7Ucc6PDf8/XMsdEwyQ==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?f+1216YxGacuY3d5Y8KFpAwlJYMdoseBq9aHJIQ3g1kxhhQhj5jMfT+vs1mk?=
 =?us-ascii?Q?b+Y23h9kgiUyPISF1I0DMTpqyoYo/uhQLuI1VMtSI61bNs4jtQdFHD97dLET?=
 =?us-ascii?Q?XYgppu3nAU/0Rf6XvMjN4WEToum0ms80ALOwBHGleLykngKlwbpfyJ9r9yIX?=
 =?us-ascii?Q?vJptOPcuI1AeKv3wxYxW7RwaWBbyn6zSq/0yxjUVIRVn48N/aP1EV504oj1q?=
 =?us-ascii?Q?9eCiwV3BfQt8ubpe4R9lerFPUO81Bd5Jkq3c+hrid3M+HgyDwVTyyYao3PdD?=
 =?us-ascii?Q?kIsBg4sZzXy1PcDCDNW86dmkKss6EThJzsOMcmq/yvGbrftHZfzhLYWoR+a7?=
 =?us-ascii?Q?PstpIgYUXAzzICZeiNsPuUiZc7Z79m672r1r8e5Wxi+NVMZ4Uia81Vj2fpJY?=
 =?us-ascii?Q?oUbrI63wrML3esAGAmCkQfKsqATb+7L/LTDhuWuk4LT+n+SwzLiE+rHps/Mq?=
 =?us-ascii?Q?jNuF8WLyO5zHsR/thrtC6zr4iwh1hz+SKgIz0OPXmtA5zdeqicbGSgfNZoZi?=
 =?us-ascii?Q?1yP1bSy9hJ8z1FGZwatyTCnC0mMnLIm00Ngpk8S+uqdeN4YoMCP8t9/fccYe?=
 =?us-ascii?Q?Lvg1xutl0VWPfuHj62/OiHvBy5lO9BRxYaYQGYygiJ2airHmGKGwVlMLzKSx?=
 =?us-ascii?Q?WqasCSI9mPeOo4vR7ECfD9xiHN0o1TGkQ+6f0ifyrvF8RQ5So0A4gQsEBhpy?=
 =?us-ascii?Q?Y+yzW5Qz8Pvm/7OdVDnUxqcg8uQgQzumH1qOdqQqbXEq3ASjYvBStswxpVWZ?=
 =?us-ascii?Q?YEJe938vH+CybrG0RBHSLxXRXrRuDwjShsh6G5Qzj/bGk9jwwig5BFpEGzDj?=
 =?us-ascii?Q?TX8dn8A3a5S67aBjyC+qo42/FHXC3YZkSkxcIPpHk0B+Gmq82iskjLUu75J3?=
 =?us-ascii?Q?U1OKpebGAtv1lzlWrsNxyMn7y4l9TKsDkUQWIOe84fuQRwt1FP6WH0zaYu41?=
 =?us-ascii?Q?z68ErU37TXOFI1RFydWFdmt0e5aSOsUNvwyAwuMVeZHHxc/PLNeoVUEoZTO5?=
 =?us-ascii?Q?tyUzntZZJXikjGwDxmszT3dL+4FV2eA54zLxVD7ULV9m7NDogXyTSY9dVcP+?=
 =?us-ascii?Q?c+MZnMUpmczcu+KsZYU/KUX+n5GAlyzqpT/3OuUq+CIDjM7UF26KKEH4EocF?=
 =?us-ascii?Q?lC/JXPvXdSu+DkHGTR7AtaJNUX7bJI1BGPrArQ9t+b9eY0JHGl784jiOfxY5?=
 =?us-ascii?Q?ki9aLIvAWxQl7bme6ps2zp3FZ+K3js1gf4wW+V8wFIhkjFYxgs8wpUHSd79/?=
 =?us-ascii?Q?Uxz2DNIW4rUBOHUVadHh8FZNKHGUoaXoG44nAT0Ajn2MkBBIhkHrEFKoXFuW?=
 =?us-ascii?Q?26D927BHQFKXJlOJgM5T0L9Mx01ZH2Yzcirz2D8sM9s4uIwWYMvVAqGf4AbC?=
 =?us-ascii?Q?qcwSLzXUH/hjBJi1NMJwSXfOTgxLYpMPPApIEPq5hHpHMkROP5l8b56M+Bef?=
 =?us-ascii?Q?IFVLvrhR+nI=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 18121b82-5f37-4637-26d2-08da1c9101f4
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 14:30:35.8096 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB8PR06MB6473
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Stefan Monnier <monnier@HIDDEN> writes:

>>> ;; default defined, buffer-local undefined
>>> (defvar var1 "default")
>>> (let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"
>>> 
>>> ;; default defined, buffer-local defined
>>> (defvar var2 "default")
>>> (setq-local var2 "buffer-local")
>>> (let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"
>>
>> I would expect both snippets to return the same.
>
> That's because you expect the "default" in `default-value` refers to the
> let-nesting dimension rather than the buffer dimension.

No, I just expect to refer to any of those consistently, I don't mind
which one. If it's the buffer dimension, even inside let bindings, both
forms should return "default". If inside let bindings the buffer
dimension is "eclipsed", both should return "inside let". If
`default-value' inside a let binding just has undefined behavior, it
should produce an error, or at least be documented somewhere.

But right now is neither of those, and it just depends of whether the
current buffer actually has a local value for the variable, which I find
inconsistent.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 14:05:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 10:05:23 2022
Received: from localhost ([127.0.0.1]:49138 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neH90-0002Ry-SH
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 10:05:23 -0400
Received: from mail-oln040092075061.outbound.protection.outlook.com
 ([40.92.75.61]:47230 helo=EUR04-VI1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neH8z-0002Rj-HE
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 10:05:22 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=c7Z3JwDtKTOgU6Efx6jcnPYRQgUdjZSpTdMqi35/RtSlQiM8Q2dKJpIiVNcmpspIH7YvR9QFugk0RUGgFzv91F1lUmw22mLRSoDXJl5AQ5Gc6CsRLj3n3fMUhKJEH/n0Z1xDRLPtSuSyLM7GrHtuyRKc3PZ3li+Jc33H7NDnOQVGWSedw45W34bx8P/ocvmlyOCXJPtD5wV1t2k2rjIqOjZoozE79XoMT4Nujb4d/qW7MzVH87/PBrtZmU7htaAxYW2l/vOFecYxu7lr6zS67kjFczwGAYGfdp8rcDHVUzojl9gdZdNC0gxI8BxbdlDqFrNEy47oa2kcmjFtSOX6ew==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=oaewNLM/BL3Six/IzTPvwKpcMURnFvdU8uRjguaYvdM=;
 b=X49Crtc1WFjh/OAK4nZvtoQ8UcmqMkTeKXmit8IS4Pd6r0ZufH22FaPtS7vGFlvJEfnX/lrORPEkGX5IuLEIIdJS+wtgaBzO3J6O8rGqS14LBvx5shLe23ocHQciXT8CMrNCFUlkB5Io/PIixpHGyoF+loiG/A47ANmz6TuWIkT+4BwEIi7/tBEP10+mnn20qBmcJ8qc7a+crCOyc4jW3VTAITCBUcunup/0BY7vWs9iSNkltbqMc0vZ9/71etu1/veGzVVWEVe1pJFhXT12tJvXcrNbCWXhkhLhP1LzaW3DlDNkTgahP5chftBsU3UmsAvxEfvEiNhd+g8tm5GPIw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=oaewNLM/BL3Six/IzTPvwKpcMURnFvdU8uRjguaYvdM=;
 b=MU+Hw+xZ6i5MwGxer9Ua64DQ+QgBzNdmcw7qNGWIKUkUc9/XY2RTU5ZqNmoU7/spkKAIZHAb1JUtEQqaNYvX3xcHY4pgl2dvJWTJsBhE/9VZJWnZTdBcAlUziWrKCB2c3gMPlDPBAVXnShU9Nwl58l3AeKWssCdTbM6DXZjCobilJrVtmxlSubBr2c87GpAItdPgnZsCnRX7E40Yd4Cyq7KGSPUiQqZb3zo95QZBkmi20+GQSqSyj2zVwKdxFBxohIOW4CPKB2EfzZL55uAVd6V6NOOoQIv2KUkhMs8HxP8Zk8dcYvVy0HlH824CV0paUzInmDz5HeDy/GhvcTR/5w==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by PA4PR06MB7183.eurprd06.prod.outlook.com (2603:10a6:102:f7::21)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 14:05:14 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 14:05:14 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 15:51:17 +0200
In-reply-to: <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
Message-ID: <PAXPR06MB77600E8276B9E70D2ED02293C6ED9@HIDDEN>
Content-Type: multipart/mixed; boundary="=-=-="
X-TMN: [YumPuMADVSscowCXafqHJCpejAA1Q5IJ]
X-ClientProxiedBy: MR1P264CA0039.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:3e::31) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87tuay2y98.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: fe7713ea-73c4-4573-1c42-08da1c8d76fb
X-MS-TrafficTypeDiagnostic: PA4PR06MB7183:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 9H2eGgWYlfQfF7kU+7c9qfHsRUoNjclDnRlWLPLsvucjyo1PmN8XYBNRdBS90x8BtCeDHTHRdJKbHqRKrk2ZureEIwycFoOJcFXxx6DnMtIMJsHKAl0ThUMswFb5s4Qh283jUgFoZUcx7Iy8JJieDnhoc57ZKkrsQHNCHVNhixAa4EssrL/vs+2kFjWk6Agvri8/1DR98T0xliZbgCCgmr28OKIDuxIgizRNaO9JIEEE2ZjTvSNga/BytiLLxP92wA117gLHod5jTMcZaKoO6Jkst9Fi1+d4//9rsm/lfIqhXQNSUXxRtstLGj4HmzZsGJl5QZ1UUNp/Yaf8LcKEAIVYcS7t+iA93gTu21yf98m1LQjiVHvjMVhMAu9h63rWZVd6ybrjm2vuQlxruxxSlyBKiMI3fTY5xEyE6SK3m7GlAi4juqbrIagjAUGqwwWKpBrS/hu0rNRcOHQhJhSAZWLTaGYEepxlUE4iYGRsdPkd+t5wGRNZrKBkn8JUmAUeGQe/4ZEP1MyfENnX2b67RrKC5SUZapjmySwNNjKZ/MDfdNScWrO0QVKli6pmpdaww+rWBAP4Z4fqViq6hwjYPg==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?vh/HvRZ/LLN9M4P5xReV0snxA5bGfUEi93BGKXLwJMG34kveJVySv2C5pKv0?=
 =?us-ascii?Q?c9kINfArUQKRfKtudMeGAHjCN6dFTMtnI9wcPwiQItisI2ndJ5E7P5BXgbEb?=
 =?us-ascii?Q?+PVVWw1OGMi0c8XUcO5IQCYopxxnTHfpbFUOy2f7LVv5Sj3T+9ry+nnchXs5?=
 =?us-ascii?Q?fdu9Fvr/eYdv40SzY0h4HUNBCMoUJABo3tQDRgq4IBHaOHdcYlZSJ9jtGZ4E?=
 =?us-ascii?Q?Gs5Y8JwLyInEtD5mrR5wfqB0vOYPfRkE5Bxnuuud7cKaZoNIYy4IQzl7ip8o?=
 =?us-ascii?Q?/y8qmqG2S0YRLf4XpcGGQ0A9foQrEmyNMLxPd8xqf3Aq7JonZK0k+iakcBhW?=
 =?us-ascii?Q?gMIgVNdNalwynyv3uq4MXXhZ1nGYGEnoS4purPg9vUtYy8QKL69+TSBXnCs6?=
 =?us-ascii?Q?DAmu0s6nJ8VECsg/NjrzY08hwUSvUP5bgoPeFgVxIIZSKNBe8TuZ0kJ2Fsnr?=
 =?us-ascii?Q?8KXMO1opSx9fXqfYMVmQYi2+PC3Ylup84UTlZmeLjgTgIf0AVqP+EiOarpLG?=
 =?us-ascii?Q?CbdQvLMoQHclbASvARJEtQuECErhBZqWdUctlpqXkrDQIg0+s9fjDoATlBrw?=
 =?us-ascii?Q?zc3/2xjn11kOW9Q2ZHTUIu7w9bsL9ig+31QuRHiFQBKhylWqpQY0m6ei6Itx?=
 =?us-ascii?Q?lom6ZMdXB7r1BuIzFPV5zKw7UIuTCwSyyKzetKfK52R8qwUvLYFQPBzZA5ga?=
 =?us-ascii?Q?KNA/S3sOQt1D+c0fCwtCF4inoLCku/0TpUEdusw2OzL/pTPHth5DHCMeL6tS?=
 =?us-ascii?Q?kXAn7rT8SMJGtGW/6K2DbhO65srPu4TQy7pOp0sLVjqXoCuh0EQms7vb+Ums?=
 =?us-ascii?Q?sjGYt5KV8ggqZgXhgdTvBYwv0wxMi2elsbwtW3CEY1s/fDU/Yo+J9s2Yu78T?=
 =?us-ascii?Q?WLbSAXQljbHfnG0TygAk5ycaUrGSCvS7Q+RWWloXa46Gahuxp4oJeQI2wuvK?=
 =?us-ascii?Q?BN/VgOCgkrph7zKHLtZWFawceOn1dtsIPjRo9XnPPjJt71PKOdSpNcwe7yLl?=
 =?us-ascii?Q?yoBsvk5/pX9YVHvaGGItIiiKtmDwWrCjZgSxNvHJkXHMVhRfSguzAtB1JqIS?=
 =?us-ascii?Q?6O9AidRNj5NLHRNu/vSRFbUH1HcFiJjBjIt9WPwnoYZ90NAnPijzZA94bIAG?=
 =?us-ascii?Q?0cSZKIo4IaRgT24ToMb025Y06IB3d0SK35jr93pGjMdU1DdR38qZUp+xJt/Z?=
 =?us-ascii?Q?T0s74MjSPzcyipI7j5SEFv4X+vvOscZTtKFHqCBY2WjM64TSFF3tMuxhTO20?=
 =?us-ascii?Q?QBFibqUlJfnbl4R3F9qH7w3bov5E2JMAmgM29v394aKTLXpk9PRDWX9Ljzvp?=
 =?us-ascii?Q?A6B7cl4naIkbd/94DDL+/E2EhY8osrY7Y9c8P4jBXlHNXqHu3a9KABbsGzYo?=
 =?us-ascii?Q?SnFnUandIIe7XfG8CvtMUA7wUhMnRnqLMQpRKpdVWcUUfMFTxmhCSBnKrOyo?=
 =?us-ascii?Q?O+4dpNKV7ro=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: fe7713ea-73c4-4573-1c42-08da1c8d76fb
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 14:05:14.7073 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: PA4PR06MB7183
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, larsi@HIDDEN,
 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain


Stefan Monnier <monnier@HIDDEN> writes:

>> Should I go ahead and just update the docstrings so that they reflect
>> this behavior, and then close this bug report?  Or do you think that the
>> code should be changed too?  For the latter I don't think I could help,
>> since that code is too low level for me.
>
> If you can send a patch for the docs which addresses your concerns that
> would be very helpful.
>
>
>         Stefan

Here is a first attempt of a patch. It updates the docstrings for those
functions and makes some other changes regarding the original
`defcustom' issue. For some places were I was not sure if a change was
necessary, I just wrote a comment to mark them and maybe discuss later.

I also would replace in other files `set-default' with
`set-default-toplevel-value', when it is used inside a lambda expression
that is passed as :set argument for `defcustom'.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-updated-documentation-regarding-default-toplevel-val.patch
Content-Description: Patch for bug#54399

From 348f43797e3a126471681e1f5be00bc3fd34914d Mon Sep 17 00:00:00 2001
From: Ignacio <ignaciocasso@HIDDEN>
Date: Tue, 12 Apr 2022 10:48:32 +0200
Subject: [PATCH] updated documentation regarding default toplevel values of
 variables

---
 lisp/custom.el | 26 +++++++++++++-------------
 src/data.c     | 16 +++++++++++-----
 2 files changed, 24 insertions(+), 18 deletions(-)

diff --git a/lisp/custom.el b/lisp/custom.el
index 76c14831ca..e23ca7915a 100644
--- a/lisp/custom.el
+++ b/lisp/custom.el
@@ -68,7 +68,7 @@ custom-initialize-default
 (defun custom-initialize-set (symbol exp)
   "Initialize SYMBOL based on EXP.
 If the symbol doesn't have a default binding already,
-then set it using its `:set' function (or `set-default' if it has none).
+then set it using its `:set' function (or `set-default-toplevel-value' if it has none).
 The value is either the value in the symbol's `saved-value' property,
 if any, or the value of EXP."
   (condition-case nil
@@ -81,7 +81,7 @@ custom-initialize-set
 
 (defun custom-initialize-reset (symbol exp)
   "Initialize SYMBOL based on EXP.
-Set the symbol, using its `:set' function (or `set-default' if it has none).
+Set the symbol, using its `:set' function (or `set-default-toplevel-value' if it has none).
 The value is either the symbol's current value
  (as obtained using the `:get' function), if any,
 or the value in the symbol's `saved-value' property if any,
@@ -100,7 +100,7 @@ custom-initialize-changed
   "Initialize SYMBOL with EXP.
 Like `custom-initialize-reset', but only use the `:set' function if
 not using the standard setting.
-For the standard setting, use `set-default'."
+For the standard setting, use `set-default-toplevel-value'."
   (condition-case nil
       (let ((def (default-toplevel-value symbol)))
         (funcall (or (get symbol 'custom-set) #'set-default-toplevel-value)
@@ -114,7 +114,7 @@ custom-initialize-changed
                 symbol
                 (eval (car (get symbol 'saved-value)))))
       (t
-       (set-default symbol (eval exp)))))))
+       (set-default-toplevel-value symbol (eval exp)))))))
 
 (defvar custom-delayed-init-variables nil
   "List of variables whose initialization is pending until startup.
@@ -262,11 +262,11 @@ defcustom
 	when using the Customize user interface.  It takes two arguments,
 	the symbol to set and the value to give it.  The function should
 	not modify its value argument destructively.  The default choice
-	of function is `set-default'.
+	of function is `set-default-toplevel-value'.
 :get	VALUE should be a function to extract the value of symbol.
 	The function takes one argument, a symbol, and should return
 	the current value for that symbol.  The default choice of function
-	is `default-value'.
+	is `default-toplevel-value'.
 :require
 	VALUE should be a feature symbol.  If you save a value
 	for this option, then when your init file loads the value,
@@ -717,7 +717,7 @@ custom-set-default
   (if custom-local-buffer
       (with-current-buffer custom-local-buffer
 	(set variable value))
-    (set-default variable value)))
+    (set-default-toplevel-value variable value)))
 
 (defun custom-set-minor-mode (variable value)
   ":set function for minor mode variables.
@@ -752,7 +752,7 @@ customize-mark-to-save
 
 Return non-nil if the `saved-value' property actually changed."
   (custom-load-symbol symbol)
-  (let* ((get (or (get symbol 'custom-get) #'default-value))
+  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
 	 (value (funcall get symbol))
 	 (saved (get symbol 'saved-value))
 	 (standard (get symbol 'standard-value))
@@ -779,7 +779,7 @@ customize-mark-as-set
 
 Return non-nil if the `customized-value' property actually changed."
   (custom-load-symbol symbol)
-  (let* ((get (or (get symbol 'custom-get) #'default-value))
+  (let* ((get (or (get symbol 'custom-get) #'default-toplevel-value))
 	 (value (funcall get symbol))
 	 (customized (get symbol 'customized-value))
 	 (old (or (get symbol 'saved-value) (get symbol 'standard-value))))
@@ -1054,12 +1054,12 @@ custom-theme-set-variables
 		     ;; Rogue variable, set it now.
 		     (put symbol 'force-value t)
 		     (funcall set symbol (eval value)))
-		    ((default-boundp symbol)
+		    ((default-boundp symbol) ; condition-case + default-toplevel-value?
 		     ;; Something already set this, overwrite it.
 		     (funcall set symbol (eval value))))
 	    (error
 	     (message "Error setting %s: %s" symbol data)))
-	  (and (or now (default-boundp symbol))
+	  (and (or now (default-boundp symbol)) ; condition-case + default-toplevel-value?
 	       (put symbol 'variable-comment comment)))))))
 
 (defvar custom--sort-vars-table)
@@ -1608,8 +1608,8 @@ custom-theme-recalc-variable
       (setq valspec (get variable 'standard-value)))
     (if (and valspec
 	     (or (get variable 'force-value)
-		 (default-boundp variable)))
-        (funcall (or (get variable 'custom-set) #'set-default) variable
+		 (default-boundp variable))) ; (condition-case ... default-toplevel-value ...) ?
+        (funcall (or (get variable 'custom-set) #'set-default) variable ; set-default-toplevel-value?
 		 (eval (car valspec))))))
 
 (defun custom-theme-recalc-face (face)
diff --git a/src/data.c b/src/data.c
index f06b561dcc..b73a997341 100644
--- a/src/data.c
+++ b/src/data.c
@@ -1927,9 +1927,10 @@ default_value (Lisp_Object symbol)
 
 DEFUN ("default-boundp", Fdefault_boundp, Sdefault_boundp, 1, 1, 0,
        doc: /* Return t if SYMBOL has a non-void default value.
-A variable may have a buffer-local or a `let'-bound local value.  This
-function says whether the variable has a non-void value outside of the
-current context.  Also see `default-value'.  */)
+This is the value that is seen in buffers that do not have their own
+values for this variable. Let bindings may shadow this default value.
+To take them into account, use `default-toplevel-value' together with
+`condition-case' instead. */)
   (Lisp_Object symbol)
 {
   register Lisp_Object value;
@@ -1942,7 +1943,9 @@ DEFUN ("default-value", Fdefault_value, Sdefault_value, 1, 1, 0,
        doc: /* Return SYMBOL's default value.
 This is the value that is seen in buffers that do not have their own values
 for this variable.  The default value is meaningful for variables with
-local bindings in certain buffers.  */)
+local bindings in certain buffers.  Let bindings may shadow this
+default value.  To take them into account, use
+`default-toplevel-value' instead. */)
   (Lisp_Object symbol)
 {
   Lisp_Object value = default_value (symbol);
@@ -2045,7 +2048,10 @@ set_default_internal (Lisp_Object symbol, Lisp_Object value,
 DEFUN ("set-default", Fset_default, Sset_default, 2, 2, 0,
        doc: /* Set SYMBOL's default value to VALUE.  SYMBOL and VALUE are evaluated.
 The default value is seen in buffers that do not have their own values
-for this variable.  */)
+for this variable. This function may no behave as expected inside let
+bindings of SYMBOL.  To take them into account, use
+`set-default-toplevel-value' instead. */)
+
   (Lisp_Object symbol, Lisp_Object value)
 {
   set_default_internal (symbol, value, SET_INTERNAL_SET);
-- 
2.25.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:55:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:55:50 2022
Received: from localhost ([127.0.0.1]:49122 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGzm-0002AT-CS
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:55:50 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:20547)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neGzk-0002AJ-6q
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:55:48 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 50098100135;
 Tue, 12 Apr 2022 09:55:42 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id B5D58100054;
 Tue, 12 Apr 2022 09:55:40 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649771740;
 bh=Lf4mw3Pgq2uLmzLmxAJ2oWM1Il3rMZnsHL1okeibOCQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=pKNV3KlG/BSn8IgGcBQrccYnjO3Mq9gSbKT6kap5dQqlOuSwaKxl2XHeB7k/Nl/CE
 Bt94vpsRPlaVDbSWWNTQIBg41ynvNdREVKhoZQvlv7Yh2ACtbmhCHuQU/2Xm0lrjx0
 bh0rDfM8LJeoq32IcaIUABaRFAvIRGniHNshvsY+8rsZeniMGKdOZ7T+lOvuXM2mxx
 7TcvTSKtXx+J1hn8KnFvXceAXLX9JNB0PrboUXO/FZHn5t1YwPIlxaamui0lIyRgTB
 phK/sJa1EObQpaLWtsla7aU2Z4Tm/biEy47XjIMcvY5jCXA7x6SZpnVkrXZ6NtBUv+
 eY9LjXdjDcMUA==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 7E498120515;
 Tue, 12 Apr 2022 09:55:40 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Message-ID: <jwvr162e7a1.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
 <87czijr4gj.fsf@HIDDEN>
 <PAXPR06MB77607074F280F2DA4C6A49B2C6139@HIDDEN>
 <jwvczhmfnud.fsf-monnier+emacs@HIDDEN>
 <PAXPR06MB776067B0CCB7924BC39E530AC6ED9@HIDDEN>
Date: Tue, 12 Apr 2022 09:55:36 -0400
In-Reply-To: <PAXPR06MB776067B0CCB7924BC39E530AC6ED9@HIDDEN>
 (Ignacio Casso's message of "Tue, 12 Apr 2022 15:23:53 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.048 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I know, but the docstring for default-boundp in Emacs 29 says:
>
> "A variable may have a buffer-local or a =E2=80=98let=E2=80=99-bound loca=
l value.  This
> function says whether the variable has a non-void value outside of the
> current context"
>
> So that docstring at least should be corrected, and either restore the
> docstring in Emacs 27, that does not mention let bindings at all, or
> clarify the distinction in that docstring an also in the docstrings for
> `default-value' and `set-default'

Indeed a patch which fixes these confusions would be great,


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:35:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:35:26 2022
Received: from localhost ([127.0.0.1]:48047 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGg1-0001Ji-UU
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:35:26 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:64437)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neGg0-0001JS-DI
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:35:24 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 63B6410019F;
 Tue, 12 Apr 2022 09:35:18 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 76087100054;
 Tue, 12 Apr 2022 09:35:16 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649770516;
 bh=paF/qZ3yWBjJX3OV8Ys0IAZ45bnoPwQa0ddT47S6CwI=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=bBI2Q6YgHY8MowPE6VozDFFpxLCzphFg8F6dwXnJkPkptgSjKvenvM/HgUC/wgmDb
 WkOq5PX9oyNw19Vbt7xK8nLZ3Cqf5GW2kUz5CiR1kSKlAQUXU+5czpqiTDsdR5CFMa
 uPMqR3Zm4xkbYHlKRXvTRMynIdclse9+jcJ88FRRo7i0hPCCDMk8jWB4QbqWNWPW3n
 Rle4DkTs/mUsQQKUwrT/zco/dwJJSsjMPw0qcK1bdTGgCsAwMVMuRIR4YxJn94ZSfK
 Pyoklk4TNM4xVHJJT4pVoydWroo6auTjrZUHGeqzKUFkkOnqDSKoECfLbeSFY/Oc8B
 8h/y7THWxAtcQ==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id CA7641202BE;
 Tue, 12 Apr 2022 09:35:15 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Message-ID: <jwvwnfue8eq.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
 <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
Date: Tue, 12 Apr 2022 09:35:14 -0400
In-Reply-To: <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
 (Ignacio Casso's message of "Tue, 12 Apr 2022 14:16:34 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.048 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, Eli Zaretskii <eliz@HIDDEN>,
 54399 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> ;; default defined, buffer-local undefined
>> (defvar var1 "default")
>> (let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"
>> 
>> ;; default defined, buffer-local defined
>> (defvar var2 "default")
>> (setq-local var2 "buffer-local")
>> (let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"
>
> I would expect both snippets to return the same.

That's because you expect the "default" in `default-value` refers to the
let-nesting dimension rather than the buffer dimension.

BTW `set-default-toplevel-value` has a running time that's proportional
to the stack depth, whereas `default-value`, like `symbol-value` is
constant-time.

> P.S. By the way, I had deleted the previous emails on these thread, so I
> could not properly reply to the last one, and had to just write to
> 54399 <at> debbugs.gnu.org instead. What is the proper way to reply to an
> debbugs email thread that is no longer or never was in your inbox? For
> the org-mode mail list there is a link on the web archives, but not for
> debbugs.gnu.org. Is there a quick way from the debbugs package? Or maybe
> using some of the info in the mbox file, which can be downloaded from
> the archives in debbugs.gnu.org? Thanks

You can M-x gnu-emacs-bug RET 54399 RET and then you should be able to
select the message to which you want to reply.
[ The name is not `gnu-emacs-bug`, but that's the mnemonic I use, and
  the completion does the rest => `gnus-read-ephemeral-emacs-bug-group`.  ]

        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:30:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:30:58 2022
Received: from localhost ([127.0.0.1]:48034 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGbi-0001CN-DB
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:30:58 -0400
Received: from mail-vi1eur05olkn2056.outbound.protection.outlook.com
 ([40.92.90.56]:62945 helo=EUR05-VI1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neGbf-0001C4-OB
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:30:56 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=N9IYtOpMNgOcJ4htYEKxuaOlMvpB2TJCQ9siCb1Yd+SlUqGywCZGghbMq4DIZwrQqB0BwXhkweJZRKBh8DN1CsCf3qOnApTYwfbPBGbTv8empDgr6ggFxMnfutedo5N4qInjsMkND85ic7hQfmE/bgDWvTtEl7KLzSBGPopV4eJHuuFAs+0tSbjYfQPKlS9V/4OHGbLgP0AZzM2i61iKPfF1/fV9RhtnolyqBiu98lc/ECC9B4dt4JhaQO32a1ZTjVvv4APtXC3Oly5PCWZKRU9OKpp4oqgzicwK/W+VQqZ9QFyWqjz6TQiO0vWyweIdIk42MvxvcGZjMTzS4K0QVA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=BP8+NkLKNcFZ0kK7JnVWcN0qCmrAbgkpMBYRI9N5dpE=;
 b=mXBuv6VuSbEbwv0oQiaokuiSMpcanFHl+cC092uvN8WF5lBj/SPvsgY79Zm1Kv6sIlTV2Yu+VSezpL7SKIh5dyk3RLHV7HLcD/T86S8uCobSdydGH95hXumkFr+zzGNHshKkUUDi6bHrlixYVwLtrIELMtscjdOpxzAOOpFd2L5JyHL1984OcncRM+ZIwqUAOa5Bd7kdkSaYAjZC5MWB1PHcWCx027VlqFk0osz4+Y38bYBoxSfiY+cpjpUuMe3shxiHdSVQyXsSTXavM+9N/oUMVkcnqdoRdOJ2ILql+YXDEBwGP/kRZY+SbhCd6+uUKcy8G6XDU8uCfGvCC0nWMA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=BP8+NkLKNcFZ0kK7JnVWcN0qCmrAbgkpMBYRI9N5dpE=;
 b=ebRikPlQKJ4JkFbMjVZ6z/G+nUMsJoPAq2t5MyzXyYSiy/nqL/K2VTr7OZYQFEJZ9UsqmKSwABCUFrma8hKsrcZFzp6N5iDQRlMbrd9tYkcFmM2vcrsxzlvi6UHxU9Et7x6X9YCJrAVsFgRHIf8bq9zt0pZzxdjzi3zCP5D5htplFdl4l/RtJ/S7WqfR/vYGTebK+6hIuh8CXdfDCXcyMzSNrjGIQP/7bDzhpxULJAgORCzliwq4k5qCAb+WeGA21xsIwpwZMegNJvJgcEQ0MGOA0byh4jylkorbKj20D0qLAaBbjh6zQjUxN0UHYQDRChyYx1ucUAG5ZgHcVh62qw==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by PR3PR06MB7004.eurprd06.prod.outlook.com (2603:10a6:102:93::7) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 13:30:49 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 13:30:49 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
 <87czijr4gj.fsf@HIDDEN>
 <PAXPR06MB77607074F280F2DA4C6A49B2C6139@HIDDEN>
 <jwvczhmfnud.fsf-monnier+emacs@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 15:23:53 +0200
In-reply-to: <jwvczhmfnud.fsf-monnier+emacs@HIDDEN>
Message-ID: <PAXPR06MB776067B0CCB7924BC39E530AC6ED9@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-TMN: [UVfFeG8JbEHk2rJZsRxrIee1CfW2AppK]
X-ClientProxiedBy: MR2P264CA0121.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:500:30::13) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87mtgqig3i.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 3283cfdc-94a4-48c4-bf9b-08da1c88a815
X-MS-TrafficTypeDiagnostic: PR3PR06MB7004:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: OQfxGqcAgenDF7nd1jzEBYXnF9IRqc8rtEcB6SBzj64VGtnqoLO4Kp9O4RoGNaY6h3icZA65IPF0liiMsGryGnSzKwsgCDycfpiEuzqoLNGRgfs94/bS348CQ0bOdRRq0GtitCH4XUmJRJU4SvisCH/u640ZuQbGp/3Hs0PM/XryyTsYIkDwNoMBK00zgspCTDoKxWkBPTpc8t9CFlgZMFUPvXthBceoAV+7OHMiXqhSseDmMW4MkxG7Gqkb8r7/PV6LZUpZdbZUheuTG1XCZQ0swcUq4yAeXq4Es3KaCOm9SKx8cDNu6IeB9WJjjevCvhvevIuND9sX3unbpwK198NvnhLnF2DtUpOlgTIEZh+u4MqMa53ViEELCkTbtLIDkeWDw7Y18npoP4eLYOJhfeMB28FrY/5rTNhmM+Qi3VShJFTnkaO0o+A9ZOhDKf+acrVuYo65KVouV+qVCOo5BqJ+7QymGXmWCfh5GsAqEUm8Kou0xf57taKebtSSN8JwQqW9+sDWZKzGJ2n1cQpWoez/v2T1EKIEd3D2poLL2j15AqWvwN55/ZGwo4ApXUonz3KlZBo92pWpuhb6Phf3ag==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?utf-8?B?ZUpIRFFjQmtyV1BZdjJDcUk0K1V3MzliMWNtbXJ2VEk0ZFJCMXREaitKOHov?=
 =?utf-8?B?d1FSSVJqaUxISFgvRnczSlY1UGJrRXRMa2doMTRMRVdCRXpSVHdVRW91K0dp?=
 =?utf-8?B?SkVOSWw4WFhNS1JZUmtxMWxvNUU3QWtOMUd5b2ZaS3gyUElhVE0xU3BVdUNk?=
 =?utf-8?B?WmU3Q0F6UlZrazYzUmVjZjRVVmtCNGliQ0dXd1pJaUl1bWVwbTNpWkZzdk5v?=
 =?utf-8?B?UUNabllYWW91SzNqcnZXakhUU2V0Vlo4V0txcjFkU2E2V0Vwd3NYYXhpblFi?=
 =?utf-8?B?N3ZZdit5Zy9sR1hueVFRbGFZM01lZGNZR010UXhzMnovSU9OdFQ5dTc2djVF?=
 =?utf-8?B?cmsxWEI4VEh1ZkhNWGxkdFF1UDQvdUc1YUg2MDJJTkg0dm5VMTVhY3VuRGp4?=
 =?utf-8?B?NFlabFl6dlUzUUN2dllBVzYrQ3lGQ3FkSlAyODZxRUtGaE9HWmRwZUdnVTh0?=
 =?utf-8?B?dTErc3BUZm9sV0pNdXRPOUs3dG50a3d4WXJJWU1xOVNhYXhDUlBlU29zZHU2?=
 =?utf-8?B?V0FaUkszVVdFd3EyK2J0VmtkdERuYzZoUlVsNzZOc3FKYUlaWlIyeDJrZjJS?=
 =?utf-8?B?c2VINjBTOGJVN1htN0dkUmZyRGM0QVhJaER4OWV1d3BPdVdxSmVWaC9OVEIz?=
 =?utf-8?B?dWpvYXF4QmdhUFB1WUlmcmxXYXRqMGRyczJyWXNXZEUxSFFpOXl1M2dZbjR3?=
 =?utf-8?B?V2NabnQ4UkNpbVZhcjRWWHFsbTRCc2kwYThmVnNWQ0dFem8wVm9oTHhwRVhn?=
 =?utf-8?B?Ny9hYmJhNTViWFN1dmlyMWVrdjlqU0JzRHhQYnpIL3MwNzlGSlp0R3h1MVk0?=
 =?utf-8?B?M0VFaFEzQUkvZXVkcDRXN2VKQjR0RXBwTUptNHQ3ZXA4SVVnTFM4WXAyZXZL?=
 =?utf-8?B?K2lqVzBwbHhpalk3dk52STFGVmNuQ3h2eVl0RW9EQUxQMSt1cnVhZHJBTEQz?=
 =?utf-8?B?Mm85ak5UY3l6c1JGZWNVd1E3K1g5ZVY4TnlvWkdZM2JYZ3dwU0tJOThscGpa?=
 =?utf-8?B?YlJoWXZOZ2x2bUF5QVJ4VGd0Uy9vQzdoU2ViQlhiYXRNTjYrdUtUa3E1dDIy?=
 =?utf-8?B?TjV6KzNtaU5OdXd1TW9hRHJjYmhBQmV0TzBuQTEwK2xrdDFLUjhUWWpLRmdt?=
 =?utf-8?B?eTZMNHpzV1R3clcvb2JncDl2WjJ3V3lzbDlDcEtVajg1SjlJa2kweFNzVjFX?=
 =?utf-8?B?TzIzQVFROVZFNGFCYmNMS3NSQjg0MXNpRnYwMTZrU0RJejBOVUp0VnFGNlht?=
 =?utf-8?B?K25ZazQ4ZktnOU8vR2tiR1FteEJGQU55VXVMMXpabytLSjlWbloyMDlNZ25S?=
 =?utf-8?B?azQ4bXZRd2FvdUZsKytLUlVxZ1M0bExjeWhWRThRNG9teTlYQUVZamRUL1Ey?=
 =?utf-8?B?U1o4b0JqZmJ6dDRNQ29sOHNZUmtaVEsvcXF0cU50c0hwVzBOb2RFYzNiamVD?=
 =?utf-8?B?cjRuUU9xSWRjVm50WFgvb1NtVVhld2NJM2lvZC9JVVBPUU1SdlFtQ2cwVTFk?=
 =?utf-8?B?OFRxTkUxSVI3a3FGd3VucU51Rlg5aWNWanpLWTkyQmhxQyt6ZS9kUmcwczZE?=
 =?utf-8?B?Z2cxUzlsck9WVzBEbzdHMStZSGNabXdPTDYwYmJtMU1wYWEybW15SGpoSjlw?=
 =?utf-8?B?TGl1V2lKYjRIUkY2OGc4dWoxZDJGY3Rpa2tvNFAyQVFhM2lmc0JkbXFWWE1C?=
 =?utf-8?B?OVRlL0QwdVZnT29lcEtHUXdadFN5Q2Ixa2s4MHFPRnVCYWhTRkxYUll2VTY0?=
 =?utf-8?B?NC9pWFd6b3QwWmNCblJUdktuUTVQOHpXN2dkQ2pnK1hEeElqZDQrQWNjVlFn?=
 =?utf-8?B?RXBneG1Od3oxVm1TK1VjWWxQRmx1TCthNElLNHliNjkwUE05TGtBMm8vSFBL?=
 =?utf-8?B?R3RISzJiT2I4cEdNWHQyeXA5ZnQ0WmUvUFVMRGt4OTZ4Zy9SbE9YWXE5ZkpE?=
 =?utf-8?Q?l4FKPd9V8pg=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 3283cfdc-94a4-48c4-bf9b-08da1c88a815
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 13:30:49.0754 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: PR3PR06MB7004
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Stefan Monnier <monnier@HIDDEN> writes:

>>   (setq lexical-binding nil)
>>   (let ((another-fresh-var 1))
>>     (default-boundp 'another-fresh-var)) ;; I expect nil, it returns t
>
> This means you misunderstand dynamic scoping or the meaning of
> "default-" in `default-boundp` (it has nothing to do with let bindings
> but is only concerned about buffer-local or not).

I know, but the docstring for default-boundp in Emacs 29 says:

"A variable may have a buffer-local or a =E2=80=98let=E2=80=99-bound local =
value.  This
function says whether the variable has a non-void value outside of the
current context"

So that docstring at least should be corrected, and either restore the
docstring in Emacs 27, that does not mention let bindings at all, or
clarify the distinction in that docstring an also in the docstrings for
`default-value' and `set-default'




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:20:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:20:01 2022
Received: from localhost ([127.0.0.1]:48011 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGR6-0000sT-SI
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:20:01 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:51973)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neGR5-0000sE-Kc
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:19:59 -0400
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 5B84B80672;
 Tue, 12 Apr 2022 09:19:54 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 21E7380570;
 Tue, 12 Apr 2022 09:19:53 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649769593;
 bh=KTIi461BM2qXW6ECwk+j1rRIPQys1alpYj12C/e4OX4=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=TRS36QoBJl7JrsoMvPaqSJeo3E4VaXcLRewP6Tq78F1laIHcg9TuQlHZh8T6sbxK2
 Ayeipjqu00N4IJbrtb746FIRIWJiJzW6Bh7SM7aVl2QhnOXyAnFKUcbx0LHBFZw0Zk
 qf+n+ODUXfxd1qLLmGNZztfH7gJJCpvvhACyY2yHBGg67iQsXx2XKU3H2dglwECCm1
 PlFYX3TVit8IqFNK3nhdct8vVN3cQ16VJuOQXF8VEXG0uzddLUwaO9lbscrbe5VAs2
 oTMoJ3JzTwnknkMiFv6LNywbt6Eh735sOomThqq86CIfT5V5BHl7CGmb1qbgaFyzXf
 tbWE4IT1WG8dQ==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id E1EA01201AC;
 Tue, 12 Apr 2022 09:19:52 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Message-ID: <jwv7d7ufniz.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
Date: Tue, 12 Apr 2022 09:19:51 -0400
In-Reply-To: <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 (Ignacio Casso's message of "Tue, 12 Apr 2022 11:13:27 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.059 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, larsi@HIDDEN,
 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Should I go ahead and just update the docstrings so that they reflect
> this behavior, and then close this bug report?  Or do you think that the
> code should be changed too?  For the latter I don't think I could help,
> since that code is too low level for me.

If you can send a patch for the docs which addresses your concerns that
would be very helpful.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:18:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:18:13 2022
Received: from localhost ([127.0.0.1]:48006 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGPN-0000pJ-H7
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:18:13 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:5198)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1neGPL-0000p7-Tj
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:18:12 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 3451B4408C6;
 Tue, 12 Apr 2022 09:18:06 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id C73A844091C;
 Tue, 12 Apr 2022 09:18:04 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1649769484;
 bh=worZ3IguDfeibsY6/NAWQm4RxcLKMq1k/3HFRM0voRA=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=OlOWI/GBhrFLUjqPoJnADeg7Ul1PRwi8vEKh7A8gAqFvCODceP5xUFj3HBInc+Zus
 hZbFHHideweC2Y3hQW/5T9L8kyj63vAn4X98equuUib6EN57p7tw5Xh9X3UvfzQhTh
 hlazhG3VhEuy6LE7RLzkODI4mXUCC9Tt3UMQ3knZnIjV/FaDB5aOlo7Y5PbwNEsSm+
 YJrnszWzF7s8U1VR+1UIPxvAmoKaW42lsqxW4yAtkntm2EHMxN0/hOvmcdob4zVfpN
 JYh6oOLTXODoXJiPcGlZ3lrbVRJx0Fw6ZEC1ULzeDJ/RaknzuJv4Qy37LjGWcBoLaK
 YSsmW996ao+8w==
Received: from pastel (unknown [45.72.221.51])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 8DE8E12014C;
 Tue, 12 Apr 2022 09:18:04 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Message-ID: <jwvczhmfnud.fsf-monnier+emacs@HIDDEN>
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
 <87czijr4gj.fsf@HIDDEN>
 <PAXPR06MB77607074F280F2DA4C6A49B2C6139@HIDDEN>
Date: Tue, 12 Apr 2022 09:18:03 -0400
In-Reply-To: <PAXPR06MB77607074F280F2DA4C6A49B2C6139@HIDDEN>
 (Ignacio Casso's message of "Fri, 18 Mar 2022 10:38:45 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.059 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>   (setq lexical-binding nil)
>   (let ((another-fresh-var 1))
>     (default-boundp 'another-fresh-var)) ;; I expect nil, it returns t

This means you misunderstand dynamic scoping or the meaning of
"default-" in `default-boundp` (it has nothing to do with let bindings
but is only concerned about buffer-local or not).

If you disregard lexical scoping, there are kinda to dimensions to
locality of variables: there's the "let" locality and there's the
"buffer" locality.  They can be combined.  `default-boundp/set-default`
only differ from `boundp/set` on the "buffer" dimension of locality.

Lexical scoping is yet a different beast because lexical variables have
fundamentally no name, so a lexical binding of variable `foo` has no
relation to what `boundp/set` see when passed `foo` as argument.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 13:17:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 09:17:52 2022
Received: from localhost ([127.0.0.1]:47999 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neGP2-0000oA-6K
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:17:52 -0400
Received: from mail-db8eur05olkn2014.outbound.protection.outlook.com
 ([40.92.89.14]:47552 helo=EUR05-DB8-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neGP1-0000nt-5L
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 09:17:51 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Qg6bKfdrWkYx28gKVmUU8wG0SnFUB/XwP7pVsLAK7MCiYo+mu4p8bmlPRttcTHCcPtC/VVgYJRb6tfZRo/+TRzEhIQkY1vQnP3sDSgkKn1SArM9F2v432RizNn8DohMUucUob/tJSm9Ggq09v0ZnrcbWWXbqkSZvto5o+61HHCvItBr0EMzrLqa+1XhicrW5WGTXeH+3KRAwNi4wfnoeMBihy9c/gHBwdMfJhR3ivB1vYlLgyuousaf1qfk1YD9kXBtGOhN9EfIuVdPlqoZ6jWJ0wogF11ew5CUz0vb1wm1ae08gejYqeVJE35GFr786OCyXFhgTNV1Fxs5V6kt+Ww==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=oz4u1GWqa2YWBSKaDk+DbYH43ewa3CWe9ukmJzAZVIY=;
 b=h+9+Of6Aa6pTI5FZZeJ2vjZ2QY3V3KSSfF+sE7N8gHWRHN2NnAKBxRMQd+8omg4SQsb0hvOIcSv9CAJOpGOZZnkqdABjJzak6F8PPq6tIeWwyz268ekr8okXL8kEFs7SKCUBANCIed77kroKdkIFaLchn8EeZgM4/wTpZRYPsBRfJLTYcNJ4Sj2qDY57z8Q8SdkoxExXrjpIWt6/hCon0DYK6gK/6sNy5X6ATa+FLTaugllcsXhGhrbBTqm4V1FjZ2/rkuWZ38XkrsylGxHMKIPIiebPt9KrpFGte6M+YmkrGRKG+yAtgAv9CHMEXRMrxwx3QiUnxMTEzf+EaEFtjA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=oz4u1GWqa2YWBSKaDk+DbYH43ewa3CWe9ukmJzAZVIY=;
 b=Xkk8wnrXlxK4j88BPnnQw7QnV7bSpZTzDSOeFec+ekYJdM0oFQ/TRyaFszLNRiEpR6/41ftbs9AspcNjIQmUVBQaSQfTM0TPqDJf+TxgDj+ty/B/PBV4/Y0HWrLeFMBEXELBUqkDnRq2Ql+j7xcPWF8kjQzC3omSvA8eInx2a0wh+0b8LZg3EcHrHq7LeGEU1wCP09A29h8n585whthQS0TozndvqyC0lBOd3ImdsKhx4JQdmuD2k8p+f0LfxR3UZcdax7gm7/GXpSFgc1HLYIwC4OVqugIbHfXYugumuiLEZYm/Dx02fsVJYV7q1DaEA1dUUTPhitsnl6OZJ9wisg==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by VI1PR06MB4589.eurprd06.prod.outlook.com (2603:10a6:803:a4::28)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 13:17:44 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 13:17:44 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 <8335ii5y60.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 27.2
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 14:16:34 +0200
In-reply-to: <8335ii5y60.fsf@HIDDEN>
Message-ID: <PAXPR06MB77602F0D4C19E0252B6EA52DC6ED9@HIDDEN>
Content-Type: text/plain
X-TMN: [7ZRBHPRjHHqwIz4+/4gizLzaoOSh5k0d]
X-ClientProxiedBy: MR1P264CA0090.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:501:3f::14) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87bkx68mqa.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: e0b657bc-88d4-46b9-27bc-08da1c86d460
X-MS-TrafficTypeDiagnostic: VI1PR06MB4589:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: fcjw+/TAM0muxiqydtWx7uosnDfMXPP3fPTQf3BlZKV+CZWEmzJK/xMScxQSGon5InmmShrDtYK3r4SjNOaNYCm93AaVs0bwf2Pkgd7gVRaF5P/fVmw0W02jvXsNo30rsMaAfWDUG9vJr3hrB8jgRMQHR4w5asJPPiblQCH+nIytOyVdtaCVuRkUqq8tBLpGqIAx9sq/ulrfzOxY0akjQhy5po/Z+aZoiPJTNkqxW8kWFna1XtoodYiv8XAnP6q+tJT0ENzrSA7akoWl+OChxRlnCi3o3B0DkA5Y4AF57omE/YTrENqdKeWbGtepfdAZ0pCT4Ny4LpdCvqrEAeas2PtXhcDZdGvTtJW2+2xhpnrMZMSWVJJvAa0o3Z7k/vCuETOldn8hmIdloVF0tWqhaeWkd269PJZeCFt1NvUAmXcuXQqYwRMPWkit3eg+SHvJHN17XKYlqglRmZQNEOe3dHOjd2K90CS8vcBf4uAtSl8OEkxl/lehN1z2oQx+gjxYxOMKJz1zagVXwXablf6roTcGJ66od3WUSPFqiqiECxvHiBUzLeLmeM81HqQE8kB5Ky+tDTitDG4UY74ZgZsZng==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?irgPmCNpLWNLzriQPMzGRwuOqq7HouQftkakTHYf9pC1o/bIYdz/vgiSiSZ8?=
 =?us-ascii?Q?4i+ZR3jtBItH6sjh/S4Mltd117fG+BVn40xByaE0vmLIK+AOgYldtG/k2/T4?=
 =?us-ascii?Q?T4fpxXX7sh/IHq7IapptBviPTmfP7DWMvUKnttLoQh0VvtS/rjZo69vB6cY5?=
 =?us-ascii?Q?zqNlmyAry/kuLQnFKkhb75+jYrhsBOktd3GXeVRBVz7+DtkhNjk3DPvjc4d2?=
 =?us-ascii?Q?UluEgi6KWyf3Q/pW2e2eVgvIweDujHPbSTpcHN46sVRRSQ7tF3hChyL+cguu?=
 =?us-ascii?Q?01DD3SLEiH1kXvEAzwV/VI42hudXf/4OJxMnitX9vamXfN11mAd3KL9mW9S8?=
 =?us-ascii?Q?DBJ+5gdMktlOaafEoPwC6RY9GuCtFZO8Ny3S8Hrwi4LA9bzQTR9bw36ypQYe?=
 =?us-ascii?Q?6tND+3T85/M1pAeBM2t2GhDyR/Y1+dgzs2+5msbMenzVXIE3QsuOzqWg90uh?=
 =?us-ascii?Q?H5ItWrRYC8Vkfe/108pY6/N1KkGEV5/mjnViGENp17GzdY3GHTGf3tTySjQL?=
 =?us-ascii?Q?TA7/l6x1i51Qi6xBf9i6JM8JNRDqQDmACJUc6IfbuEHalsvQHU0K2I07TXZ/?=
 =?us-ascii?Q?c9CPDI+iDAgX07V+GuLGyZcq0/bnQTdYf39ZViEhqCPOiW+WLFx/gJ1nwq8f?=
 =?us-ascii?Q?sB/tekV4EesYXrlCbkOA9jVUIO/u6mG963nBsRniJaqSxxUQTWP/HRTsB0HB?=
 =?us-ascii?Q?zHISLoyQmJDUCNNbEzXJvZxHhaMLipHXqoWwOupZZ9Zj0CbKqVCSZjX3vGMI?=
 =?us-ascii?Q?aONeD91P327Z0o0lerbRzInrWLjqBU79BhsWYBysFscGcHfEnatzYYU453Fg?=
 =?us-ascii?Q?fOY4WphUoZ14WDeCkka2W8393ncmPJThRcjjU+jK9shaCcaX7qe/JpTe5nLU?=
 =?us-ascii?Q?cWEnwd5KCyJ5tWlWkGvwQ9a/QYbMlqNJDWBXcdrzXSGuJv0gXgVY3be0uu92?=
 =?us-ascii?Q?UBSpA8bK/a7PxM+f14fItri4sHNYlykJZ7Wco5xAm0lNrPz2iNvroSF673Hf?=
 =?us-ascii?Q?er5Ms0sWAcci9knvpCBy5gMLUX078pPv2k182JaHigQflVlcD8+MGE6ZjLq8?=
 =?us-ascii?Q?atMg/XNYOhWNxySuDhlmozmVzxfwC+Y7s8q4bZ3ljp6v/XjGe5692PRLF6Qy?=
 =?us-ascii?Q?Euit0Y7Yp+f7abXocOlYxRbE8qfZxBmwHcvTLQCIHnnIIGhjzOsZSFD5F90V?=
 =?us-ascii?Q?TSSl95AktVcrt6qjPeS9L7Cb8JD0ADxBrPLkHgXvT/49p8DYA++ZJf9OVBvo?=
 =?us-ascii?Q?j6zK/WDunsLtmKWbKGiA5F8KrrUJDcSJPv5jdA+YTv519ugBdo2qfSBbgWjc?=
 =?us-ascii?Q?8+DhTPsvHHv/XD5u+Q2x2S+uZZKsbNHBFg25A6xeXgHSnHV7mUV1BlNUXQ8+?=
 =?us-ascii?Q?lDHBze4Y/uRWwRAJMLYdhvbkO32robt5PvLBqT1Nr2r2OBsonq283cLz7Vxy?=
 =?us-ascii?Q?Sl4TYZu6Z24=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: e0b657bc-88d4-46b9-27bc-08da1c86d460
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 13:17:44.5144 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: VI1PR06MB4589
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> Please tell more in each case where you consider the behavior
> "surprising" why did you expect something different.  I think it's
> important to make the subsequent discussion focused and efficient.
>
> Thanks.

I explained why I considered some of those cases surprising by
themselves in previous emails of the thread. I originally expected
`default-value', `set-default' and `default-boundp' to behave like their
counterparts `default-toplevel-value' and
`set-default-toplevel-value'. But I assumed there was a reason for there
being two versions, so I was just going to update some docstrings to
make the distinction more clear (or in the case `default-boundp',
correct the docstring, which is just wrong).

But now, considering all the cases together, I also consider surprising
that the behavior, whichever the correct one should be, depends on
whether the variable has or not a buffer local binding. So for example,
for the following

> ;; default defined, buffer-local undefined
> (defvar var1 "default")
> (let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"
> 
> ;; default defined, buffer-local defined
> (defvar var2 "default")
> (setq-local var2 "buffer-local")
> (let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"

I would expect both snippets to return the same. And the same goes for
every two pair of snippets that only differ in whether the form
(setq-local varX "buffer-local") is present. So I was no longer sure
that the issue was just incomplete or ambiguous documentation, and I
wrote all the cases I could think in the last email to see what you
think about it.


P.S. By the way, I had deleted the previous emails on these thread, so I
could not properly reply to the last one, and had to just write to
54399 <at> debbugs.gnu.org instead. What is the proper way to reply to an
debbugs email thread that is no longer or never was in your inbox? For
the org-mode mail list there is a link on the web archives, but not for
debbugs.gnu.org. Is there a quick way from the debbugs package? Or maybe
using some of the info in the mbox file, which can be downloaded from
the archives in debbugs.gnu.org? Thanks





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 11:38:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 07:38:51 2022
Received: from localhost ([127.0.0.1]:47802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neErC-0006J3-Oj
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 07:38:50 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38966)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1neErC-0006Iq-5O
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 07:38:50 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34658)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neEr5-00036W-Vv; Tue, 12 Apr 2022 07:38:44 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=EunXXZclFxgj9J8gXUuXqGm5QZAd+DhBdPt0WHoF+f0=; b=Q0MlAPaQBLTw
 KOaMj2tfSbWxEwc2+g/MrNsI+jE06v1M47JpTS9Yf9fICVIqLI/1LMTi/ChY1d2w1A7yfAI+P4pEU
 VD8b0OtMksIrDN40y4t0b4wsziZibz4+qmMsh7wZC0NkWznedk0AGhjAkkYYFw2IIC+xMAFN20QeS
 SEjeH2v5zSWKQcbF4YaP0oFf5rd4nyTv9fKevW6y1tIuE5wst3JmDhjxBA5MiqUx0A6uoEj2w7aW9
 /rNDmegVPBYltF7PLN8E9AdakzE4wekGsCxkzy/WumDERvC2XvNnbuMYoBZGXAp/iqQ0kQf2y25oO
 k5NXBGq+Bq3Q08YETOyZDg==;
Received: from [87.69.77.57] (port=4616 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1neEr5-0000J2-9C; Tue, 12 Apr 2022 07:38:43 -0400
Date: Tue, 12 Apr 2022 14:38:47 +0300
Message-Id: <8335ii5y60.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
 (message from Ignacio Casso on Tue, 12 Apr 2022 11:13:27 +0200)
Subject: Re: bug#54399: 27.2;
 Problems with (let ((custom-variable ...)) (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: michael_heerdegen@HIDDEN, larsi@HIDDEN, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

[Adding Stefan to the discussion.]

> From: Ignacio Casso <ignaciocasso@HIDDEN>
> Date: Tue, 12 Apr 2022 11:13:27 +0200
> 
> I was revisiting this bug report and writing a patch to correct and
> update some docstrings, both in custom.el and for `default-value',
> `set-default' and `default-boundp'. But for the last three, I'm no
> longer sure if the errors are in the implementation or the docstrings,
> since I have found more strange cases while experimenting. In a few
> words, those functions behave differently inside let bindings depending
> on whether the current buffer has or not a local value for the variable,
> which I find a little bit inconsistent. If it has, they behave as they
> "toplevel" counterparts (`default-toplevel-value',
> `set-default-toplevel-value'). If they don't, they behave as I explained
> in previous emails. I describe those cases below, with code snippets and
> comments. Note that the behavior also depends on whether lexical binding
> is enabled or not. I use dynamic binding in these examples.

Please tell more in each case where you consider the behavior
"surprising" why did you expect something different.  I think it's
important to make the subsequent discussion focused and efficient.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 12 Apr 2022 10:30:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 12 06:30:39 2022
Received: from localhost ([127.0.0.1]:47685 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1neDnC-0000Yn-Ov
	for submit <at> debbugs.gnu.org; Tue, 12 Apr 2022 06:30:39 -0400
Received: from mail-am6eur05olkn2055.outbound.protection.outlook.com
 ([40.92.91.55]:4704 helo=EUR05-AM6-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1neDn9-0000PO-SU
 for 54399 <at> debbugs.gnu.org; Tue, 12 Apr 2022 06:30:37 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=QE/o6DRIwZJ3zev2/t/LwRvcnNcS99uStorrWz6h4uKPwEWoi+8tbz2OmKU1Mq85EV8ShTskshyxO4tbs7egg6cwDp+0i03i9UbnrkwJc7YjM71tMRw7STf6aipNm3hwRqnPqt8lvo9eSmMPV+L/vh/zpvKYMdyks6U4FLAzJXenOfnCvBrdIeo0JFapG0VVeBhhwus0w1JFL/Ii/FsGJMnVuCXiakI13AjymmCxRht0eFc4boAV5Oum+5OitHOm5DXsRzzoOZDEZVGgAmLd21Dk9rEJv4rfKdkHIbLYQhzg9oSoOQpu8uQ5ukD3heLKLWb1spOrfA+UhypAGeByYw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=2VV0xl4QLRWR0OFcxMhNBAMvELZDb0I6j4EKFjau0qg=;
 b=Fr0VwfRBfuNr5gyGAiDAhOSw5vAo/+gH+SuEW4/oGTy1nZ3TKCzN0CoQeKPNw86Q2YbgnZJazi4gjWNxSKAHzHyqiqicrDkzOY3+sBbz8V1CGj9F3IYUTGJ3Kv2Yv8weOVltmullvvy7URQrsBH2ny4BguI6FnyaOBXyhIMPvmgd44BUXRloI3r4oTttGC1KETJ66t1Zt3Z+xjgAsU0x6mZlpkklrWueuKv9GgswSYBbHD7vasXw/zJPFWltBnruFl1hkppQ8YvPss4Ei1uNc9gtZFsQ1tOOHX2gT/rYjneN7qd2dpvT3Jy1+ow3GfkM0XbelqNquwqPrHA4NEoyGQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=2VV0xl4QLRWR0OFcxMhNBAMvELZDb0I6j4EKFjau0qg=;
 b=ERui0bJYTMPSjyW6jhsJBC8fzvOdVm6F/oE9cdNOk3ypWfzX0DTsggavGsrQMM7JJVdg0NDWasPIjkle4MSd1YdVNsCFDh64MGSj3kly5qIgPlYr+n4yXn8+4mYFlxv8l7THfx6qx4Th6u/GmChfMuGomk4PhGAukfa4qxkXbGDhGpb5bZyy51nmIYkwmlDX3oTKKz+5KKrMsZ2ml98XoMSGQDPjPksuhQDQV+J7WS9T9YP9OadQWxgGLOo78DeiAY4+ezxNo7U71WqL+DIE00jOvTcMp2orjQTFb28Xaf3YgmbFURVfQv1G+vDT0I7bexSEOhnUcWk+SvW+5nhWYQ==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by AM5PR0601MB2353.eurprd06.prod.outlook.com (2603:10a6:203:70::13)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5144.29; Tue, 12 Apr
 2022 10:30:29 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::c43d:998b:8b75:5e3a%5]) with mapi id 15.20.5144.030; Tue, 12 Apr 2022
 10:30:29 +0000
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: 54399 <at> debbugs.gnu.org,larsi@HIDDEN,Michael Heerdegen
 <michael_heerdegen@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Tue, 12 Apr 2022 11:13:27 +0200
Message-ID: <PAXPR06MB776028CFD4246956E22CE0C7C6ED9@HIDDEN>
Content-Type: text/plain
X-TMN: [VGG1XADRDIjOjWEqVs6Nr5fyusO0jPHf]
X-ClientProxiedBy: PAZP264CA0192.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:102:236::31) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87bkx6iog2.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 9245b8e4-29b1-4ee9-7775-08da1c6f7623
X-MS-TrafficTypeDiagnostic: AM5PR0601MB2353:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: g14mG+lfcMJfAgRTsM8wLHNjB80PB1wljIOp61j/GlEASOb2rvRD0QogWmJWh3czgkqWtKEGsh40OKyzEWZ6vX5oorCFMSbqIUJYWUoz2WO9/wKnub3pIiaXU8w4KC8PMNKHNEvoNOT4T/efqyEoYntMuebgGtZB7Cqq5YIwB9kaIemvvDrlDHsTi8NN/GxDn03lyBFswBZsV4G+rDJIEsxoUZ6fm92w3lcW36IyuD8Dmiz0BaJ1fmvcnkK+XdLL7hmw/i2/K4uRNZNPdmuQgWp2EqCFV/50G1uRNG1VkIYcm5OvOc8gKRlepVoaLjuoQdPP9zv3etuDJZSNCggr10e8wMaLofmhyqjMawfZaXlLpxGRuj9yveDurZgOtv3erC5BVcxCpicU/+Mb3IxQ2xJCzpJHyJvtINr1zVpDcGqhVZTHmxhvCjQsvFqgjzU3S+F4Zp3gvyl7F7ufw20aTugZYO+GV1MrGt4Y//8buF72bfDzNwpuThTrqjmUQ2x4iqVl3rc/I1nBurVRWXl0UExTsd3oJfu7mdmRgWnYKxewQklY5OGOoQJmWcxp4yEcs1bz7ZzQUu2IQ5jk/ICVyA==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?NcTLLe4L3tmLmOhdXFF+ogGDhdMenore4N3aRUG/oRfb4dR5q/+Fh8M0W9q0?=
 =?us-ascii?Q?DyZLgNNZ+jzd/6/omQStRJ1pG+gzytTMVYascEFBp319T5f2dzVYYzB9lqBJ?=
 =?us-ascii?Q?mjSLxMptPBQ+nvZqHpN4pJTatEDwLKWN81ZqRfW0m3xEzn1ZhIW/nGgKiTRJ?=
 =?us-ascii?Q?mrej1tU7Zh4Ica5s3fIcsSPgNpv0dsMCjKEzJlKT7Rd8rvQWWW6tH5ffhvIs?=
 =?us-ascii?Q?yyWvhXxP3O6xVTj1lnWSQilSMA6xNUMjVFZCc8dCyKzL/+TiDnjy3O2n5pL5?=
 =?us-ascii?Q?wtHGkutAH6Oxh6B8kOxYkcaRcRh9L5UxhmntK/2yGPbkDIXB6hgAnsqw7jmC?=
 =?us-ascii?Q?HVbG/gARKbEYYkVYbUHslgFaRJcYN/wfgomSjZjOpUVZ0tc9USfqgdsnRDPk?=
 =?us-ascii?Q?u4UIihBJ3Ctc7vJCIKIyW9OVtvVwU9KT2sIGLiebhOt0Esmq5EtVy0cFxxMy?=
 =?us-ascii?Q?+0gYlYBmVARN3x3fPz8WPuArab9s6xWI0d2X5l4kiJl3Gtjbr3AURsKPXnmj?=
 =?us-ascii?Q?LH/IwcK9LNPpNBDytQgW5y12V26iwWSVbOVZyCLa7+FvG9dt/kjqZXAKpHRP?=
 =?us-ascii?Q?VWJRopYV9uYTUF2euqr5j995qN1lRYK+aBRhD6JLRYWLrCtTfkYrpVLshgUe?=
 =?us-ascii?Q?zRQuN4A1HXrCocchh3ZasFv78o/mIrk7LzS9jYs46LCxvrQYz7y+idHnMCaZ?=
 =?us-ascii?Q?Pxf5n2VOcLMkZyP3c02bscsOdINLqiRWqEyZKRgejbcola6mSs6hC82fsN1s?=
 =?us-ascii?Q?x9Gof3Rqo3vwN8NWffNYh4S41Q4JoBlK48IICvhmKxL3AcTmiUVFNVgNgQP1?=
 =?us-ascii?Q?CBouVhx+2Jg4Cty9o7Mho9By16/gQruxHUTxptLLlag8PriTrqct5ZjZdtoO?=
 =?us-ascii?Q?pvRZ+xInwFmqaDkGVewvH+0dhlo5DsQ2qyqI062kWVGWbz2LAx3XFIrpKlj9?=
 =?us-ascii?Q?unGp0BqPxpXHkmbD7SxIQVEomM8hFOvxvLlkcaG9W1DpD0RjtnjTTeL0TObL?=
 =?us-ascii?Q?EMFn4Afa4sHQX2HHXI3x3eUnan2HfTYw+VzIPrMBVa4uwEDDt/NyffttR2H7?=
 =?us-ascii?Q?0fJ86bCsnc4wLYmaOIokpFvwjq7nOsnljj0zsFQdCoCmUF0t17yU5NPZfYxm?=
 =?us-ascii?Q?LjLO6MUlp995f1we6yKeDix9P5w9t1eteDBsGN4pQ2YoQbej/uPIFd2t7Qvc?=
 =?us-ascii?Q?ms3OkMvzoEuENw+Om9ECkq40UhHOYnm84W1K2BGly90/Zvt1ACp65/CRudG3?=
 =?us-ascii?Q?MWAgk/90ZUsRoDq4Do4huGC2UsubaMUyh9TqWGMmlnPUUdQO0P+2Mw/KhE2P?=
 =?us-ascii?Q?2WYicJRgChLFNFr3QnFe78L7RaEQN3W/k211/dSyufXNj6rrVP6xhaC3HUMR?=
 =?us-ascii?Q?Brhwg9PUYWQedCV9RK57z+jpQLyWy5GybjNxqH2xalw9A5hPAoeWlMjGTj59?=
 =?us-ascii?Q?tA8UC3mjMv0=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 9245b8e4-29b1-4ee9-7775-08da1c6f7623
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Apr 2022 10:30:29.4070 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: AM5PR0601MB2353
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> I think custom.el already uses `set-default-toplevel-value' where
> appropriate by default. So my request is (1) to correct the docstrings
> in custom.el to reflect so, so that users know to use it instead of
> `set-default', and (2) Add some warnings somewhere, although I'm not
> sure where.
> 
> I personally can not think of a single case in which someone would want
> to use `set-default' instead of `set-default-toplevel-value'. If I
> understand them correctly, they both do the same outside a let binding,
> and I don't see why someone would want the `set-default' behavior inside
> the let binding. In fact, I guess most people assume that `set-default'
> behaves like `set-default-toplevel-value' (I did at least).
> 
> So I would at least talk about this in the docstrings of `set-default',
> and also `default-value' and `default-boundp' which suffer the same
> problem. In fact, now that I see it, the docstring of the later is just
> wrong. The others just don't mention let bindings and only talk about
> buffer-local bindings, but that one explicitly says that the function
> can be used to know if a variable has a non-void value outside of a
> let-binding, and with dynamic binding that doesn't work (see snippet
> below).
> 
>   (setq lexical-binding nil)
>   (let ((another-fresh-var 1))
>     (default-boundp 'another-fresh-var)) ;; I expect nil, it returns t


Hello,

I was revisiting this bug report and writing a patch to correct and
update some docstrings, both in custom.el and for `default-value',
`set-default' and `default-boundp'. But for the last three, I'm no
longer sure if the errors are in the implementation or the docstrings,
since I have found more strange cases while experimenting. In a few
words, those functions behave differently inside let bindings depending
on whether the current buffer has or not a local value for the variable,
which I find a little bit inconsistent. If it has, they behave as they
"toplevel" counterparts (`default-toplevel-value',
`set-default-toplevel-value'). If they don't, they behave as I explained
in previous emails. I describe those cases below, with code snippets and
comments. Note that the behavior also depends on whether lexical binding
is enabled or not. I use dynamic binding in these examples.

;;;; `default-value'

;; default defined, buffer-local undefined
(defvar var1 "default")
(let ((var1 "inside let")) (default-value 'var1)) ;; returns "inside let"

;; default defined, buffer-local defined
(defvar var2 "default")
(setq-local var2 "buffer-local")
(let ((var2 "inside let")) (default-value 'var2)) ;; returns "default"

;; default undefined, buffer-local undefined
(let ((var3 "inside let")) (default-value 'var3)) ;; returns "inside let"

;; default undefined, buffer-local defined
(setq-local var4 "buffer-local")
(let ((var4 "inside let")) (default-value 'var4)) ;; void-variable error


;;;; `default-boundp'

;; default defined, buffer-local undefined
(defvar var5 "default")
(let ((var5 "inside let")) (default-boundp 'var5)) ;; returns t

;; default defined, buffer-local defined
(defvar var6 "default")
(setq-local var6 "buffer-local")
(let ((var6 "inside let")) (default-boundp 'var6)) ;; returns t

;; default undefined, buffer-local undefined
(let ((var7 "inside let")) (default-boundp 'var7)) ;; returns t

;; default undefined, buffer-local defined
(setq-local var8 "buffer-local")
(let ((var8 "inside let")) (default-boundp 'var8)) ;; returns nil


;;;; `set-default'

;; default defined, buffer-local undefined
(defvar var9 "default")
(let ((var9 "inside let"))
  (set-default 'var9 "new-default")
  var9)                                          ;; returns "new-default"
var9                                             ;; returns "default"
(default-value 'var9)                            ;; returns "default"

;; default defined, buffer-local defined
(defvar var10 "default")
(setq-local var10 "buffer-local")
(let ((var10 "inside let"))
  (set-default 'var10 "new-default")
  var10)                                         ;; returns "inside let"
var10                                            ;; returns "buffer-local"
(default-value 'var10)                           ;; returns "new-default"

;; default undefined, buffer-local undefined
(let ((var11 "inside let"))
  (set-default 'var11 "new-default")
  var11)                                         ;; returns "new-default"
var11                                            ;; void-variable error
(default-value 'var11)                           ;; void-variable error

;; default undefined, buffer-local defined
(setq-local var12 "buffer-local")
(let ((var12 "inside let"))
  (set-default 'var12 "new-default")
  var12)                                         ;; returns "inside let"
var12                                            ;; returns "buffer-local"
(default-value 'var12)                           ;; returns "new-default"


Should I go ahead and just update the docstrings so that they reflect
this behavior, and then close this bug report? Or do you think that the
code should be changed too? For the later I don't think I could help,
since that code is too low level for me.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 18 Mar 2022 09:56:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Mar 18 05:56:52 2022
Received: from localhost ([127.0.0.1]:56358 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nV9Lo-0002tE-7v
	for submit <at> debbugs.gnu.org; Fri, 18 Mar 2022 05:56:52 -0400
Received: from mail-oln040092065039.outbound.protection.outlook.com
 ([40.92.65.39]:28738 helo=EUR01-HE1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1nV9Lm-0002t1-JS
 for 54399 <at> debbugs.gnu.org; Fri, 18 Mar 2022 05:56:51 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=jjA7qM5WoKP/wWu9+nrJh5u7xFOzTaygohbM7OhxOt9RtV/kd7SUOqUU07DAHk+JKulgIRwBdfh7bE4i/UIRKYanvwaxO/G/maiCZBFidE+AE7mZyKTA7tPOxbnT3Sgj5tTxWJU8hQw7vPI79R7z2QYyiKY/w+NNkagTcMtlD85oimFQ5E0BNsqdGoxDWJFQj2c0nofENgFGfaBUpc5P1jnLGBX4+xLZurW2WPElHg01lk2ncAABj+YCgCKD33vLRcPtKwT08xipk6P1rNCaCKylhZneYlksaw/pfYReyNejJVjadxhyBeMenLCKE9i9yU70wpR2dVYfXdNZkidfUQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=Z1BrYRurvKqVr3rbWIhGLIEr18z8E8Yadxd3HD9+eRw=;
 b=J1EdDNKpgrmwEZogZOQDQ2FzIrmiL3XBGsmSoRvZP4ShDwqUCRQp7XktRD8GED56xHdNAeXHI7aW8GvwqLK8nm4miCOXG9oaU8AHgkfP3ydrGRjP8sC76SdpM6K6a0rN06vqutgYJe/qc2eP1nzh6sknkRBjJrlD2hJfDVPJvs0JWq9SKusNhEqAijDcWZcher06VY6RdiCZcxI/SthofYsCv47m6NGBbGlqTOqa27XeHjE9c9iVQxbI1cKAzyaq9VHdf6nQyawmlGSO2W7IwRaLZ4P14Nhv1K5+gpsk4G7BoTXZbOgVGS4LwbOeiBPJJ3b+FrNuRbhZj9QfgBcuSA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=Z1BrYRurvKqVr3rbWIhGLIEr18z8E8Yadxd3HD9+eRw=;
 b=CkdyfQZccCgyrRWUijl+OsF4a/vlHbZCXBIX0RY82YginGtiGWn/2/lrtYJu2SN1Jx/EZ045RjxaTLcKxrMZCT6UlNejSiL9pUk4jv7mU2qXAXZcJ1gV9o/JXKCb0hleZWGhomiKHTqjEXSF1CUJpSsiSOr4cN7Gm2YGanHzWUQJBjCi2a0Z3SavxiGET9F7dA2zYT9kex/Fro+LLcWhrGcpIk4pVpTzwCErAKiDBtLlzbgP7GsiNEiYxxBTerdKNBU6uhWwfsU8xGg71OGGTFvBnQ3Pftps/wPe8/dXgnbLOs321ZXOJZsQntBnCeUxmAl4YWDK8kJozRKphlJpDw==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by HE1PR0601MB2364.eurprd06.prod.outlook.com (2603:10a6:3:99::21)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5081.15; Fri, 18 Mar
 2022 09:56:42 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::e05a:8d81:8648:b10f]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::e05a:8d81:8648:b10f%9]) with mapi id 15.20.5081.018; Fri, 18 Mar 2022
 09:56:42 +0000
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
 <87czijr4gj.fsf@HIDDEN>
User-agent: mu4e 1.6.10; emacs 29.0.50
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
Date: Fri, 18 Mar 2022 10:38:45 +0100
In-reply-to: <87czijr4gj.fsf@HIDDEN>
Message-ID: <PAXPR06MB77607074F280F2DA4C6A49B2C6139@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-TMN: [SKP1jLSzMh13nLJj2DCWLy0PNCeh/e5J]
X-ClientProxiedBy: MR2P264CA0186.FRAP264.PROD.OUTLOOK.COM (2603:10a6:501::25)
 To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <878rt7lh2i.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 9890b312-09a1-4000-a866-08da08c59ac2
X-MS-TrafficTypeDiagnostic: HE1PR0601MB2364:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: pD83+SyUArYi3oh4tYiZkoVq5WSTiPKHHu6PxG43rqs61m+dS3cluj3uLt/25epPaq4q5xRpYI/cwaH0+cdNGDrOADLuMID1DeS5JeuRnb5wn/DZenUBdO6cJ3twUvgwyqEJaoBI+lJf84phx/4iSCRE9FATcxugEMzqbNv4Sp57BUctk3L+g3DE639y9Rif1uEl67SKU26cMns0zy/FygTgZb6FBg1v3DD3MAKiSovOUxQQnze0DdRAW2aKwtmjjRUlEA4KO9qdYnMeA0+EtzvuxF8UZl3M9adqPcrBc2hbTCo6vIH8YNeMdtitAhKDUu6I4zkvVSWppVwpZSmGOf2IURRXjiXEPIfBLWhF/u/k5bjpAhkn3gzHB3n+squJqvjGNhgBiCER8K16XsmM3CUfZtAnaLgjfBL5q56Ky5Gh1XpPgpWmikTsEO+R2YSdpKlLz+T0MhGgYzAj4TEywF3B/pm7eewKct6sc9+QvE5sVW5B9/RWO5xxIWouxaxDTcSOerZVm1H8CoAmOqqrOtGNomVJJ1uXgGmaRuOwNY+mWlbzy91dOKhcExgoxAyti0ageHR8nYE6pEvag5I0XQ==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?utf-8?B?Y3BTNTBZQWdpc0w4cUNYVzlPZ3VTNE5IODBZcDFySTRsZjF6b1ZGVW8za2F4?=
 =?utf-8?B?bHA3MXpYSm4weWdESEVrdWJVVzd4dVh5ZHNEWG0vamdqZ3c3MDZuRE5NaGlt?=
 =?utf-8?B?NUJTLzl0UGp1ei9xOCtwbVpONWFBMmQxM0Zxc2NXNkpZeGUwZGpST3lSank3?=
 =?utf-8?B?bzdod3RoZWozcXhZVzFKODMzR283a2NYZnBDek9YOUtBTWxMbDcxUXNraE9h?=
 =?utf-8?B?cVBtdkZOMUlLNXdMYlhSU3pMTGhXWWs0a1NzNUloVm5ydVYxNHJXWUpjNDYy?=
 =?utf-8?B?UDZnUVZQM3pabkRtYkQ5ZXp3ajYxR1g2MzRjSytQY092RG9vZktmVy94VFFy?=
 =?utf-8?B?SnNtYXA0WjJDS3RTQzdBemhrb3lMSzdiS2Q5Vjl2YWtlWTBXNnhGbW9KMHdO?=
 =?utf-8?B?dURyLytzbW1DWklwaEhHNWRjU1haZzRDU0FqSlRXVnpWNHl4dFk3RmtBblpF?=
 =?utf-8?B?Rm50YVl5OU9VczdDTG1jY1g2RVRMa2ZvMitwc08xUHRjYXJ5eTFPTzEwZkc1?=
 =?utf-8?B?TVk1MkpWYnlGUEx3SUxCTzBDMThZYWVOWlcwVlVQVDBiNGp4NFZGZjB0NTZP?=
 =?utf-8?B?dnRzLzdyU3J4Smt5R3FnTUlwd0ppVjAvd0VGdkxQK1ROeFBHb1hWUnc4K21B?=
 =?utf-8?B?TmFjelJ1c2dONGR2VS9US1NjNnRRUUZLaHVaYzR5TFJ4REtaU1lJWTNSOXNF?=
 =?utf-8?B?ODlUcDFocnduRzF5U1Jyc012NVMzWGp4Uy9DRVppZUNYVkhaMEJqaTU5VDFi?=
 =?utf-8?B?VDJpeFNIekV3ZUMvNnBpcXFiZWlWMXdscFZMQTBMQVRhNXRJM0NLVXFQTVdQ?=
 =?utf-8?B?d3pXdDJ2TTVzL0lQOWlHZlhCdTBBL2hxVk5iRnh5OXQ1Snpjbi9iWi8vdU8r?=
 =?utf-8?B?anZnVXRDSWJ2RWpCQTNRUlI5OVVlS2JsekFiVVRKQnlmcWNwK2dPZHkvZDgw?=
 =?utf-8?B?TnVNbm5nSW4yd0ZESzNvcmYxNGI3dXVycGNlSmY4QnlDTVhYS0JwUkJkbVpj?=
 =?utf-8?B?aDgyYjRxck1yRHQxa1hKK0wxVVNiNzc4Zm5DRElyRkQvcGNjVUo4NDJSMG52?=
 =?utf-8?B?M3dJWVo5V3oxTEl5UGFBVFhSeGlJYWpVcTlnZk5ONm5rYkRpYnlEMlAyVzdB?=
 =?utf-8?B?Ynl0ZkpBOU5hcms4cWtUbmw1cC9DdzNsSVBuVElMSVlLOUJnaXFGM0xQTGVT?=
 =?utf-8?B?SUQ3SUhDLzJZNWV1UDRkaC9UdXc3eEozK2k5M0N0Mk1lOTdpeVVydGFxemdI?=
 =?utf-8?B?eWozVlN5Z2MvV08waEpVUDhtNzZjVllBL1J6YWd2N3RHZ3ZPMndvTUJmOW5L?=
 =?utf-8?B?L2p1UmFPZ2t3NXVtY1RIQ0trTm01a2FPWm0wc3lLS2J6UjFHcllqVUhlMnVm?=
 =?utf-8?B?V0l5MG56QXN5NzlCWUFkc0ZUS1VHYTVtc0F6RkJZNTBHS1pvVnV5VkxnMzY1?=
 =?utf-8?B?M1Rqb01IOTZCZ29ua0p3M3VuZ3hxclgyVko1WkVQZHk4ZHRYYi9ia21uZm54?=
 =?utf-8?B?ZlJuZkdOeWQvSzhUSElVNE1ENEM0a2FxNVlMcTVnaDcwRTZYUngxUWNLbGZs?=
 =?utf-8?B?bWJ4dz09?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 9890b312-09a1-4000-a866-08da08c59ac2
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 18 Mar 2022 09:56:42.8425 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HE1PR0601MB2364
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: Michael Heerdegen <michael_heerdegen@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Michael Heerdegen <michael_heerdegen@HIDDEN> writes:
>
>> Hmm - I don't know much about the background, but wasn't
>> `set-default-toplevel-value' invented to make just that work?  See
>> commit
>>
>> a104f656c8 Make defvar affect the default binding outside of any let.
>> Stefan Monnier <monnier@HIDDEN> Fri Aug 2 17:16:33 2013 -0400
>
> Ah, newfangled code.  =F0=9F=98=80
>
>> AFAIU this bug report is a request to (1) correct some docstrings and
>> (2) use `set-default-toplevel-value' instead of `set-default' at more
>> places in custom.el to assign values, where appropriate.
>
> Right.

I think custom.el already uses `set-default-toplevel-value' where
appropriate by default. So my request is (1) to correct the docstrings
in custom.el to reflect so, so that users know to use it instead of
`set-default', and (2) Add some warnings somewhere, although I'm not
sure where.

I personally can not think of a single case in which someone would want
to use `set-default' instead of `set-default-toplevel-value'. If I
understand them correctly, they both do the same outside a let binding,
and I don't see why someone would want the `set-default' behavior inside
the let binding. In fact, I guess most people assume that `set-default'
behaves like `set-default-toplevel-value' (I did at least).

So I would at least talk about this in the docstrings of `set-default',
and also `default-value' and `default-boundp' which suffer the same
problem. In fact, now that I see it, the docstring of the later is just
wrong. The others just don't mention let bindings and only talk about
buffer-local bindings, but that one explicitly says that the function
can be used to know if a variable has a non-void value outside of a
let-binding, and with dynamic binding that doesn't work (see snippet
below).

  (setq lexical-binding nil)
  (let ((another-fresh-var 1))
    (default-boundp 'another-fresh-var)) ;; I expect nil, it returns t




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 18 Mar 2022 09:32:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Mar 18 05:32:41 2022
Received: from localhost ([127.0.0.1]:56277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nV8yO-0002Eg-Ow
	for submit <at> debbugs.gnu.org; Fri, 18 Mar 2022 05:32:40 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56930)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nV8yN-0002ES-7S
 for 54399 <at> debbugs.gnu.org; Fri, 18 Mar 2022 05:32:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=kQZO/Mk/IKewf1+GiL/ZDOIuOA3hQtQJTdIpW8v9c+E=; b=lDlYjBjdmlTSDS5iSLwXFS3FRl
 1BmemIbv4kfHt7W3oWoVNTrgqJqTD3pFlDCaELVAZeAFWXd+lfJPE4S4pXgR1VTNS9U7TqMpxf3dD
 eFrYLJcP8alCfQW830KgbPmV+zZXtz0uPblmFZVlrDUSEdFP42Jrcnmvn+m0NLrsVze0=;
Received: from 109.179.236.69.tmi.telenormobil.no ([109.179.236.69] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nV8yD-0002qa-Sw; Fri, 18 Mar 2022 10:32:32 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
Date: Fri, 18 Mar 2022 10:32:28 +0100
In-Reply-To: <875yocm7n6.fsf@HIDDEN> (Michael Heerdegen's message of "Fri, 18
 Mar 2022 01:22:37 +0100")
Message-ID: <87czijr4gj.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Michael Heerdegen <michael_heerdegen@HIDDEN> writes: > Hmm
 - I don't know much about the background,
 but wasn't > `set-default-toplevel-value'
 invented to make just that work? See > commit > > a104f656c8 Make defvar
 affect the default binding outside of [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 0.0 TVD_RCVD_IP            Message was received from an IP address
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: Ignacio Casso <ignaciocasso@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> Hmm - I don't know much about the background, but wasn't
> `set-default-toplevel-value' invented to make just that work?  See
> commit
>
> a104f656c8 Make defvar affect the default binding outside of any let.
> Stefan Monnier <monnier@HIDDEN> Fri Aug 2 17:16:33 2013 -0400

Ah, newfangled code.  =F0=9F=98=80

> AFAIU this bug report is a request to (1) correct some docstrings and
> (2) use `set-default-toplevel-value' instead of `set-default' at more
> places in custom.el to assign values, where appropriate.

Right.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 18 Mar 2022 01:02:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 17 21:02:56 2022
Received: from localhost ([127.0.0.1]:55732 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nV116-0003Js-G9
	for submit <at> debbugs.gnu.org; Thu, 17 Mar 2022 21:02:56 -0400
Received: from mout.web.de ([212.227.17.11]:49973)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1nV114-0003Ja-HM
 for 54399 <at> debbugs.gnu.org; Thu, 17 Mar 2022 21:02:55 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1647565365;
 bh=THzYzY7x/Ql6zX0Zm3mO6RwyAgXhgH0bCCMB/MspPKk=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=ZQ7IUx5c2OUNHXKDPlZXTRr8zBBE03VvYITOyS9yEuX+h2bL7gJZcf2QiKkdxMCXo
 3IjQR06zQCYFJneoPoob8TtV/aljZ3C8NRYs8URky2sKYzesy3x84tK2KvHvRyEZb1
 k1AzWexveMYVkyUCmfajbu75XtSHl0jafbrdRs7I=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.60.174.212]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1N5lnF-1o9n1K26KR-0171bN; Fri, 18
 Mar 2022 02:02:45 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN> <875yocm7n6.fsf@HIDDEN>
Date: Fri, 18 Mar 2022 02:02:44 +0100
In-Reply-To: <875yocm7n6.fsf@HIDDEN> (Michael Heerdegen's message of "Fri, 18
 Mar 2022 01:22:37 +0100")
Message-ID: <87sfrgkr7v.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:uvP15lww+wRHoXSvv56torUnGFlyaz/lo/HtRsi2gBCZUwaYug/
 SXKMB6HByIO0u/z9RcsOpSH4mRuwG6OkLjDhNu8vdvRlswJC/KJ64cKZTmm/SWXOfwkFuke
 ZNWhm18vCslkck5waV5Hk13nZGOjugYeXinERNNMGtUuN9YezaByBzrDeO2dWtqeGt4p1iF
 wYeNac4TVxlToA0y7DGXg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:7QeCZNeb/Oc=:hL7JScRNC1qTnKnGTaml2L
 XPdDWO3lxZdJv/pnRQnltL9HCVWJ2TQsG8i9A5Gt1iWSDRjj7wLMEaRSr5ZjRxqDefzQaY4fm
 7Q6coUWUA3ULgoNz0i0bRXv4O0695NKOMYQs85fZTpeeHUTJZl/8lGXkzyOCilIQ3jAPqUGrn
 ZftQxdQ2R1JW3kO5Tfa6eupza4jACstFaiIhEidp4mQKIt/45UNTEs5icrPKWT8aT8yRRgD53
 pADxIoECkFlHqAVrFVZVQ88GTrGqlfhx3MLuTSFFgTMBfiteR/FOP3gK0X7NF8yqyW3L5zlDc
 5mzpVrkK/DzPiu1Tl04Guzhgdv+bdAr9bRi+/ffzqDHw7M2NnXB4KONaOif5vZpJKUK4E7trW
 gOcBc5KS0uP0OKNLmQN54S/GB/uLq5fV5cFebNMTKsE7M8JNEhE3mI9WVhWEkSb1LL9nfZH3l
 Em126XUGi/g3/7kk7kdYN+AHBffiic47Q6LlN3oJ9qN0Qt+DRgy5KFRRfdQ8gaH+ZaJTa+RFw
 W9j9xPKyaxFe+rHlrciVwt6r4pSUsImyX4oShUBwBUKfzdwa3PtCxdlivQHHgxnr1s88igeTk
 ltoLe9G6j7OfB/U9kIZ1bC9vY1Jv7QiUbyU+CoXfLvfSAVL1hQNALVEZKWUVcDY9lmmqYC+bI
 KUsWym+uE6rUJrpP6flOxG/FL0/hZVIhw8f/jA7b3z/IVGIZCMsv0TlBxzK4YfFXfpTHsned2
 0DjhSe1CJPUnS7Tkvz/E4DWm8SBYEY4ILkttHBwK6dCfes4HE4a92bNVP73VpQ2FqG3Fj4cA8
 nSJJ4eeS7ydV6gk4X5DHbdg3hO1UlUylD27sChLz1yHLfSc5M1Iwi+iUqsSjuksAyOnLo1OQn
 i66/ddEE9cNsQ/nSke5/pjtATQeLFgeNsn02i2XyT/q/IlWw75arVf33QMYMHQcXVmX0aip15
 Jn9DO1Bh6G+J1i8PnSsSYqcjegAZoLNwtK+YgjOCkHw+jykc+QwRAuKPHo95apr5d25lEO8Sy
 hpodZXUyoC/8VVeVrnYThKFFfGJTE+0EOya/IyMAHuGmpeP8DpYsRNg+eSkWkT03oSSgEUzUz
 H6VsxHdDX0ey64=
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 54399
Cc: Ignacio Casso <ignaciocasso@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> a104f656c8 Make defvar affect the default binding outside of any let.
> Stefan Monnier <monnier@HIDDEN> Fri Aug 2 17:16:33 2013 -0400

And AFAIU this commit also fixed the problem for variables that are not
user options.  Now you can create a local special variable like this:

(defvar variable)
(let ((variable ...))
  (require ...) ...)

That has the desired effect (of binding variable dynamically) but any

(defvar variable ...)

form evaluated when loading still makes the VARIABLE special and sets
the global value.  Right?

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 18 Mar 2022 00:22:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 17 20:22:49 2022
Received: from localhost ([127.0.0.1]:55687 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nV0OG-0002IX-V2
	for submit <at> debbugs.gnu.org; Thu, 17 Mar 2022 20:22:49 -0400
Received: from mout.web.de ([212.227.15.14]:49997)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1nV0OF-0002II-1G
 for 54399 <at> debbugs.gnu.org; Thu, 17 Mar 2022 20:22:47 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1647562958;
 bh=kgKKT1Br68lHvGRfwBxf04L9jbZHAcqnUsChcOHKts4=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=siiSrNfl/aNP9dLfITbUkyxAPwqN0I4eDN8+iJwDlLs+cVKiBUzAwYEP+12bT9pWH
 rt9GdqG2t6u89oa/wxEOuEPJr7kmzLWMlgcj37mxvGSbnQ1J8qozJwMN0IgW/OUFix
 Lt9YhaEF+L8Yg7HchQ2LRVYrG51A5394y6EmTJ2U=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.60.174.212]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MREzA-1njDr80thE-00NOn1; Fri, 18
 Mar 2022 01:22:38 +0100
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 <87sfrgu8ju.fsf@HIDDEN>
Date: Fri, 18 Mar 2022 01:22:37 +0100
In-Reply-To: <87sfrgu8ju.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 17 Mar 2022 12:23:33 +0100")
Message-ID: <875yocm7n6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:3KUGnkt4nceRW3QdrotgwiGrJ+1jCOsSxoOE9aSKLB8P0n7MI83
 /4TCjTIwBvWLGhYqH2LQJbCpAwnWo3fkQHtsUGm17Q7YUhRur4+VCeTTBADjp9V7bvHAHHA
 BdIY28xETxpLh5NrYlhrs3nou6tSA2A2XJK+LwX89KWPecUIchr1dgAI7gQS3uIugA+DNcj
 rso3UIS9na/fboG7OV+uQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:9yWF0WDpPAw=:oRvKzIXa5H/kONyA7njkru
 kdEXg/Hfml8e/pn7Grq1fX9o6U4AGeuv0vkKcuUgDd71+OL98EZVhrFRWIERn8L66sv6ZuhnD
 qanHLfOaI5c4Y+JK0xN4SGmXkU7QXz4i96b/C5khCRCLO4avQRAFVWpr8Xpbnp27D0DJKaan9
 eUKymg5RKnCeF6EprSS9B8esNHcsxWFuSt4su4iWT6fLgDY7xnSXhWJNfEg5P+2y6IMwyiOUJ
 hKPdL+qez2qCTuuEkROnr5gQoIX/vQFr9rx4+kkGyiKJvlJgpRllSKMGk0e8IOAYQyKl2zp+E
 tn7fJdnp8nzBTvXAk19/mJTq2S0IEfOl9t/TkbLrAc21b8V/7Z8zSv5FQ9wMHRnGcp3vtIkSV
 E520YTAymKv8bmwJNQCckK1quhhndGY1sTPSZgdNwc/Y43eYL86G5eeMbDSXyMQJmBlMkhX4l
 FJ13b7edA2Vqi/lK7AmYpG1PclcF+AND+Om488CPdpILTIzgNgUjHUWzYu5ePejgqj/8Tbt0k
 RNbxSheXIeOArGZybNcOFxsNFeKFW8wJ77WT6ijWym358/C3QZC1DicwF2va7fbQsXMf9v3DW
 vrHJt0TLiWo4AynwhNsQ26KnIZvw0MwY7XWyM0YqQ0Ci2wLWgg6tg2bv+r+HDnITz7QadiqNk
 7y/7JwhmK7cKIzrzGVOD6BGb5mfWLZTIcFy5ZovUfo/eJogMWIM5tZGvOAe6cVanLlC3N6XfE
 uKNRiRwu7FbhfR+OlXAo3woP+IkQGi6Gc0lEAjZHGCnkoHAZVuQTszMZKfYNKAsReqtZUKQIo
 XmpPa/+5r8kBCYaoS50zwQ8RDIFOnU7T0oL9rs4RrnrKP+aYcgIZIdkvxheHMW6t7Q91EOOMe
 c7j3ppPOsYcfsl2MbijXUwy7igyGq6FDN5HL8HCQ22EBQ4XpLZ4Xn+DA0Xn03kcOg0ZsYGWVZ
 g4+VzhKxyQBchpZig2noEyzrr/ucwUJ3xV2Cce2ymX8haN1HQ0aS9mCsbEBshpV2nQ0vdiJAx
 V8BTO05O1Im4tz8qSGLCxCGBAQnDxMDNrQt3V4HlCFqhxhoMpqfNCBUobx1uFb2MPImKXUwoZ
 Zmx+hYG8cuiCFI=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 54399
Cc: Ignacio Casso <ignaciocasso@HIDDEN>, 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Ignacio Casso <ignaciocasso@HIDDEN> writes:
>
> > Calling an autoload function under the following circumstances does not
> > always work as expected:
> >
> >   - the function uses a variable defined with defcustom in the same file
> >     as the function.
> >
> >   - the function is called inside a let form that binds that same
> >     variable.
>
> I don't think this is supported?  And it's not just with user options --
> normal variables will end up being unbound if you do this (unless this
> has been changed since I looked at this a decade ago).  And I think it's
> documented, too?  Or am I misremembering?  Anybody?

Hmm - I don't know much about the background, but wasn't
`set-default-toplevel-value' invented to make just that work?  See
commit

a104f656c8 Make defvar affect the default binding outside of any let.
Stefan Monnier <monnier@HIDDEN> Fri Aug 2 17:16:33 2013 -0400

AFAIU this bug report is a request to (1) correct some docstrings and
(2) use `set-default-toplevel-value' instead of `set-default' at more
places in custom.el to assign values, where appropriate.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 54399 <at> debbugs.gnu.org:


Received: (at 54399) by debbugs.gnu.org; 17 Mar 2022 11:23:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Mar 17 07:23:44 2022
Received: from localhost ([127.0.0.1]:53208 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nUoEK-0002rf-0v
	for submit <at> debbugs.gnu.org; Thu, 17 Mar 2022 07:23:44 -0400
Received: from quimby.gnus.org ([95.216.78.240]:47044)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nUoEH-0002rM-QS
 for 54399 <at> debbugs.gnu.org; Thu, 17 Mar 2022 07:23:42 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=Uqh6lB9lwV6evIw0kBGYdFa8ImlHOpEGd1IDfJGb2+w=; b=JVxdlJryFp0u5dQBTllAJQw03g
 uTdPHj2zPxq4XXoTGCuu/ofvtm7Cm1zryaPv80w0bOiQmtT9QnFFNKzJD3S7YoB5tXWUAMJ7f0ghq
 2QyBcQtGn5k3jSNMwOmotSjDtmLo2j1ALB82vdxSYLUU/7qWq3Y8XDbJOeQIvGP0/A3I=;
Received: from 109.179.236.69.tmi.telenormobil.no ([109.179.236.69] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nUoEA-0006cz-6Y; Thu, 17 Mar 2022 12:23:36 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Ignacio Casso <ignaciocasso@HIDDEN>
Subject: Re: bug#54399: 27.2; Problems with (let ((custom-variable ...))
 (autoload-function ...))
References: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
Date: Thu, 17 Mar 2022 12:23:33 +0100
In-Reply-To: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
 (Ignacio Casso's message of "Tue, 15 Mar 2022 12:50:05 +0100")
Message-ID: <87sfrgu8ju.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Ignacio Casso <ignaciocasso@HIDDEN> writes: > Calling
 an autoload function under the following circumstances does not > always
 work as expected: > > - the function uses a variable defined with defcustom
 in the same file > as the function. > > - [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 0.0 TVD_RCVD_IP            Message was received from an IP address
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 54399
Cc: 54399 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Ignacio Casso <ignaciocasso@HIDDEN> writes:

> Calling an autoload function under the following circumstances does not
> always work as expected:
>
>   - the function uses a variable defined with defcustom in the same file
>     as the function.
>
>   - the function is called inside a let form that binds that same
>     variable.

I don't think this is supported?  And it's not just with user options --
normal variables will end up being unbound if you do this (unless this
has been changed since I looked at this a decade ago).  And I think it's
documented, too?  Or am I misremembering?  Anybody?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 Mar 2022 15:52:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Mar 15 11:52:03 2022
Received: from localhost ([127.0.0.1]:49388 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nU9Ss-0002do-PP
	for submit <at> debbugs.gnu.org; Tue, 15 Mar 2022 11:52:03 -0400
Received: from lists.gnu.org ([209.51.188.17]:52860)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ignaciocasso@HIDDEN>) id 1nU9Sq-0002dO-Rm
 for submit <at> debbugs.gnu.org; Tue, 15 Mar 2022 11:52:01 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45682)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ignaciocasso@HIDDEN>)
 id 1nU9Sq-0002TN-KS
 for bug-gnu-emacs@HIDDEN; Tue, 15 Mar 2022 11:52:00 -0400
Received: from mail-oln040092074058.outbound.protection.outlook.com
 ([40.92.74.58]:49778 helo=EUR04-DB3-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ignaciocasso@HIDDEN>)
 id 1nU9So-0004eu-5x
 for bug-gnu-emacs@HIDDEN; Tue, 15 Mar 2022 11:51:59 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=UhOsXjXpbISYev68UdVaahCFoRU2gqwlw3+n7fYG9VYyaHDsgXb1Qdcr1rO5lVFen0j1bMBmIPBreF8JiOQNN+odmoQsQuToqDMNenKghyg/ilhYX420duUl3c06BwK/IGRy0HfRFq/kO/YsLyYlrkkL9+IwcRzAIQb35Gb3l6owS0ob40df+p2XNAK7jQcggWwB5pr46dEu1A8iEKRzaddYUfmPIa9WJhk+H4hFL+XmGHb1NozuYLl2Gk21CST7txYyqdBn2HyLrnDRvdlYN2JA4ZiUUJAz+H3dAZvgQieovmtdyLUR/U3CrVpBDJBVOgBBn8vHqRBxpH8pAa8a2g==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=5NoWvherqUwjiMr02BwJjtjhFtNoGNeSHoAlk/PEtaA=;
 b=U930Sfim/2bZ4H6ZP4QYRgQEwrJcEQ7lKck/zU0/BL9olyQLx40M/3XAHNrD+IcMDsm4eEuAW6UbQ1ZeaoD+0v0gKLmJEw+lA8A+ug2J20k7Nv/7ZgA0ioa6WT7lc3jLQDjJtEFUoNDytWmBpNJKuJ2sva14YUrAAdbuLat5MVzOADf99kq/EXwke52/NhcEs5jxYL6qXwQs7auDGbxiS3wB5vcR9EH/jekSx5fLjMkDLx2RS+4FLjicDwT07cST30QDuL10TMIDZ0lrsdNrThxcBsZrBp/Fq3SxlacFZVZ7lvh8vc3+zWuVGU5/DVv4fPKXgonJoY10ax+WmFUMYQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=hotmail.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=5NoWvherqUwjiMr02BwJjtjhFtNoGNeSHoAlk/PEtaA=;
 b=btYDDuEwGUHJP8r7xZN0pYYG1zrA27FdiIoZaLzicoaqKpX5MknRPgsHPAqkT49Le6juuAyeIqyTgzBuN17GZzdw1mAocWmPKz63pAJEqVHlJkOD9FQtyhcDa7V2ohjtoSUgRzznjbnTBG7EBfoHsRiVc3bynQWwXOVuEnXClxKsPp5IK+N+apwGhwgvHB1RLsFPvPbiEZP9S2+HoZE9DkoOW7Bt8m68vvQDVjDjPJVJnXhRDESgH7jLTNrsHxVIJdZaht4vU/1xfkck20QdZGMjWfqCi2J78vHTm8mSV+h1bBGWghmf7ujtMIcpNBN+WUQYwdv1sGc3FauHvywmxg==
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com (2603:10a6:102:155::8)
 by DB7PR06MB4759.eurprd06.prod.outlook.com (2603:10a6:10:59::14) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5061.26; Tue, 15 Mar
 2022 15:31:26 +0000
Received: from PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::e05a:8d81:8648:b10f]) by PAXPR06MB7760.eurprd06.prod.outlook.com
 ([fe80::e05a:8d81:8648:b10f%9]) with mapi id 15.20.5061.028; Tue, 15 Mar 2022
 15:31:26 +0000
User-agent: mu4e 1.6.10; emacs 27.2
From: Ignacio Casso <ignaciocasso@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 27.2; Problems with (let ((custom-variable ...)) (autoload-function
 ...))
Date: Tue, 15 Mar 2022 12:50:05 +0100
Message-ID: <PAXPR06MB77608504A9705F55BD7FC456C6109@HIDDEN>
Content-Type: text/plain
X-TMN: [pSJjsx+pwHxukMt51Af/RD4O+pDdYK4+]
X-ClientProxiedBy: MR2P264CA0087.FRAP264.PROD.OUTLOOK.COM
 (2603:10a6:500:32::27) To PAXPR06MB7760.eurprd06.prod.outlook.com
 (2603:10a6:102:155::8)
X-Microsoft-Original-Message-ID: <87mthr1bcj.fsf@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 7e0b6364-35d8-43c7-093f-08da0698de2c
X-MS-TrafficTypeDiagnostic: DB7PR06MB4759:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: LUmK45UBbhXl7IBrjfUKn+TeNAs3xM/hjPXLkQZP+Icc4f0p0QtnAXWkxtTYUh72s18F9wngDX6ad8pYEyD5d0d+3CikrF/xD1eHCX+qA3XAoXplNc4wHv/XuRMsWWRh+UsA2lg+HkHpZrT46NkeweGsG6QF7zjvO4FyJPSbhDPTzJZjtGTyNkYJpjrrKgm/pv//QGWTlVM1nwlDQP+IGNT1eiz5C0dWkmnfwFwNqcM3zaU6vY9NKuIogtpK/PWBLSYWwYSu18fzaTVvQyRQ5xEi11yX9spBhzWwzsdusO6XZ7zubK9+7KoLVuO9Ywn7UgHouS+TKRsDSaqEeDwt9WTxtia/WQJb+q84VyEF62frmHcmaEWgBwFNP6609H7B4WvEJ7DYCJtKGOj9jSgUMbz3XgikhXtHqzp2mOj3eJiOwUWl4N7QJJVTCeKmrHucpqVX/cMjZRyOKbfKWSBAy8rjAIFHWfyh6up0HtLI1sxaB1ARGJ5kolkkLwiT0HUkg34GRyhi2umD0k5cgDdo1TmHbdM7TLNReapqcRO560SPeDOiRpF5ODDZFpGVSYUZXUXZ3QhQGsTti15CDoiFYqfjMvYR9KgODxoMuyWgIKjYRiAIFUIOMr0XwrHCxm8I
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?us-ascii?Q?CgJDNh4Qup+t0gzfn+orUSOpBSm9lF9h9cx+xaCfuhPk4S9jm89Vpr+IR498?=
 =?us-ascii?Q?cNHrZ+PmHn8IWG4zYvmjGyRbaqjLc+DyQ1N9mPlSgnIzmPjJgLVIQsGtEAoW?=
 =?us-ascii?Q?XcV+JfUhmr83ItvxWDSa/ZDguYu5BYB8NpSkdIyxUEyfrLm2FJfmksqbWDr5?=
 =?us-ascii?Q?3aoCofjaTKqkSj3RGp5UczDDqK9RhNQA2IRkoTbGBSBPlFNyywdA83qU06jO?=
 =?us-ascii?Q?fjt0CHMmcejxP6eoFwz7sxApUd2b1GG+IAacuQd6e1PyHQEuglKpZPYn8op/?=
 =?us-ascii?Q?clVeqk1pmy+bre/2ajA1aCdxuBVFlOrbXnxE4uSmC1uxzHvY4177crJheeMX?=
 =?us-ascii?Q?wVoDq6l+YvjYZL4BIUlwGfiteOwaOt9WpdxmnGkcomOmn6aKBvmECqjE1DOD?=
 =?us-ascii?Q?jJgGSoNo6r1a+6aKpnfyhaDJnqm8n+xZq8IxodRZ6AmTcHfFgMB82B6lmoWc?=
 =?us-ascii?Q?BWeszfHe6lHbU2a9tUqHAbkSgMgo0KrweptAN3E5E1U+r7GADWSEjBOQqHzI?=
 =?us-ascii?Q?y1QzTaNCAEbT43sZ4lrRIyanJuNMRFrS3GIRv/AFmBQeOjS9X+dB/fqJ8JKz?=
 =?us-ascii?Q?xXFYchC1JylAsu71Xpwe4PwOIf1O4uZxuuzveyOQLTf7EEzv6YOJll4VEJbO?=
 =?us-ascii?Q?YujwvRl26M9V2a4W7p8cEl9AdaTJCKkqlsMvynp6wpiDi0PcyNOh7vd2OjsA?=
 =?us-ascii?Q?oR6NC2A6rdn8d61QADMUIBSphvCU7bRmDrpVb4hz3d38AWfVgHHKr+ndF3A6?=
 =?us-ascii?Q?UPAQBNWLRf0sFlLhizr1XQSYSjeg/b9rzwlv1wzt54cZVoID30laWopj7wP7?=
 =?us-ascii?Q?NX/Py/smTRqEaQqrv3g9wKazuUU6Hirv+A1N0N9XZjCrVpq9oYAyLm1pTp/S?=
 =?us-ascii?Q?8tLjI009qrehIUvW+VkVnfvT/elQj5iP8BcLj1eI7NPI76AHZ0zeqS6ru70T?=
 =?us-ascii?Q?YPgHhaVsFvYBG3OKs3etpv5zvL3c360u0BLcRv/iW2fownQgHkXbJpfviuXK?=
 =?us-ascii?Q?COmVmLpMvKuDqs93ZkZ1iJlDJ9Lrw/t/hCIjyeNO3z67L4xgzg1oOeCzL5+m?=
 =?us-ascii?Q?hmtTu3rX0WH3qLAfUkkxeijNj+J3Nxl3V2q1/Pf0oIv37DCjnLVhDLU9SNJd?=
 =?us-ascii?Q?ui3CEs7j5FSAL3ebLw3H9Ji6Km8msMuwXQ=3D=3D?=
X-OriginatorOrg: sct-15-20-4755-11-msonline-outlook-6e454.templateTenant
X-MS-Exchange-CrossTenant-Network-Message-Id: 7e0b6364-35d8-43c7-093f-08da0698de2c
X-MS-Exchange-CrossTenant-AuthSource: PAXPR06MB7760.eurprd06.prod.outlook.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 15 Mar 2022 15:31:26.1225 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: DB7PR06MB4759
Received-SPF: pass client-ip=40.92.74.58;
 envelope-from=ignaciocasso@HIDDEN;
 helo=EUR04-DB3-obe.outbound.protection.outlook.com
X-Spam_score_int: -4
X-Spam_score: -0.5
X-Spam_bar: /
X-Spam_report: (-0.5 / 5.0 requ) BAYES_00=-1.9, DATE_IN_PAST_03_06=1.592,
 DKIM_SIGNED=0.1, DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 FREEMAIL_FROM=0.001, RCVD_IN_DNSWL_NONE=-0.0001, RCVD_IN_MSPIKE_H2=-0.001,
 SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hello, I reported this org-mode bug in
 https://lists.gnu.org/archive/html/emacs-orgmode/2022-03/msg00085.html, 
 but after some discussion we figured out that the issue is not particular
 to org-mode but generi [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.1 DATE_IN_PAST_03_06     Date: is 3 to 6 hours before Received: date
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (ignaciocasso[at]hotmail.com)
 0.0 RCVD_IN_MSPIKE_H5      RBL: Excellent reputation (+5)
 [209.51.188.17 listed in wl.mailspike.net]
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
 medium trust [209.51.188.17 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
 -0.0 T_SCC_BODY_TEXT_LINE   No description available.
 1.5 SPOOFED_FREEMAIL       No description available.
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

Hello,

I reported this org-mode bug in
https://lists.gnu.org/archive/html/emacs-orgmode/2022-03/msg00085.html,
but after some discussion we figured out that the issue is not
particular to org-mode but generic to all Emacs and decided to bring our
conclusions and questions  here. The problem is the following:

Calling an autoload function under the following circumstances does not
always work as expected:

  - the function uses a variable defined with defcustom in the same file
    as the function.

  - the function is called inside a let form that binds that same
    variable.

  - the file defining the function and the variable has not been loaded
    yet at the time the function is called, and the variable has not
    been set either.

I would expect to work exactly the same as if the file had already been
loaded. Instead, the following happens depending on the scoping and the
defcustom setter:

1) If the let form is evaluated with lexical-binding, and the variable
is not also autoloaded, Emacs does not know the variable is special by
the time it evaluates let, so it uses lexical binding. Later, when it
evaluates defcustom and it finds out that it is special and it should
have used dynamic binding, Emacs 29 produces the error (error "Defining
as dynamic an already lexical var"). Emacs 27 does not perform this
check and keeps going, and since it uses lexical binding, the let
binding has not effect at all inside the function as the user would
expect. The exact same thing happens also if the variable is defined
with defvar. I guess there is nothing that can be done about it
otherwise Emacs 29 would have done so instead of throwing an error. The
following form reproduces this behavior (please ensure to evaluate it
with lexical binding):

(progn

  (defun my-load ()
    (defvar my-var 1)
    (message "Value while loading: %s" my-var))

  (defun my-var-alias () my-var)

  (let ((my-var 2))
    (my-load)
    (message "Lexical value inside let: %s" my-var)
    (message "Dynamic value inside let: %s" (my-var-alias)))
  (message "Value ouside let: %s" my-var))


2) If the let form is evaluated with dynamic binding, or the variable
has also an autoload cookie so Emacs already knows is dynamic, then the
behavior depends on the :set argument of defcustom:

2.1) If no explicit argument is passed, then defcustom uses as default
set-default-toplevel-value. In that case everything works as
expected. Note however that the documentation and comments says in many
places that the default :set argument is just set-default instead of
set-default-toplevel-value.

2.2) If the :set argument is set or set-default (the suggested default
choice in the documentation), that function is called with arguments the
variable symbol and the standard value passed as argument to defcustom.
But those functions only affect the scope of the let binding, which
means that a) they overwrite the let binding, which is not what the user
expect, and b) when the evaluation of the let form finish the variable
is void. Thus, any further use of that variable or functions that use it
will produce a void variable error. And this is not trivial to fix:
requiring the feature again will do nothing since it's already provided,
so the user needs to finds it's definition and evaluate defvar/defcustom
again himself, or restart Emacs. The following form reproduces this
behavior (please ensure to evaluate it with dynamic binding):

(progn

  (defun my-load ()
    (defcustom my-other-var 1 "Test variable" :set 'set-default)
    (message "Value while loading: %s" my-other-var))

  (let ((my-other-var 2))
    (my-load)
    (message "Value inside let: %s" (my-other-var-alias)))
  (message "Value ouside let: %s" my-other-var))


I think that something should be done about point 2.2. Some suggestions
are:

- A warning when defcustom of a variable is called inside a let binding
  of that same variable.

- Update documentation of defcustom to say that the default choice of
  the :set argument is set-default-toplevel-value

- Document default-value, default-boundp, and set-default to say that
  they may not work as the user expects when called inside a let binding
  with dynamic binding enabled. The snippets below show how I expected
  them to work (please evaluate them with dynamic binding):

  (let ((fresh-var 1))
    (default-value 'fresh-var)) ;; I expect and error, it returns 1

  (let ((another-fresh-var 1))
    (default-boundp 'another-fresh-var)) ;; I expect nil, it returns t

  (defvar yet-another-fresh-var 1)
  (let ((yet-another-fresh-var 2))
    (set-default 'yet-another-fresh-var 3)
    yet-another-fresh-var) ;; I expect 2, it returns 3
  yet-another-fresh-var ;; I expect 3, it returns 1


What do you think?




Acknowledgement sent to Ignacio Casso <ignaciocasso@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#54399; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 12 May 2022 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.